"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RemoveAddButton = exports.PassageButton = exports.ConfimationDialog = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styles = require("@material-ui/core/styles");

var _core = require("@material-ui/core");

var _RemoveCircle = _interopRequireDefault(require("@material-ui/icons/RemoveCircle"));

var _AddCircle = _interopRequireDefault(require("@material-ui/icons/AddCircle"));

var _Dialog = _interopRequireDefault(require("@material-ui/core/Dialog"));

var _DialogTitle = _interopRequireDefault(require("@material-ui/core/DialogTitle"));

var _DialogContent = _interopRequireDefault(require("@material-ui/core/DialogContent"));

var _DialogContentText = _interopRequireDefault(require("@material-ui/core/DialogContentText"));

var _DialogActions = _interopRequireDefault(require("@material-ui/core/DialogActions"));

var RemoveAddButton = function RemoveAddButton(_ref) {
  var classes = _ref.classes,
      label = _ref.label,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'add' : _ref$type,
      onClick = _ref.onClick;
  var Tag = type === 'add' ? _AddCircle["default"] : _RemoveCircle["default"];
  return /*#__PURE__*/_react["default"].createElement(_core.Button, {
    color: "primary",
    size: "small",
    className: classes.root,
    onClick: onClick
  }, /*#__PURE__*/_react["default"].createElement(Tag, {
    fontSize: 'small',
    color: 'primary',
    className: classes.icon
  }), label);
};

exports.RemoveAddButton = RemoveAddButton;
var PassageButton = (0, _styles.withStyles)(function (theme) {
  return {
    root: {
      textDecoration: 'underline',
      '&:hover': {
        textDecoration: 'underline',
        backgroundColor: 'transparent'
      }
    },
    label: {
      display: 'flex',
      alignItems: 'center'
    },
    icon: {
      marginRight: theme.spacing.unit / 2
    }
  };
})(RemoveAddButton);
exports.PassageButton = PassageButton;

var ConfimationDialog = function ConfimationDialog(_ref2) {
  var content = _ref2.content,
      cancel = _ref2.cancel,
      title = _ref2.title,
      ok = _ref2.ok,
      open = _ref2.open,
      onOk = _ref2.onOk,
      onCancel = _ref2.onCancel;
  return /*#__PURE__*/_react["default"].createElement(_Dialog["default"], {
    open: open
  }, /*#__PURE__*/_react["default"].createElement(_DialogTitle["default"], null, title), /*#__PURE__*/_react["default"].createElement(_DialogContent["default"], null, /*#__PURE__*/_react["default"].createElement(_DialogContentText["default"], null, content)), /*#__PURE__*/_react["default"].createElement(_DialogActions["default"], null, onOk && /*#__PURE__*/_react["default"].createElement(_core.Button, {
    onClick: onOk,
    color: "primary"
  }, ok), onCancel && /*#__PURE__*/_react["default"].createElement(_core.Button, {
    onClick: onCancel,
    color: "primary"
  }, cancel)));
};

exports.ConfimationDialog = ConfimationDialog;
ConfimationDialog.propTypes = {
  content: _propTypes["default"].string.isRequired,
  title: _propTypes["default"].string.isRequired,
  cancel: _propTypes["default"].string.isRequired,
  ok: _propTypes["default"].string.isRequired,
  open: _propTypes["default"].bool.isRequired,
  onCancel: _propTypes["default"].func.isRequired,
  onOk: _propTypes["default"].func.isRequired
};
//# sourceMappingURL=common.js.map