"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Main = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _configUi = require("@pie-lib/pie-toolbox/config-ui");

var _styles = require("@material-ui/core/styles");

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _common = require("./common");

var _passage = _interopRequireDefault(require("./passage"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Panel = _configUi.settings.Panel,
    toggle = _configUi.settings.toggle,
    dropdown = _configUi.settings.dropdown;

var Main = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Main, _React$Component);

  var _super = _createSuper(Main);

  function Main(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, Main);
    _this = _super.call(this, props);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getInnerText", function (html) {
      return (html || '').replaceAll(/<[^>]*>/g, '');
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onDelete", function (model, indexToRemove, onModelChanged) {
      var updatedPassages = model.passages;
      updatedPassages.splice(indexToRemove, 1);
      onModelChanged(_objectSpread(_objectSpread({}, model), {}, {
        passages: updatedPassages
      }));

      _this.setState({
        showConfirmationDialog: false,
        indexToRemove: -1
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "removeAdditionalPassage", function (indexToRemove) {
      var _this$props = _this.props,
          _this$props$model = _this$props.model,
          model = _this$props$model === void 0 ? {} : _this$props$model,
          onModelChanged = _this$props.onModelChanged;
      var _model$passages = model.passages,
          passages = _model$passages === void 0 ? [] : _model$passages;
      var _passages$indexToRemo = passages[indexToRemove],
          _passages$indexToRemo2 = _passages$indexToRemo.teacherInstructions,
          teacherInstructions = _passages$indexToRemo2 === void 0 ? '' : _passages$indexToRemo2,
          _passages$indexToRemo3 = _passages$indexToRemo.title,
          title = _passages$indexToRemo3 === void 0 ? '' : _passages$indexToRemo3,
          _passages$indexToRemo4 = _passages$indexToRemo.subtitle,
          subtitle = _passages$indexToRemo4 === void 0 ? '' : _passages$indexToRemo4,
          _passages$indexToRemo5 = _passages$indexToRemo.author,
          author = _passages$indexToRemo5 === void 0 ? '' : _passages$indexToRemo5,
          _passages$indexToRemo6 = _passages$indexToRemo.text,
          text = _passages$indexToRemo6 === void 0 ? '' : _passages$indexToRemo6;

      if (_this.getInnerText(teacherInstructions).trim() || _this.getInnerText(title).trim() || _this.getInnerText(subtitle).trim() || _this.getInnerText(author).trim() || _this.getInnerText(text).trim()) {
        _this.setState({
          showConfirmationDialog: true,
          indexToRemove: indexToRemove
        });
      } else {
        _this.onDelete(model, indexToRemove, onModelChanged);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "addAdditionalPassage", function () {
      var _this$props2 = _this.props,
          model = _this$props2.model,
          onModelChanged = _this$props2.onModelChanged;
      var updatedPassages = [].concat((0, _toConsumableArray2["default"])(model.passages), [{
        teacherInstructions: '',
        title: '',
        subtitle: '',
        author: '',
        text: ''
      }]);
      onModelChanged(_objectSpread(_objectSpread({}, model), {}, {
        passages: updatedPassages
      }));
    });
    _this.state = {
      showConfirmationDialog: false,
      indexToRemove: -1
    };
    return _this;
  }

  (0, _createClass2["default"])(Main, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          classes = _this$props3.classes,
          model = _this$props3.model,
          configuration = _this$props3.configuration,
          imageSupport = _this$props3.imageSupport,
          onConfigurationChanged = _this$props3.onConfigurationChanged,
          onModelChanged = _this$props3.onModelChanged,
          uploadSoundSupport = _this$props3.uploadSoundSupport;

      var _ref = configuration || {},
          settingsPanelDisabled = _ref.settingsPanelDisabled,
          _ref$language = _ref.language,
          language = _ref$language === void 0 ? {} : _ref$language,
          _ref$languageChoices = _ref.languageChoices,
          languageChoices = _ref$languageChoices === void 0 ? {} : _ref$languageChoices,
          _ref$teacherInstructi = _ref.teacherInstructions,
          teacherInstructions = _ref$teacherInstructi === void 0 ? {} : _ref$teacherInstructi,
          _ref$title = _ref.title,
          title = _ref$title === void 0 ? {} : _ref$title,
          _ref$subtitle = _ref.subtitle,
          subtitle = _ref$subtitle === void 0 ? {} : _ref$subtitle,
          _ref$text = _ref.text,
          text = _ref$text === void 0 ? {} : _ref$text,
          _ref$author = _ref.author,
          author = _ref$author === void 0 ? {} : _ref$author,
          _ref$additionalPassag = _ref.additionalPassage,
          additionalPassage = _ref$additionalPassag === void 0 ? {} : _ref$additionalPassag;

      var _ref2 = model || {},
          extraCSSRules = _ref2.extraCSSRules,
          passages = _ref2.passages;

      var panelSettings = {
        titleEnabled: title && title.settings && toggle(title.label),
        subtitleEnabled: subtitle && subtitle.settings && toggle(subtitle.label),
        authorEnabled: author && author.settings && toggle(author.label),
        textEnabled: text && text.settings && toggle(text.label),
        'additionalPassage.enabled': additionalPassage && additionalPassage.settings && toggle(additionalPassage.label, true)
      };
      var panelProperties = {
        teacherInstructionsEnabled: teacherInstructions && teacherInstructions.settings && toggle(teacherInstructions.label),
        'language.enabled': language && language.settings && toggle(language.label, true),
        language: language && language.settings && language.enabled && dropdown(languageChoices.label, languageChoices.options)
      };
      var confirmationDialogContent = "".concat(additionalPassage.label, " will be deleted");
      var _this$state = this.state,
          indexToRemove = _this$state.indexToRemove,
          showConfirmationDialog = _this$state.showConfirmationDialog;
      return /*#__PURE__*/_react["default"].createElement(_configUi.layout.ConfigLayout, {
        extraCSSRules: extraCSSRules,
        hideSettings: settingsPanelDisabled,
        settings: /*#__PURE__*/_react["default"].createElement(Panel, {
          model: model,
          configuration: configuration,
          onChangeModel: function onChangeModel(model) {
            return onModelChanged(model);
          },
          onChangeConfiguration: function onChangeConfiguration(config) {
            return onConfigurationChanged(config);
          },
          groups: {
            Settings: panelSettings,
            Properties: panelProperties
          }
        })
      }, passages.map(function (passage, passageIndex) {
        return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
          key: passageIndex
        }, passageIndex > 0 && /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
          variant: "h5",
          className: classes.additionalPassageHeading
        }, additionalPassage.label), /*#__PURE__*/_react["default"].createElement(_passage["default"], {
          imageSupport: imageSupport,
          uploadSoundSupport: uploadSoundSupport,
          model: model,
          configuration: configuration,
          passageIndex: passageIndex,
          onModelChanged: onModelChanged
        }), passageIndex > 0 && additionalPassage.enabled && /*#__PURE__*/_react["default"].createElement(_common.PassageButton, {
          type: 'remove',
          label: "Remove ".concat(additionalPassage.label),
          onClick: function onClick() {
            return _this2.removeAdditionalPassage(passageIndex);
          }
        }), passageIndex === 0 && additionalPassage.enabled && passages.length < 2 && /*#__PURE__*/_react["default"].createElement(_common.PassageButton, {
          label: "Add ".concat(additionalPassage.label),
          onClick: _this2.addAdditionalPassage
        }));
      }), /*#__PURE__*/_react["default"].createElement(_common.ConfimationDialog, {
        open: showConfirmationDialog,
        title: 'Warning',
        content: confirmationDialogContent,
        cancel: 'Cancel',
        ok: 'Ok',
        onCancel: function onCancel() {
          return _this2.setState({
            showConfirmationDialog: false
          });
        },
        onOk: function onOk() {
          return _this2.onDelete(model, indexToRemove, onModelChanged);
        }
      }));
    }
  }]);
  return Main;
}(_react["default"].Component);

exports.Main = Main;
(0, _defineProperty2["default"])(Main, "propTypes", {
  onModelChanged: _propTypes["default"].func.isRequired,
  onConfigurationChanged: _propTypes["default"].func,
  model: _propTypes["default"].object.isRequired,
  configuration: _propTypes["default"].object.isRequired,
  imageSupport: _propTypes["default"].object.isRequired,
  uploadSoundSupport: _propTypes["default"].object.isRequired,
  classes: _propTypes["default"].object.isRequired
});

var _default = (0, _styles.withStyles)(function (theme) {
  return {
    additionalPassageHeading: {
      paddingTop: theme.spacing.unit * 2,
      marginBottom: theme.spacing.unit * 2
    }
  };
})(Main);

exports["default"] = _default;
//# sourceMappingURL=design.js.map