"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.PassageComponent = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styles = require("@material-ui/core/styles");

var _configUi = require("@pie-lib/pie-toolbox/config-ui");

var _editableHtml = require("@pie-lib/pie-toolbox/editable-html");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var PassageComponent = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(PassageComponent, _React$Component);

  var _super = _createSuper(PassageComponent);

  function PassageComponent(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, PassageComponent);
    _this = _super.call(this, props);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (fieldName, value) {
      var _this$props = _this.props,
          model = _this$props.model,
          onModelChanged = _this$props.onModelChanged,
          passageIndex = _this$props.passageIndex;

      if (!model.passages || passageIndex < 0 || passageIndex >= model.passages.length) {
        return;
      }

      var updatedPassages = (0, _toConsumableArray2["default"])(model.passages);
      updatedPassages[passageIndex] = _objectSpread(_objectSpread({}, updatedPassages[passageIndex]), {}, (0, _defineProperty2["default"])({}, fieldName, value));
      onModelChanged(_objectSpread(_objectSpread({}, model), {}, {
        passages: updatedPassages
      }));
    });
    return _this;
  }

  (0, _createClass2["default"])(PassageComponent, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          model = _this$props2.model,
          classes = _this$props2.classes,
          configuration = _this$props2.configuration,
          imageSupport = _this$props2.imageSupport,
          passageIndex = _this$props2.passageIndex,
          uploadSoundSupport = _this$props2.uploadSoundSupport;

      var _ref = configuration || {},
          _ref$maxImageWidth = _ref.maxImageWidth,
          maxImageWidth = _ref$maxImageWidth === void 0 ? {} : _ref$maxImageWidth,
          _ref$maxImageHeight = _ref.maxImageHeight,
          maxImageHeight = _ref$maxImageHeight === void 0 ? {} : _ref$maxImageHeight,
          _ref$mathMlOptions = _ref.mathMlOptions,
          mathMlOptions = _ref$mathMlOptions === void 0 ? {} : _ref$mathMlOptions,
          _ref$baseInputConfigu = _ref.baseInputConfiguration,
          baseInputConfiguration = _ref$baseInputConfigu === void 0 ? {} : _ref$baseInputConfigu,
          _ref$teacherInstructi = _ref.teacherInstructions,
          teacherInstructions = _ref$teacherInstructi === void 0 ? {} : _ref$teacherInstructi,
          _ref$title = _ref.title,
          title = _ref$title === void 0 ? {} : _ref$title,
          _ref$subtitle = _ref.subtitle,
          subtitle = _ref$subtitle === void 0 ? {} : _ref$subtitle,
          _ref$text = _ref.text,
          text = _ref$text === void 0 ? {} : _ref$text,
          _ref$author = _ref.author,
          author = _ref$author === void 0 ? {} : _ref$author;

      var _ref2 = model || {},
          _ref2$errors = _ref2.errors,
          errors = _ref2$errors === void 0 ? {} : _ref2$errors,
          _ref2$passages = _ref2.passages,
          passages = _ref2$passages === void 0 ? [] : _ref2$passages,
          teacherInstructionsEnabled = _ref2.teacherInstructionsEnabled,
          titleEnabled = _ref2.titleEnabled,
          subtitleEnabled = _ref2.subtitleEnabled,
          authorEnabled = _ref2.authorEnabled,
          textEnabled = _ref2.textEnabled;

      var _ref3 = errors || {},
          passagesErrors = _ref3.passages;

      var _ref4 = passagesErrors && passagesErrors[passageIndex] || {},
          teacherInstructionsError = _ref4.teacherInstructions,
          titleError = _ref4.title,
          subtitleError = _ref4.subtitle,
          authorError = _ref4.author,
          textError = _ref4.text;

      var defaultImageMaxWidth = maxImageWidth && maxImageWidth.prompt;
      var defaultImageMaxHeight = maxImageHeight && maxImageHeight.prompt;

      var getPluginProps = function getPluginProps(customConfiguration) {
        return _objectSpread(_objectSpread({}, baseInputConfiguration), customConfiguration);
      };

      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, teacherInstructionsEnabled && /*#__PURE__*/_react["default"].createElement(_configUi.InputContainer, {
        label: teacherInstructions.label,
        className: classes.inputContainer
      }, /*#__PURE__*/_react["default"].createElement(_editableHtml.EditableHtml, {
        activePlugins: _editableHtml.ALL_PLUGINS,
        markup: passages[passageIndex].teacherInstructions || '',
        onChange: function onChange(value) {
          return _this2.handleChange('teacherInstructions', value);
        },
        nonEmpty: false,
        error: teacherInstructionsError,
        maxImageWidth: maxImageWidth && maxImageWidth.teacherInstructions || defaultImageMaxWidth,
        maxImageHeight: maxImageHeight && maxImageHeight.teacherInstructions || defaultImageMaxHeight,
        mathMlOptions: mathMlOptions,
        languageCharactersProps: [{
          language: 'spanish'
        }, {
          language: 'special'
        }],
        pluginProps: getPluginProps(teacherInstructions === null || teacherInstructions === void 0 ? void 0 : teacherInstructions.inputConfiguration)
      }), teacherInstructionsError && /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.errorText
      }, teacherInstructionsError)), titleEnabled && /*#__PURE__*/_react["default"].createElement(_configUi.InputContainer, {
        label: title.label,
        className: classes.inputContainer
      }, /*#__PURE__*/_react["default"].createElement(_editableHtml.EditableHtml, {
        activePlugins: _editableHtml.ALL_PLUGINS,
        markup: passages[passageIndex].title || '',
        onChange: function onChange(value) {
          return _this2.handleChange('title', value);
        },
        nonEmpty: false,
        error: titleError,
        mathMlOptions: mathMlOptions,
        languageCharactersProps: [{
          language: 'spanish'
        }, {
          language: 'special'
        }],
        pluginProps: getPluginProps(title === null || title === void 0 ? void 0 : title.inputConfiguration)
      }), titleError && /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.errorText
      }, titleError)), subtitleEnabled && /*#__PURE__*/_react["default"].createElement(_configUi.InputContainer, {
        label: subtitle.label,
        className: classes.inputContainer
      }, /*#__PURE__*/_react["default"].createElement(_editableHtml.EditableHtml, {
        activePlugins: _editableHtml.ALL_PLUGINS,
        markup: passages[passageIndex].subtitle || '',
        onChange: function onChange(value) {
          return _this2.handleChange('subtitle', value);
        },
        nonEmpty: false,
        error: subtitleError,
        mathMlOptions: mathMlOptions,
        languageCharactersProps: [{
          language: 'spanish'
        }, {
          language: 'special'
        }],
        pluginProps: getPluginProps(subtitle === null || subtitle === void 0 ? void 0 : subtitle.inputConfiguration)
      }), subtitleError && /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.errorText
      }, subtitleError)), authorEnabled && /*#__PURE__*/_react["default"].createElement(_configUi.InputContainer, {
        label: author.label,
        className: classes.inputContainer
      }, /*#__PURE__*/_react["default"].createElement(_editableHtml.EditableHtml, {
        activePlugins: _editableHtml.ALL_PLUGINS,
        markup: passages[passageIndex].author || '',
        onChange: function onChange(value) {
          return _this2.handleChange('author', value);
        },
        nonEmpty: false,
        error: authorError,
        mathMlOptions: mathMlOptions,
        languageCharactersProps: [{
          language: 'spanish'
        }, {
          language: 'special'
        }],
        pluginProps: getPluginProps(author === null || author === void 0 ? void 0 : author.inputConfiguration)
      }), authorError && /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.errorText
      }, authorError)), textEnabled && /*#__PURE__*/_react["default"].createElement(_configUi.InputContainer, {
        label: text.label,
        className: classes.inputContainer
      }, /*#__PURE__*/_react["default"].createElement(_editableHtml.EditableHtml, {
        activePlugins: _editableHtml.ALL_PLUGINS,
        markup: passages[passageIndex].text || '',
        onChange: function onChange(value) {
          return _this2.handleChange('text', value);
        },
        imageSupport: imageSupport,
        uploadSoundSupport: uploadSoundSupport,
        nonEmpty: false,
        error: textError,
        maxImageWidth: maxImageWidth && maxImageWidth.text || defaultImageMaxWidth,
        maxImageHeight: maxImageHeight && maxImageHeight.text || defaultImageMaxHeight,
        mathMlOptions: mathMlOptions,
        languageCharactersProps: [{
          language: 'spanish'
        }, {
          language: 'special'
        }],
        pluginProps: getPluginProps(text === null || text === void 0 ? void 0 : text.inputConfiguration)
      }), textError && /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.errorText
      }, textError)));
    }
  }]);
  return PassageComponent;
}(_react["default"].Component);

exports.PassageComponent = PassageComponent;
(0, _defineProperty2["default"])(PassageComponent, "propTypes", {
  classes: _propTypes["default"].object,
  onModelChanged: _propTypes["default"].func.isRequired,
  model: _propTypes["default"].object.isRequired,
  configuration: _propTypes["default"].object.isRequired,
  imageSupport: _propTypes["default"].object.isRequired,
  passageIndex: _propTypes["default"].number.isRequired,
  uploadSoundSupport: _propTypes["default"].object.isRequired
});
(0, _defineProperty2["default"])(PassageComponent, "defaultProps", {
  passageIndex: 0
});

var _default = (0, _styles.withStyles)(function (theme) {
  return {
    inputContainer: {
      paddingTop: theme.spacing.unit * 2,
      marginBottom: theme.spacing.unit * 2,
      width: '100%'
    },
    errorText: {
      fontSize: theme.typography.fontSize - 2,
      color: theme.palette.error.main,
      paddingTop: theme.spacing.unit
    }
  };
})(PassageComponent);

exports["default"] = _default;
//# sourceMappingURL=passage.js.map