"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _wrapNativeSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/wrapNativeSuper"));

var _piePlayerEvents = require("@pie-framework/pie-player-events");

var _mathRendering = require("@pie-lib/pie-toolbox/math-rendering");

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _stimulusTabs = _interopRequireDefault(require("./stimulus-tabs"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var PiePassage = /*#__PURE__*/function (_HTMLElement) {
  (0, _inherits2["default"])(PiePassage, _HTMLElement);

  var _super = _createSuper(PiePassage);

  function PiePassage() {
    var _this;

    (0, _classCallCheck2["default"])(this, PiePassage);
    _this = _super.call(this);
    _this._model = {
      passages: []
    };
    _this._session = null;
    return _this;
  }

  (0, _createClass2["default"])(PiePassage, [{
    key: "setLangAttribute",
    value: function setLangAttribute() {
      var language = this._model && (0, _typeof2["default"])(this._model.language) ? this._model.language : '';
      var lang = language ? language.slice(0, 2) : 'en';
      this.setAttribute('lang', lang);
    }
  }, {
    key: "model",
    set: function set(s) {
      this._model = s;
      this.dispatchEvent(new _piePlayerEvents.ModelSetEvent(this.tagName.toLowerCase(), this._session, !!this._model));
      this.setLangAttribute();

      this._render();
    }
  }, {
    key: "session",
    set: function set(s) {
      this._session = s;
    }
  }, {
    key: "connectedCallback",
    value: function connectedCallback() {
      this.setAttribute('aria-label', 'Passage');
      this.setAttribute('role', 'region');

      this._render();
    }
  }, {
    key: "_render",
    value: function _render() {
      var _this2 = this;

      var _this$_model$passages = this._model.passages,
          passages = _this$_model$passages === void 0 ? [] : _this$_model$passages;

      if (this._model.passages.length > 0) {
        var passagesTabs = passages.map(function (passage, index) {
          return _objectSpread({
            id: index
          }, passage);
        });

        var elem = /*#__PURE__*/_react["default"].createElement(_stimulusTabs["default"], {
          tabs: passagesTabs
        });

        _reactDom["default"].render(elem, this, function () {
          return (0, _mathRendering.renderMath)(_this2);
        });
      }
    }
  }]);
  return PiePassage;
}( /*#__PURE__*/(0, _wrapNativeSuper2["default"])(HTMLElement));

exports["default"] = PiePassage;
//# sourceMappingURL=index.js.map