"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _wrapNativeSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/wrapNativeSuper"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _debounce = _interopRequireDefault(require("lodash/debounce"));

var _debug = _interopRequireDefault(require("debug"));

var _stimulusTabs = _interopRequireDefault(require("./stimulus-tabs"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var log = (0, _debug["default"])('pie-element:passage:print');

var checkNullish = function checkNullish(value) {
  return value !== null && value !== undefined;
};

var isEnabled = function isEnabled(value, defaultValue) {
  return checkNullish(value) ? value : defaultValue;
};

var preparePrintPassage = function preparePrintPassage(model, opts) {
  var isInstructor = opts.role === 'instructor'; // TODO: also update '../../configure/src/defaults.js' and '../../controller/src/defaults.js' when updating defaultValue

  var teacherInstructionsEnabled = isEnabled(model.teacherInstructionsEnabled, true);
  var titleEnabled = isEnabled(model.titleEnabled, true);
  var authorEnabled = isEnabled(model.authorEnabled, false);
  var subtitleEnabled = isEnabled(model.subtitleEnabled, true);
  var textEnabled = isEnabled(model.textEnabled, true);
  return model.passages.map(function (passage, index) {
    return {
      id: index,
      teacherInstructions: isEnabled(passage.teacherInstructionsEnabled, teacherInstructionsEnabled) ? isInstructor && passage.teacherInstructions || '' : '',
      label: passage.title || "Passage ".concat(index + 1),
      title: isEnabled(passage.titleEnabled, titleEnabled) ? passage.title || '' : '',
      author: isEnabled(passage.authorEnabled, authorEnabled) ? passage.author || '' : '',
      subtitle: isEnabled(passage.subtitleEnabled, subtitleEnabled) ? passage.subtitle || '' : '',
      text: isEnabled(passage.textEnabled, textEnabled) ? passage.text || '' : ''
    };
  });
};

var PassagePrint = /*#__PURE__*/function (_HTMLElement) {
  (0, _inherits2["default"])(PassagePrint, _HTMLElement);

  var _super = _createSuper(PassagePrint);

  function PassagePrint() {
    var _this;

    (0, _classCallCheck2["default"])(this, PassagePrint);
    _this = _super.call(this);
    _this._model = null;
    _this._options = null;
    _this._session = [];
    _this._rerender = (0, _debounce["default"])(function () {
      if (_this._model && _this._session) {
        if (_this._model.passages && _this._model.passages.length > 0) {
          var printPassage = preparePrintPassage(_this._model, _this._options);

          var element = /*#__PURE__*/_react["default"].createElement(_stimulusTabs["default"], {
            disabledTabs: true,
            tabs: printPassage
          });

          _reactDom["default"].render(element, (0, _assertThisInitialized2["default"])(_this));
        }
      } else {
        log('skip');
      }
    }, 50, {
      leading: false,
      trailing: true
    });
    return _this;
  }

  (0, _createClass2["default"])(PassagePrint, [{
    key: "model",
    set: function set(s) {
      this._model = s;

      this._rerender();
    }
  }, {
    key: "options",
    set: function set(o) {
      this._options = o;
    }
  }, {
    key: "connectedCallback",
    value: function connectedCallback() {}
  }]);
  return PassagePrint;
}( /*#__PURE__*/(0, _wrapNativeSuper2["default"])(HTMLElement));

exports["default"] = PassagePrint;
//# sourceMappingURL=print.js.map