"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Tabs = _interopRequireDefault(require("@material-ui/core/Tabs"));

var _Tab = _interopRequireDefault(require("@material-ui/core/Tab"));

var _styles = require("@material-ui/core/styles");

var _renderUi = require("@pie-lib/pie-toolbox/render-ui");

var _classnames = _interopRequireDefault(require("classnames"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var styles = function styles(theme) {
  return {
    passages: {
      flexGrow: 1,
      backgroundColor: _renderUi.color.background(),
      color: _renderUi.color.text(),
      '&:not(.MathJax) table': {
        borderCollapse: 'collapse'
      },
      '&:not(.MathJax) table td, &:not(.MathJax) table th': {
        padding: '.6em 1em',
        textAlign: 'left'
      }
    },
    passage: {
      backgroundColor: _renderUi.color.background(),
      color: _renderUi.color.text(),
      padding: theme.spacing.unit * 2
    },
    passageTitle: {
      fontSize: '1.75rem'
    },
    passageSubtitle: {
      fontSize: '1.5rem'
    },
    passageAuthor: {
      fontSize: '1.25rem'
    },
    passageText: {},
    stickyTabs: {
      background: _renderUi.color.background(),
      position: 'sticky',
      top: 0
    },
    tab: {
      background: theme.palette.common.white,
      // replace with color.background() once PD-2801 is DONE
      fontSize: 'inherit',
      color: theme.palette.common.black // remove when PD-2801 is DONE

    },
    tabButton: {
      background: theme.palette.common.white // replace with color.background() once PD-2801 is DONE

    },
    teacherInstructions: {
      marginBottom: theme.spacing.unit * 2
    }
  };
};

var StimulusTabs = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(StimulusTabs, _React$Component);

  var _super = _createSuper(StimulusTabs);

  function StimulusTabs() {
    var _this;

    (0, _classCallCheck2["default"])(this, StimulusTabs);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      activeTab: 0
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (event, activeTab) {
      _this.setState(function () {
        return {
          activeTab: activeTab
        };
      });

      setTimeout(function () {
        var tabChangeEvent = new CustomEvent('pie-ui-passage-tabChanged', {
          detail: {
            tab: activeTab
          }
        });
        window.dispatchEvent(tabChangeEvent);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleKeyDown", function (event, currentTabId) {
      var key = event.key;
      var tabs = _this.props.tabs;
      var newTabIndex = -1;
      var currentIndex = tabs.findIndex(function (tab) {
        return tab.id === currentTabId;
      });

      switch (key) {
        case 'ArrowRight':
          // Move to the next tab
          newTabIndex = (currentIndex + 1) % tabs.length;
          break;

        case 'ArrowLeft':
          // Move to the previous tab
          newTabIndex = (currentIndex - 1 + tabs.length) % tabs.length;
          break;
        // Commented out ArrowDown and ArrowUp for future vertical tab navigation
        // case 'ArrowDown':
        //   // Move to the next tab (for vertical alignment)
        //   newTabIndex = (currentIndex + 1) % tabs.length;
        //   break;
        // case 'ArrowUp':
        //   // Move to the previous tab (for vertical alignment)
        //   newTabIndex = (currentIndex - 1 + tabs.length) % tabs.length;
        //   break;

        case 'Home':
          // Move to the first tab
          newTabIndex = 0;
          break;

        case 'End':
          // Move to the last tab
          newTabIndex = tabs.length - 1;
          break;

        case 'Enter':
        case ' ':
          // Activate the current tab
          newTabIndex = currentIndex;
          break;

        default:
          break;
      }

      if (newTabIndex !== -1) {
        event.preventDefault();

        _this.handleChange(event, tabs[newTabIndex].id);

        document.getElementById("button-".concat(tabs[newTabIndex].id)).focus();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "parsedText", function () {
      var text = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
      // fix imported audio content for Safari PD-1391
      var div = document.createElement('div');
      div.innerHTML = text.replace(/(<br\/>\n)/g, '<br/>');
      var audio = div.querySelector('audio');

      if (audio) {
        var source = document.createElement('source');
        source.setAttribute('type', 'audio/mp3');
        source.setAttribute('src', audio.getAttribute('src'));
        audio.removeAttribute('src');
        audio.appendChild(source);
      }

      return div.innerHTML;
    });
    return _this;
  }

  (0, _createClass2["default"])(StimulusTabs, [{
    key: "renderInstructions",
    value: function renderInstructions(teacherInstructions) {
      var disabledTabs = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (!teacherInstructions) {
        return;
      }

      var teacherInstructionsDiv = /*#__PURE__*/_react["default"].createElement(_renderUi.PreviewPrompt, {
        tagName: "div",
        className: "prompt",
        defaultClassName: "teacher-instructions",
        prompt: teacherInstructions
      });

      if (disabledTabs) {
        return teacherInstructionsDiv;
      }

      return /*#__PURE__*/_react["default"].createElement(_renderUi.Collapsible, {
        labels: {
          hidden: 'Show Teacher Instructions',
          visible: 'Hide Teacher Instructions'
        }
      }, teacherInstructionsDiv);
    }
  }, {
    key: "renderTab",
    value: function renderTab(tab, disabledTabs) {
      var classes = this.props.classes;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(classes.passage, 'passage'),
        key: tab.id,
        id: "tabpanel-".concat(tab.id),
        role: "tabpanel",
        "aria-labelledby": "button-".concat(tab.id)
      }, this.renderInstructions(tab.teacherInstructions, disabledTabs), (tab.title || tab.subtitle) && /*#__PURE__*/_react["default"].createElement("h2", null, tab.title && /*#__PURE__*/_react["default"].createElement(_renderUi.Purpose, {
        purpose: "passage-title"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(classes.passageTitle, 'title'),
        dangerouslySetInnerHTML: {
          __html: this.parsedText(tab.title)
        }
      })), tab.subtitle && /*#__PURE__*/_react["default"].createElement(_renderUi.Purpose, {
        purpose: "passage-subtitle"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(classes.passageSubtitle, 'subtitle'),
        dangerouslySetInnerHTML: {
          __html: this.parsedText(tab.subtitle)
        }
      }))), tab.author && /*#__PURE__*/_react["default"].createElement(_renderUi.Purpose, {
        purpose: "passage-author"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(classes.passageAuthor, 'author'),
        dangerouslySetInnerHTML: {
          __html: this.parsedText(tab.author)
        }
      })), tab.text && /*#__PURE__*/_react["default"].createElement(_renderUi.Purpose, {
        purpose: "passage-text"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        key: tab.id,
        className: (0, _classnames["default"])(classes.passageText, 'text'),
        dangerouslySetInnerHTML: {
          __html: this.parsedText(tab.text)
        }
      })));
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          classes = _this$props.classes,
          model = _this$props.model,
          tabs = _this$props.tabs,
          disabledTabs = _this$props.disabledTabs;
      var activeTab = this.state.activeTab;

      if (!(tabs !== null && tabs !== void 0 && tabs.length)) {
        return;
      }

      var _ref = model || {},
          extraCSSRules = _ref.extraCSSRules;

      var selectedTab = (tabs || []).find(function (tab) {
        return tab.id === activeTab;
      });
      return /*#__PURE__*/_react["default"].createElement(_renderUi.UiLayout, {
        extraCSSRules: extraCSSRules,
        className: (0, _classnames["default"])(classes.passages, 'passages')
      }, disabledTabs || tabs.length === 1 ? tabs.map(function (tab) {
        return _this2.renderTab(tab, disabledTabs);
      }) : /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Tabs["default"], {
        classes: {
          root: classes.stickyTabs,
          flexContainer: classes.tabButton
        },
        value: activeTab,
        onChange: this.handleChange
      }, tabs.map(function (tab) {
        return /*#__PURE__*/_react["default"].createElement(_Tab["default"], {
          className: classes.tab,
          key: tab.id,
          id: "button-".concat(tab.id),
          label: /*#__PURE__*/_react["default"].createElement(_renderUi.Purpose, {
            purpose: "passage-label"
          }, /*#__PURE__*/_react["default"].createElement("span", {
            dangerouslySetInnerHTML: {
              __html: _this2.parsedText(tab.label)
            }
          })),
          value: tab.id,
          tabIndex: activeTab === tab.id ? 0 : -1,
          "aria-controls": "tabpanel-".concat(tab.id),
          "aria-selected": activeTab === tab.id,
          onFocus: function onFocus() {
            return _this2.handleChange(null, tab.id);
          },
          onKeyDown: function onKeyDown(event) {
            return _this2.handleKeyDown(event, tab.id);
          }
        });
      })), selectedTab ? this.renderTab(selectedTab, disabledTabs) : null));
    }
  }]);
  return StimulusTabs;
}(_react["default"].Component);

StimulusTabs.propTypes = {
  classes: _propTypes["default"].object.isRequired,
  tabs: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    id: _propTypes["default"].number.isRequired,
    label: _propTypes["default"].string.isRequired,
    title: _propTypes["default"].string.isRequired,
    subtitle: _propTypes["default"].string,
    author: _propTypes["default"].string,
    text: _propTypes["default"].string.isRequired,
    teacherInstructions: _propTypes["default"].string
  }).isRequired).isRequired,
  disabledTabs: _propTypes["default"].bool
};

var _default = (0, _styles.withStyles)(styles)(StimulusTabs);

exports["default"] = _default;
//# sourceMappingURL=stimulus-tabs.js.map