import Configure from './configure.js';
import Element from './element.js';
import * as controller from './controller.js';

var generate = {};

generate.model = (id, element) => ({
  id,
  element,
  passages: [
    {
      teacherInstructions: 'Teacher instructions for first tab',
      title: 'Hope Is the Thing with Feathers',
      subtitle: 'from <em>The Complete Poems of Emily Dickinson</em>',
      author: 'by Emily Dickinson',
      text: '<p><font style="visibility:hidden">00000</font>Hope is the thing with feathers<br /><font style="visibility:hidden">00000</font>That perches in the soul,<br /><font style="visibility:hidden">00000</font>And sings the tune without the words,<br /><font style="visibility:hidden">00000</font>And never stops at all,</p><p>5<font style="visibility:hidden">0000</font>And sweetest in the gale is heard;<br /><font style="visibility:hidden">00000</font>And sore must be the storm<br /><font style="visibility:hidden">00000</font>That could abash the little bird<br /><font style="visibility:hidden">00000</font>That kept so many warm.</p><p><font style="visibility:hidden">00000</font>I&#8217;ve heard it in the chillest land,<br />10<font style="visibility:hidden">000</font>And on the strangest sea;<br /><font style="visibility:hidden">00000</font>Yet, never, in extremity,<br /><font style="visibility:hidden">00000</font>It asked a crumb of me.</p>',
    },
    {
      title: 'Ineskeen Road, July Evening',
      text: `The bicycles go by in twos and threes -<br/>
        There's a dance in Billy Brennan's barn tonight,<br/>
        And there's the half-talk code of mysteries<br/>
        And the wink-and-elbow language of delight.<br/>
        Half-past eight and there is not a spot<br/>
        Upon a mile of road, no shadow thrown<br/>
        That might turn out a man or woman, not<br/>
        A footfall tapping secrecies of stone. <br/>
        <p/>
        I have what every poet hates in spite<br/>
        Of all the solemn talk of contemplation.<br/>
        Oh, Alexander Selkirk knew the plight<br/>
        Of being king and government and nation.<br/>
        A road, a mile of kingdom. I am king<br/>
        Of banks and stones and every blooming thing.<br/>
        `,
    },
  ],
});

const { model } = generate;

var config = {
  elements: {
    'passage-element': '../..',
  },
  models: [model('1', 'passage-element')],
};

//Note: demo-el is a custom element loaded in the markup.
  customElements.whenDefined("demo-el").then(() => {
    config.models.forEach((m) => {
      const de = document.createElement("demo-el");
      document.body.appendChild(de);
      de.def = { tagName: m.element, Element, Configure, controller };
      de.model = m;
    });
  });
