import PrintElement from './print.js';

var generate = {};

generate.model = (id, element) => ({
  id,
  element,
  passages: [
    {
      teacherInstructions: 'Teacher instructions for first tab',
      title: 'Hope Is the Thing with Feathers',
      subtitle: 'from <em>The Complete Poems of Emily Dickinson</em>',
      author: 'by Emily Dickinson',
      text: '<p><font style="visibility:hidden">00000</font>Hope is the thing with feathers<br /><font style="visibility:hidden">00000</font>That perches in the soul,<br /><font style="visibility:hidden">00000</font>And sings the tune without the words,<br /><font style="visibility:hidden">00000</font>And never stops at all,</p><p>5<font style="visibility:hidden">0000</font>And sweetest in the gale is heard;<br /><font style="visibility:hidden">00000</font>And sore must be the storm<br /><font style="visibility:hidden">00000</font>That could abash the little bird<br /><font style="visibility:hidden">00000</font>That kept so many warm.</p><p><font style="visibility:hidden">00000</font>I&#8217;ve heard it in the chillest land,<br />10<font style="visibility:hidden">000</font>And on the strangest sea;<br /><font style="visibility:hidden">00000</font>Yet, never, in extremity,<br /><font style="visibility:hidden">00000</font>It asked a crumb of me.</p>',
    },
    {
      title: 'Ineskeen Road, July Evening',
      text: `The bicycles go by in twos and threes -<br/>
        There's a dance in Billy Brennan's barn tonight,<br/>
        And there's the half-talk code of mysteries<br/>
        And the wink-and-elbow language of delight.<br/>
        Half-past eight and there is not a spot<br/>
        Upon a mile of road, no shadow thrown<br/>
        That might turn out a man or woman, not<br/>
        A footfall tapping secrecies of stone. <br/>
        <p/>
        I have what every poet hates in spite<br/>
        Of all the solemn talk of contemplation.<br/>
        Oh, Alexander Selkirk knew the plight<br/>
        Of being king and government and nation.<br/>
        A road, a mile of kingdom. I am king<br/>
        Of banks and stones and every blooming thing.<br/>
        `,
    },
  ],
});

const { model } = generate;

var config = {
  elements: {
    'passage-element': '../..',
  },
  models: [model('1', 'passage-element')],
};

// new init - just shows off print!

const init = async () => {
  console.log('define the element...');
  await Promise.all(
    config.models.map(async (m) => {
      try {
        const printTag = `${m.element}-print`;
        if (customElements.get(printTag)) {
          return true;
        } else {
          customElements.define(printTag, PrintElement);
          await customElements.whenDefined(printTag);
          return true;
        }
      } catch (e) {
        return false;
      }
    })
  );

  console.log('now apply the model...');
  config.models.forEach((m) => {
    const printTag = `${m.element}-print`;
    const h3s = document.createElement('h3');
    h3s.textContent = 'student mode';
    document.body.appendChild(h3s);
    const de = document.createElement(printTag);
    document.body.appendChild(de);
    de.options = {};
    de.model = m;

    const h3 = document.createElement('h3');
    h3.textContent = 'instructor mode';
    document.body.appendChild(h3);
    const instr = document.createElement(printTag);
    document.body.appendChild(instr);
    instr.options = { mode: 'instructor' };
    instr.model = JSON.parse(JSON.stringify(m));
  });
};

init()
  .then(() => {
    console.log('ready');
  })
  .catch((e) => {
    console.error(e);
  });
