import {_dll_react, _dll_prop_types, _dll_classnames, _dll_react_dom} from "../../../@pie-lib/pie-toolbox-math-rendering-module@4.1.5/module/index.js";
import {_dll_pie_lib__pie_toolbox_config_ui, _dll_pie_lib__pie_toolbox_editable_html} from "../../../@pie-lib/pie-toolbox-module@7.0.4/module/index.js";
var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};
function getDefaultExportFromCjs(x) {
  return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}
function getAugmentedNamespace(n) {
  if (n.__esModule) return n;
  var a = Object.defineProperty({}, '__esModule', {
    value: true
  });
  Object.keys(n).forEach(function (k) {
    var d = Object.getOwnPropertyDescriptor(n, k);
    Object.defineProperty(a, k, d.get ? d : {
      enumerable: true,
      get: function () {
        return n[k];
      }
    });
  });
  return a;
}
var lib$8 = {};
Object.defineProperty(lib$8, "__esModule", {
  value: true
});
class ModelUpdatedEvent extends CustomEvent {
  constructor(update, reset = false) {
    super(ModelUpdatedEvent.TYPE, {
      bubbles: true,
      detail: {
        update,
        reset
      }
    });
    this.update = update;
    this.reset = reset;
  }
}
ModelUpdatedEvent.TYPE = 'model.updated';
var ModelUpdatedEvent_1 = lib$8.ModelUpdatedEvent = ModelUpdatedEvent;
class DeleteImageEvent extends CustomEvent {
  constructor(src, done) {
    super(DeleteImageEvent.TYPE, {
      bubbles: true,
      detail: {
        src,
        done
      }
    });
    this.src = src;
    this.done = done;
  }
}
DeleteImageEvent.TYPE = 'delete.image';
var DeleteImageEvent_1 = lib$8.DeleteImageEvent = DeleteImageEvent;
class InsertImageEvent extends CustomEvent {
  constructor(handler) {
    super(InsertImageEvent.TYPE, {
      bubbles: true,
      detail: handler
    });
    this.handler = handler;
  }
}
InsertImageEvent.TYPE = 'insert.image';
var InsertImageEvent_1 = lib$8.InsertImageEvent = InsertImageEvent;
class DeleteSoundEvent extends CustomEvent {
  constructor(src, done) {
    super(DeleteSoundEvent.TYPE, {
      bubbles: true,
      detail: {
        src,
        done
      }
    });
    this.src = src;
    this.done = done;
  }
}
DeleteSoundEvent.TYPE = 'delete.sound';
var DeleteSoundEvent_1 = lib$8.DeleteSoundEvent = DeleteSoundEvent;
class InsertSoundEvent extends CustomEvent {
  constructor(handler) {
    super(InsertSoundEvent.TYPE, {
      bubbles: true,
      detail: handler
    });
    this.handler = handler;
  }
}
InsertSoundEvent.TYPE = 'insert.sound';
var InsertSoundEvent_1 = lib$8.InsertSoundEvent = InsertSoundEvent;
var styles$e = {};
var interopRequireDefault = {
  exports: {}
};
(function (module) {
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      "default": obj
    };
  }
  (module.exports = _interopRequireDefault, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(interopRequireDefault);
getDefaultExportFromCjs(interopRequireDefault.exports);
var createGenerateClassName$2 = {};
var warning$2 = function () {};
{
  var printWarning = function printWarning(format, args) {
    var len = arguments.length;
    args = new Array(len > 1 ? len - 1 : 0);
    for (var key = 1; key < len; key++) {
      args[key - 1] = arguments[key];
    }
    var argIndex = 0;
    var message = 'Warning: ' + format.replace(/%s/g, function () {
      return args[argIndex++];
    });
    if (typeof console !== 'undefined') {
      console.error(message);
    }
    try {
      throw new Error(message);
    } catch (x) {}
  };
  warning$2 = function (condition, format, args) {
    var len = arguments.length;
    args = new Array(len > 2 ? len - 2 : 0);
    for (var key = 2; key < len; key++) {
      args[key - 2] = arguments[key];
    }
    if (format === undefined) {
      throw new Error('`warning(condition, format, ...args)` requires a warning ' + 'message argument');
    }
    if (!condition) {
      printWarning.apply(null, [format].concat(args));
    }
  };
}
var warning_1 = warning$2;
var _interopRequireDefault$Q = interopRequireDefault.exports;
Object.defineProperty(createGenerateClassName$2, "__esModule", {
  value: true
});
createGenerateClassName$2.default = createGenerateClassName$1;
var _warning$e = _interopRequireDefault$Q(warning_1);
var escapeRegex = /([[\].#*$><+~=|^:(),"'`\s])/g;
function safePrefix(classNamePrefix) {
  var prefix = String(classNamePrefix);
  (0, _warning$e.default)(prefix.length < 256, ("Material-UI: the class name prefix is too long: ").concat(prefix, "."));
  return prefix.replace(escapeRegex, '-');
}
function createGenerateClassName$1() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var _options$dangerouslyU = options.dangerouslyUseGlobalCSS, dangerouslyUseGlobalCSS = _options$dangerouslyU === void 0 ? false : _options$dangerouslyU;
  options.productionPrefix;
  var _options$seed = options.seed, seed = _options$seed === void 0 ? '' : _options$seed;
  var ruleCounter = 0;
  return function (rule, styleSheet) {
    ruleCounter += 1;
    (0, _warning$e.default)(ruleCounter < 1e10, ['Material-UI: you might have a memory leak.', 'The ruleCounter is not supposed to grow that much.'].join(''));
    if (dangerouslyUseGlobalCSS && styleSheet && styleSheet.options.name) {
      return ("").concat(safePrefix(styleSheet.options.name), "-").concat(rule.key);
    }
    if (styleSheet && styleSheet.options.classNamePrefix) {
      return ("").concat(safePrefix(styleSheet.options.classNamePrefix), "-").concat(rule.key, "-").concat(seed).concat(ruleCounter);
    }
    return ("").concat(rule.key, "-").concat(seed).concat(ruleCounter);
  };
}
var createMuiTheme$1 = {};
var defineProperty$1 = {
  exports: {}
};
(function (module) {
  function _defineProperty(obj, key, value) {
    if ((key in obj)) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }
    return obj;
  }
  (module.exports = _defineProperty, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(defineProperty$1);
getDefaultExportFromCjs(defineProperty$1.exports);
var _extends$1 = {
  exports: {}
};
(function (module) {
  function _extends() {
    (module.exports = _extends = Object.assign || (function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];
        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }
      return target;
    }), module.exports.__esModule = true, module.exports["default"] = module.exports);
    return _extends.apply(this, arguments);
  }
  (module.exports = _extends, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(_extends$1);
getDefaultExportFromCjs(_extends$1.exports);
var objectWithoutProperties = {
  exports: {}
};
var objectWithoutPropertiesLoose = {
  exports: {}
};
(function (module) {
  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }
    return target;
  }
  (module.exports = _objectWithoutPropertiesLoose, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(objectWithoutPropertiesLoose);
getDefaultExportFromCjs(objectWithoutPropertiesLoose.exports);
(function (module) {
  var objectWithoutPropertiesLoose$1 = objectWithoutPropertiesLoose.exports;
  function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};
    var target = objectWithoutPropertiesLoose$1(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }
    return target;
  }
  (module.exports = _objectWithoutProperties, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(objectWithoutProperties);
getDefaultExportFromCjs(objectWithoutProperties.exports);
var umd = {
  exports: {}
};
(function (module, exports) {
  (function (global, factory) {
    module.exports = factory();
  })(commonjsGlobal, function () {
    var isMergeableObject = function isMergeableObject(value) {
      return isNonNullObject(value) && !isSpecial(value);
    };
    function isNonNullObject(value) {
      return !!value && typeof value === 'object';
    }
    function isSpecial(value) {
      var stringValue = Object.prototype.toString.call(value);
      return stringValue === '[object RegExp]' || stringValue === '[object Date]' || isReactElement(value);
    }
    var canUseSymbol = typeof Symbol === 'function' && Symbol.for;
    var REACT_ELEMENT_TYPE = canUseSymbol ? Symbol.for('react.element') : 0xeac7;
    function isReactElement(value) {
      return value.$$typeof === REACT_ELEMENT_TYPE;
    }
    function emptyTarget(val) {
      return Array.isArray(val) ? [] : {};
    }
    function cloneUnlessOtherwiseSpecified(value, options) {
      return options.clone !== false && options.isMergeableObject(value) ? deepmerge(emptyTarget(value), value, options) : value;
    }
    function defaultArrayMerge(target, source, options) {
      return target.concat(source).map(function (element) {
        return cloneUnlessOtherwiseSpecified(element, options);
      });
    }
    function getMergeFunction(key, options) {
      if (!options.customMerge) {
        return deepmerge;
      }
      var customMerge = options.customMerge(key);
      return typeof customMerge === 'function' ? customMerge : deepmerge;
    }
    function getEnumerableOwnPropertySymbols(target) {
      return Object.getOwnPropertySymbols ? Object.getOwnPropertySymbols(target).filter(function (symbol) {
        return target.propertyIsEnumerable(symbol);
      }) : [];
    }
    function getKeys(target) {
      return Object.keys(target).concat(getEnumerableOwnPropertySymbols(target));
    }
    function mergeObject(target, source, options) {
      var destination = {};
      if (options.isMergeableObject(target)) {
        getKeys(target).forEach(function (key) {
          destination[key] = cloneUnlessOtherwiseSpecified(target[key], options);
        });
      }
      getKeys(source).forEach(function (key) {
        if (!options.isMergeableObject(source[key]) || !target[key]) {
          destination[key] = cloneUnlessOtherwiseSpecified(source[key], options);
        } else {
          destination[key] = getMergeFunction(key, options)(target[key], source[key], options);
        }
      });
      return destination;
    }
    function deepmerge(target, source, options) {
      options = options || ({});
      options.arrayMerge = options.arrayMerge || defaultArrayMerge;
      options.isMergeableObject = options.isMergeableObject || isMergeableObject;
      var sourceIsArray = Array.isArray(source);
      var targetIsArray = Array.isArray(target);
      var sourceAndTargetTypesMatch = sourceIsArray === targetIsArray;
      if (!sourceAndTargetTypesMatch) {
        return cloneUnlessOtherwiseSpecified(source, options);
      } else if (sourceIsArray) {
        return options.arrayMerge(target, source, options);
      } else {
        return mergeObject(target, source, options);
      }
    }
    deepmerge.all = function deepmergeAll(array, options) {
      if (!Array.isArray(array)) {
        throw new Error('first argument should be an array');
      }
      return array.reduce(function (prev, next) {
        return deepmerge(prev, next, options);
      }, {});
    };
    var deepmerge_1 = deepmerge;
    return deepmerge_1;
  });
})(umd);
var isobject = function isObject(val) {
  return val != null && typeof val === 'object' && Array.isArray(val) === false;
};
var isObject = isobject;
function isObjectObject(o) {
  return isObject(o) === true && Object.prototype.toString.call(o) === '[object Object]';
}
var isPlainObject = function isPlainObject(o) {
  var ctor, prot;
  if (isObjectObject(o) === false) return false;
  ctor = o.constructor;
  if (typeof ctor !== 'function') return false;
  prot = ctor.prototype;
  if (isObjectObject(prot) === false) return false;
  if (prot.hasOwnProperty('isPrototypeOf') === false) {
    return false;
  }
  return true;
};
var createBreakpoints$1 = {};
var _interopRequireDefault$P = interopRequireDefault.exports;
Object.defineProperty(createBreakpoints$1, "__esModule", {
  value: true
});
createBreakpoints$1.default = createBreakpoints;
createBreakpoints$1.keys = void 0;
var _extends2$m = _interopRequireDefault$P(_extends$1.exports);
var _objectWithoutProperties2$k = _interopRequireDefault$P(objectWithoutProperties.exports);
var keys = ['xs', 'sm', 'md', 'lg', 'xl'];
createBreakpoints$1.keys = keys;
function createBreakpoints(breakpoints) {
  var _breakpoints$values = breakpoints.values, values = _breakpoints$values === void 0 ? {
    xs: 0,
    sm: 600,
    md: 960,
    lg: 1280,
    xl: 1920
  } : _breakpoints$values, _breakpoints$unit = breakpoints.unit, unit = _breakpoints$unit === void 0 ? 'px' : _breakpoints$unit, _breakpoints$step = breakpoints.step, step = _breakpoints$step === void 0 ? 5 : _breakpoints$step, other = (0, _objectWithoutProperties2$k.default)(breakpoints, ["values", "unit", "step"]);
  function up(key) {
    var value = typeof values[key] === 'number' ? values[key] : key;
    return ("@media (min-width:").concat(value).concat(unit, ")");
  }
  function down(key) {
    var endIndex = keys.indexOf(key) + 1;
    var upperbound = values[keys[endIndex]];
    if (endIndex === keys.length) {
      return up('xs');
    }
    var value = typeof upperbound === 'number' && endIndex > 0 ? upperbound : key;
    return ("@media (max-width:").concat(value - step / 100).concat(unit, ")");
  }
  function between(start, end) {
    var endIndex = keys.indexOf(end) + 1;
    if (endIndex === keys.length) {
      return up(start);
    }
    return ("@media (min-width:").concat(values[start]).concat(unit, ") and ") + ("(max-width:").concat(values[keys[endIndex]] - step / 100).concat(unit, ")");
  }
  function only(key) {
    return between(key, key);
  }
  function width(key) {
    return values[key];
  }
  return (0, _extends2$m.default)({
    keys: keys,
    values: values,
    up: up,
    down: down,
    between: between,
    only: only,
    width: width
  }, other);
}
var createMixins$1 = {};
var _interopRequireDefault$O = interopRequireDefault.exports;
Object.defineProperty(createMixins$1, "__esModule", {
  value: true
});
createMixins$1.default = createMixins;
var _defineProperty2$e = _interopRequireDefault$O(defineProperty$1.exports);
var _extends3$2 = _interopRequireDefault$O(_extends$1.exports);
function createMixins(breakpoints, spacing, mixins) {
  var _toolbar;
  return (0, _extends3$2.default)({
    gutters: function gutters() {
      var styles = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      return (0, _extends3$2.default)({
        paddingLeft: spacing.unit * 2,
        paddingRight: spacing.unit * 2
      }, styles, (0, _defineProperty2$e.default)({}, breakpoints.up('sm'), (0, _extends3$2.default)({
        paddingLeft: spacing.unit * 3,
        paddingRight: spacing.unit * 3
      }, styles[breakpoints.up('sm')])));
    },
    toolbar: (_toolbar = {
      minHeight: 56
    }, (0, _defineProperty2$e.default)(_toolbar, ("").concat(breakpoints.up('xs'), " and (orientation: landscape)"), {
      minHeight: 48
    }), (0, _defineProperty2$e.default)(_toolbar, breakpoints.up('sm'), {
      minHeight: 64
    }), _toolbar)
  }, mixins);
}
var createPalette$1 = {};
var indigo$1 = {};
Object.defineProperty(indigo$1, "__esModule", {
  value: true
});
indigo$1.default = void 0;
var indigo = {
  50: '#e8eaf6',
  100: '#c5cae9',
  200: '#9fa8da',
  300: '#7986cb',
  400: '#5c6bc0',
  500: '#3f51b5',
  600: '#3949ab',
  700: '#303f9f',
  800: '#283593',
  900: '#1a237e',
  A100: '#8c9eff',
  A200: '#536dfe',
  A400: '#3d5afe',
  A700: '#304ffe'
};
var _default$X = indigo;
indigo$1.default = _default$X;
var pink$1 = {};
Object.defineProperty(pink$1, "__esModule", {
  value: true
});
pink$1.default = void 0;
var pink = {
  50: '#fce4ec',
  100: '#f8bbd0',
  200: '#f48fb1',
  300: '#f06292',
  400: '#ec407a',
  500: '#e91e63',
  600: '#d81b60',
  700: '#c2185b',
  800: '#ad1457',
  900: '#880e4f',
  A100: '#ff80ab',
  A200: '#ff4081',
  A400: '#f50057',
  A700: '#c51162'
};
var _default$W = pink;
pink$1.default = _default$W;
var grey$1 = {};
Object.defineProperty(grey$1, "__esModule", {
  value: true
});
grey$1.default = void 0;
var grey = {
  50: '#fafafa',
  100: '#f5f5f5',
  200: '#eeeeee',
  300: '#e0e0e0',
  400: '#bdbdbd',
  500: '#9e9e9e',
  600: '#757575',
  700: '#616161',
  800: '#424242',
  900: '#212121',
  A100: '#d5d5d5',
  A200: '#aaaaaa',
  A400: '#303030',
  A700: '#616161'
};
var _default$V = grey;
grey$1.default = _default$V;
var red$1 = {};
Object.defineProperty(red$1, "__esModule", {
  value: true
});
red$1.default = void 0;
var red = {
  50: '#ffebee',
  100: '#ffcdd2',
  200: '#ef9a9a',
  300: '#e57373',
  400: '#ef5350',
  500: '#f44336',
  600: '#e53935',
  700: '#d32f2f',
  800: '#c62828',
  900: '#b71c1c',
  A100: '#ff8a80',
  A200: '#ff5252',
  A400: '#ff1744',
  A700: '#d50000'
};
var _default$U = red;
red$1.default = _default$U;
var common$1 = {};
Object.defineProperty(common$1, "__esModule", {
  value: true
});
common$1.default = void 0;
var common = {
  black: '#000',
  white: '#fff'
};
var _default$T = common;
common$1.default = _default$T;
var colorManipulator = {};
var _interopRequireDefault$N = interopRequireDefault.exports;
Object.defineProperty(colorManipulator, "__esModule", {
  value: true
});
colorManipulator.convertHexToRGB = convertHexToRGB;
colorManipulator.rgbToHex = rgbToHex;
colorManipulator.decomposeColor = decomposeColor;
colorManipulator.recomposeColor = recomposeColor;
colorManipulator.getContrastRatio = getContrastRatio;
colorManipulator.getLuminance = getLuminance;
colorManipulator.emphasize = emphasize;
colorManipulator.fade = fade;
colorManipulator.darken = darken;
colorManipulator.lighten = lighten;
var _warning$d = _interopRequireDefault$N(warning_1);
function clamp(value) {
  var min = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  var max = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;
  (0, _warning$d.default)(value >= min && value <= max, ("Material-UI: the value provided ").concat(value, " is out of range [").concat(min, ", ").concat(max, "]."));
  if (value < min) {
    return min;
  }
  if (value > max) {
    return max;
  }
  return value;
}
function convertHexToRGB(color) {
  color = color.substr(1);
  var re = new RegExp((".{1,").concat(color.length / 3, "}"), 'g');
  var colors = color.match(re);
  if (colors && colors[0].length === 1) {
    colors = colors.map(function (n) {
      return n + n;
    });
  }
  return colors ? ("rgb(").concat(colors.map(function (n) {
    return parseInt(n, 16);
  }).join(', '), ")") : '';
}
function rgbToHex(color) {
  if (color.indexOf('#') === 0) {
    return color;
  }
  function intToHex(c) {
    var hex = c.toString(16);
    return hex.length === 1 ? ("0").concat(hex) : hex;
  }
  var _decomposeColor = decomposeColor(color), values = _decomposeColor.values;
  values = values.map(function (n) {
    return intToHex(n);
  });
  return ("#").concat(values.join(''));
}
function decomposeColor(color) {
  if (color.charAt(0) === '#') {
    return decomposeColor(convertHexToRGB(color));
  }
  var marker = color.indexOf('(');
  var type = color.substring(0, marker);
  var values = color.substring(marker + 1, color.length - 1).split(',');
  values = values.map(function (value) {
    return parseFloat(value);
  });
  {
    if (['rgb', 'rgba', 'hsl', 'hsla'].indexOf(type) === -1) {
      throw new Error([("Material-UI: unsupported `").concat(color, "` color."), 'We support the following formats: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla().'].join('\n'));
    }
  }
  return {
    type: type,
    values: values
  };
}
function recomposeColor(color) {
  var type = color.type;
  var values = color.values;
  if (type.indexOf('rgb') !== -1) {
    values = values.map(function (n, i) {
      return i < 3 ? parseInt(n, 10) : n;
    });
  }
  if (type.indexOf('hsl') !== -1) {
    values[1] = ("").concat(values[1], "%");
    values[2] = ("").concat(values[2], "%");
  }
  return ("").concat(color.type, "(").concat(values.join(', '), ")");
}
function getContrastRatio(foreground, background) {
  var lumA = getLuminance(foreground);
  var lumB = getLuminance(background);
  return (Math.max(lumA, lumB) + 0.05) / (Math.min(lumA, lumB) + 0.05);
}
function getLuminance(color) {
  var decomposedColor = decomposeColor(color);
  if (decomposedColor.type.indexOf('rgb') !== -1) {
    var rgb = decomposedColor.values.map(function (val) {
      val /= 255;
      return val <= 0.03928 ? val / 12.92 : Math.pow((val + 0.055) / 1.055, 2.4);
    });
    return Number((0.2126 * rgb[0] + 0.7152 * rgb[1] + 0.0722 * rgb[2]).toFixed(3));
  }
  return decomposedColor.values[2] / 100;
}
function emphasize(color) {
  var coefficient = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0.15;
  return getLuminance(color) > 0.5 ? darken(color, coefficient) : lighten(color, coefficient);
}
function fade(color, value) {
  (0, _warning$d.default)(color, ("Material-UI: missing color argument in fade(").concat(color, ", ").concat(value, ")."));
  if (!color) return color;
  color = decomposeColor(color);
  value = clamp(value);
  if (color.type === 'rgb' || color.type === 'hsl') {
    color.type += 'a';
  }
  color.values[3] = value;
  return recomposeColor(color);
}
function darken(color, coefficient) {
  (0, _warning$d.default)(color, ("Material-UI: missing color argument in darken(").concat(color, ", ").concat(coefficient, ")."));
  if (!color) return color;
  color = decomposeColor(color);
  coefficient = clamp(coefficient);
  if (color.type.indexOf('hsl') !== -1) {
    color.values[2] *= 1 - coefficient;
  } else if (color.type.indexOf('rgb') !== -1) {
    for (var i = 0; i < 3; i += 1) {
      color.values[i] *= 1 - coefficient;
    }
  }
  return recomposeColor(color);
}
function lighten(color, coefficient) {
  (0, _warning$d.default)(color, ("Material-UI: missing color argument in lighten(").concat(color, ", ").concat(coefficient, ")."));
  if (!color) return color;
  color = decomposeColor(color);
  coefficient = clamp(coefficient);
  if (color.type.indexOf('hsl') !== -1) {
    color.values[2] += (100 - color.values[2]) * coefficient;
  } else if (color.type.indexOf('rgb') !== -1) {
    for (var i = 0; i < 3; i += 1) {
      color.values[i] += (255 - color.values[i]) * coefficient;
    }
  }
  return recomposeColor(color);
}
var _interopRequireDefault$M = interopRequireDefault.exports;
Object.defineProperty(createPalette$1, "__esModule", {
  value: true
});
createPalette$1.default = createPalette;
createPalette$1.dark = createPalette$1.light = void 0;
var _extends2$l = _interopRequireDefault$M(_extends$1.exports);
var _objectWithoutProperties2$j = _interopRequireDefault$M(objectWithoutProperties.exports);
var _warning$c = _interopRequireDefault$M(warning_1);
var _deepmerge$3 = _interopRequireDefault$M(umd.exports);
var _indigo = _interopRequireDefault$M(indigo$1);
var _pink = _interopRequireDefault$M(pink$1);
var _grey = _interopRequireDefault$M(grey$1);
var _red = _interopRequireDefault$M(red$1);
var _common = _interopRequireDefault$M(common$1);
var _colorManipulator$1 = colorManipulator;
var light = {
  text: {
    primary: 'rgba(0, 0, 0, 0.87)',
    secondary: 'rgba(0, 0, 0, 0.54)',
    disabled: 'rgba(0, 0, 0, 0.38)',
    hint: 'rgba(0, 0, 0, 0.38)'
  },
  divider: 'rgba(0, 0, 0, 0.12)',
  background: {
    paper: _common.default.white,
    default: _grey.default[50]
  },
  action: {
    active: 'rgba(0, 0, 0, 0.54)',
    hover: 'rgba(0, 0, 0, 0.08)',
    hoverOpacity: 0.08,
    selected: 'rgba(0, 0, 0, 0.14)',
    disabled: 'rgba(0, 0, 0, 0.26)',
    disabledBackground: 'rgba(0, 0, 0, 0.12)'
  }
};
createPalette$1.light = light;
var dark = {
  text: {
    primary: _common.default.white,
    secondary: 'rgba(255, 255, 255, 0.7)',
    disabled: 'rgba(255, 255, 255, 0.5)',
    hint: 'rgba(255, 255, 255, 0.5)',
    icon: 'rgba(255, 255, 255, 0.5)'
  },
  divider: 'rgba(255, 255, 255, 0.12)',
  background: {
    paper: _grey.default[800],
    default: '#303030'
  },
  action: {
    active: _common.default.white,
    hover: 'rgba(255, 255, 255, 0.1)',
    hoverOpacity: 0.1,
    selected: 'rgba(255, 255, 255, 0.2)',
    disabled: 'rgba(255, 255, 255, 0.3)',
    disabledBackground: 'rgba(255, 255, 255, 0.12)'
  }
};
createPalette$1.dark = dark;
function addLightOrDark(intent, direction, shade, tonalOffset) {
  if (!intent[direction]) {
    if (intent.hasOwnProperty(shade)) {
      intent[direction] = intent[shade];
    } else if (direction === 'light') {
      intent.light = (0, _colorManipulator$1.lighten)(intent.main, tonalOffset);
    } else if (direction === 'dark') {
      intent.dark = (0, _colorManipulator$1.darken)(intent.main, tonalOffset * 1.5);
    }
  }
}
function createPalette(palette) {
  var _palette$primary = palette.primary, primary = _palette$primary === void 0 ? {
    light: _indigo.default[300],
    main: _indigo.default[500],
    dark: _indigo.default[700]
  } : _palette$primary, _palette$secondary = palette.secondary, secondary = _palette$secondary === void 0 ? {
    light: _pink.default.A200,
    main: _pink.default.A400,
    dark: _pink.default.A700
  } : _palette$secondary, _palette$error = palette.error, error = _palette$error === void 0 ? {
    light: _red.default[300],
    main: _red.default[500],
    dark: _red.default[700]
  } : _palette$error, _palette$type = palette.type, type = _palette$type === void 0 ? 'light' : _palette$type, _palette$contrastThre = palette.contrastThreshold, contrastThreshold = _palette$contrastThre === void 0 ? 3 : _palette$contrastThre, _palette$tonalOffset = palette.tonalOffset, tonalOffset = _palette$tonalOffset === void 0 ? 0.2 : _palette$tonalOffset, other = (0, _objectWithoutProperties2$j.default)(palette, ["primary", "secondary", "error", "type", "contrastThreshold", "tonalOffset"]);
  function getContrastText(background) {
    var contrastText = (0, _colorManipulator$1.getContrastRatio)(background, dark.text.primary) >= contrastThreshold ? dark.text.primary : light.text.primary;
    {
      var contrast = (0, _colorManipulator$1.getContrastRatio)(background, contrastText);
      (0, _warning$c.default)(contrast >= 3, [("Material-UI: the contrast ratio of ").concat(contrast, ":1 for ").concat(contrastText, " on ").concat(background), 'falls below the WACG recommended absolute minimum contrast ratio of 3:1.', 'https://www.w3.org/TR/2008/REC-WCAG20-20081211/#visual-audio-contrast-contrast'].join('\n'));
    }
    return contrastText;
  }
  function augmentColor(color) {
    var mainShade = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 500;
    var lightShade = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 300;
    var darkShade = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 700;
    if (!color.main && color[mainShade]) {
      color.main = color[mainShade];
    }
    if (!color.main) {
      throw new Error(['Material-UI: the color provided to augmentColor(color) is invalid.', ("The color object needs to have a `main` property or a `").concat(mainShade, "` property.")].join('\n'));
    }
    addLightOrDark(color, 'light', lightShade, tonalOffset);
    addLightOrDark(color, 'dark', darkShade, tonalOffset);
    if (!color.contrastText) {
      color.contrastText = getContrastText(color.main);
    }
    return color;
  }
  augmentColor(primary);
  augmentColor(secondary, 'A400', 'A200', 'A700');
  augmentColor(error);
  var types = {
    dark: dark,
    light: light
  };
  (0, _warning$c.default)(types[type], ("Material-UI: the palette type `").concat(type, "` is not supported."));
  var paletteOutput = (0, _deepmerge$3.default)((0, _extends2$l.default)({
    common: _common.default,
    type: type,
    primary: primary,
    secondary: secondary,
    error: error,
    grey: _grey.default,
    contrastThreshold: contrastThreshold,
    getContrastText: getContrastText,
    augmentColor: augmentColor,
    tonalOffset: tonalOffset
  }, types[type]), other, {
    clone: false
  });
  return paletteOutput;
}
var createTypography$1 = {};
var componentPropType$1 = {};
var _typeof$1 = {
  exports: {}
};
(function (module) {
  function _typeof(obj) {
    "@babel/helpers - typeof";
    return ((module.exports = _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
      return typeof obj;
    } : function (obj) {
      return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    }, module.exports.__esModule = true, module.exports["default"] = module.exports), _typeof(obj));
  }
  (module.exports = _typeof, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(_typeof$1);
getDefaultExportFromCjs(_typeof$1.exports);
var reactIs$1 = {
  exports: {}
};
var reactIs_development = {};
{
  (function () {
    var hasSymbol = typeof Symbol === 'function' && Symbol.for;
    var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;
    var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 0xeaca;
    var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for('react.fragment') : 0xeacb;
    var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for('react.strict_mode') : 0xeacc;
    var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for('react.profiler') : 0xead2;
    var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for('react.provider') : 0xeacd;
    var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace;
    var REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for('react.async_mode') : 0xeacf;
    var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for('react.concurrent_mode') : 0xeacf;
    var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
    var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for('react.suspense') : 0xead1;
    var REACT_SUSPENSE_LIST_TYPE = hasSymbol ? Symbol.for('react.suspense_list') : 0xead8;
    var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 0xead3;
    var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;
    var REACT_BLOCK_TYPE = hasSymbol ? Symbol.for('react.block') : 0xead9;
    var REACT_FUNDAMENTAL_TYPE = hasSymbol ? Symbol.for('react.fundamental') : 0xead5;
    var REACT_RESPONDER_TYPE = hasSymbol ? Symbol.for('react.responder') : 0xead6;
    var REACT_SCOPE_TYPE = hasSymbol ? Symbol.for('react.scope') : 0xead7;
    function isValidElementType(type) {
      return typeof type === 'string' || typeof type === 'function' || type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || typeof type === 'object' && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_RESPONDER_TYPE || type.$$typeof === REACT_SCOPE_TYPE || type.$$typeof === REACT_BLOCK_TYPE);
    }
    function typeOf(object) {
      if (typeof object === 'object' && object !== null) {
        var $$typeof = object.$$typeof;
        switch ($$typeof) {
          case REACT_ELEMENT_TYPE:
            var type = object.type;
            switch (type) {
              case REACT_ASYNC_MODE_TYPE:
              case REACT_CONCURRENT_MODE_TYPE:
              case REACT_FRAGMENT_TYPE:
              case REACT_PROFILER_TYPE:
              case REACT_STRICT_MODE_TYPE:
              case REACT_SUSPENSE_TYPE:
                return type;
              default:
                var $$typeofType = type && type.$$typeof;
                switch ($$typeofType) {
                  case REACT_CONTEXT_TYPE:
                  case REACT_FORWARD_REF_TYPE:
                  case REACT_LAZY_TYPE:
                  case REACT_MEMO_TYPE:
                  case REACT_PROVIDER_TYPE:
                    return $$typeofType;
                  default:
                    return $$typeof;
                }
            }
          case REACT_PORTAL_TYPE:
            return $$typeof;
        }
      }
      return undefined;
    }
    var AsyncMode = REACT_ASYNC_MODE_TYPE;
    var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
    var ContextConsumer = REACT_CONTEXT_TYPE;
    var ContextProvider = REACT_PROVIDER_TYPE;
    var Element = REACT_ELEMENT_TYPE;
    var ForwardRef = REACT_FORWARD_REF_TYPE;
    var Fragment = REACT_FRAGMENT_TYPE;
    var Lazy = REACT_LAZY_TYPE;
    var Memo = REACT_MEMO_TYPE;
    var Portal = REACT_PORTAL_TYPE;
    var Profiler = REACT_PROFILER_TYPE;
    var StrictMode = REACT_STRICT_MODE_TYPE;
    var Suspense = REACT_SUSPENSE_TYPE;
    var hasWarnedAboutDeprecatedIsAsyncMode = false;
    function isAsyncMode(object) {
      {
        if (!hasWarnedAboutDeprecatedIsAsyncMode) {
          hasWarnedAboutDeprecatedIsAsyncMode = true;
          console['warn']('The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 17+. Update your code to use ' + 'ReactIs.isConcurrentMode() instead. It has the exact same API.');
        }
      }
      return isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
    }
    function isConcurrentMode(object) {
      return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
    }
    function isContextConsumer(object) {
      return typeOf(object) === REACT_CONTEXT_TYPE;
    }
    function isContextProvider(object) {
      return typeOf(object) === REACT_PROVIDER_TYPE;
    }
    function isElement(object) {
      return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
    }
    function isForwardRef(object) {
      return typeOf(object) === REACT_FORWARD_REF_TYPE;
    }
    function isFragment(object) {
      return typeOf(object) === REACT_FRAGMENT_TYPE;
    }
    function isLazy(object) {
      return typeOf(object) === REACT_LAZY_TYPE;
    }
    function isMemo(object) {
      return typeOf(object) === REACT_MEMO_TYPE;
    }
    function isPortal(object) {
      return typeOf(object) === REACT_PORTAL_TYPE;
    }
    function isProfiler(object) {
      return typeOf(object) === REACT_PROFILER_TYPE;
    }
    function isStrictMode(object) {
      return typeOf(object) === REACT_STRICT_MODE_TYPE;
    }
    function isSuspense(object) {
      return typeOf(object) === REACT_SUSPENSE_TYPE;
    }
    reactIs_development.AsyncMode = AsyncMode;
    reactIs_development.ConcurrentMode = ConcurrentMode;
    reactIs_development.ContextConsumer = ContextConsumer;
    reactIs_development.ContextProvider = ContextProvider;
    reactIs_development.Element = Element;
    reactIs_development.ForwardRef = ForwardRef;
    reactIs_development.Fragment = Fragment;
    reactIs_development.Lazy = Lazy;
    reactIs_development.Memo = Memo;
    reactIs_development.Portal = Portal;
    reactIs_development.Profiler = Profiler;
    reactIs_development.StrictMode = StrictMode;
    reactIs_development.Suspense = Suspense;
    reactIs_development.isAsyncMode = isAsyncMode;
    reactIs_development.isConcurrentMode = isConcurrentMode;
    reactIs_development.isContextConsumer = isContextConsumer;
    reactIs_development.isContextProvider = isContextProvider;
    reactIs_development.isElement = isElement;
    reactIs_development.isForwardRef = isForwardRef;
    reactIs_development.isFragment = isFragment;
    reactIs_development.isLazy = isLazy;
    reactIs_development.isMemo = isMemo;
    reactIs_development.isPortal = isPortal;
    reactIs_development.isProfiler = isProfiler;
    reactIs_development.isStrictMode = isStrictMode;
    reactIs_development.isSuspense = isSuspense;
    reactIs_development.isValidElementType = isValidElementType;
    reactIs_development.typeOf = typeOf;
  })();
}
{
  reactIs$1.exports = reactIs_development;
}
var _interopRequireDefault$L = interopRequireDefault.exports;
Object.defineProperty(componentPropType$1, "__esModule", {
  value: true
});
var default_1$6 = componentPropType$1.default = void 0;
var _typeof2$2 = _interopRequireDefault$L(_typeof$1.exports);
var _reactIs = reactIs$1.exports;
function createComponentProp(isRequired) {
  return function componentPropType(props, key, componentName, location, propFullName) {
    var prop = props[key];
    var propName = propFullName || key;
    var message;
    if (prop == null) {
      if (isRequired) {
        message = ("The ").concat(location, " `").concat(propName, "` is marked as required in `").concat(componentName, "`, ") + ("but its value is `").concat((0, _typeof2$2.default)(prop), "`.");
      }
    } else if (!(0, _reactIs.isValidElementType)(prop)) {
      var preciseType = (0, _typeof2$2.default)(prop);
      message = ("Invalid ").concat(location, " `").concat(propName, "` of type `").concat(preciseType, "` ") + ("supplied to `").concat(componentName, "`, expected a component.");
    }
    if (message != null) {
      return new Error(("").concat(message).concat(''));
    }
    return null;
  };
}
var componentPropType = createComponentProp(false);
componentPropType.isRequired = createComponentProp(true);
var _default$S = componentPropType;
default_1$6 = componentPropType$1.default = _default$S;
var chainPropTypes$1 = {};
Object.defineProperty(chainPropTypes$1, "__esModule", {
  value: true
});
var default_1$5 = chainPropTypes$1.default = void 0;
function chainPropTypes(propType1, propType2) {
  return function validate() {
    return propType1.apply(void 0, arguments) || propType2.apply(void 0, arguments);
  };
}
var _default$R = chainPropTypes;
default_1$5 = chainPropTypes$1.default = _default$R;
var exactProp$1 = {};
var _interopRequireDefault$K = interopRequireDefault.exports;
Object.defineProperty(exactProp$1, "__esModule", {
  value: true
});
var default_1$4 = exactProp$1.default = exactProp$1.specialProperty = void 0;
var _defineProperty2$d = _interopRequireDefault$K(defineProperty$1.exports);
var _extends3$1 = _interopRequireDefault$K(_extends$1.exports);
var specialProperty = "exact-prop: \u200B";
exactProp$1.specialProperty = specialProperty;
function exactProp(propTypes) {
  return (0, _extends3$1.default)({}, propTypes, (0, _defineProperty2$d.default)({}, specialProperty, function (props) {
    var unsupportedProps = Object.keys(props).filter(function (prop) {
      return !propTypes.hasOwnProperty(prop);
    });
    if (unsupportedProps.length > 0) {
      return new Error(("The following properties are not supported: ").concat(unsupportedProps.map(function (prop) {
        return ("`").concat(prop, "`");
      }).join(', '), ". Please remove them."));
    }
    return null;
  }));
}
var _default$Q = exactProp;
default_1$4 = exactProp$1.default = _default$Q;
var getDisplayName$3 = {};
Object.defineProperty(getDisplayName$3, "__esModule", {
  value: true
});
getDisplayName$3.getFunctionName = getFunctionName;
var default_1$3 = getDisplayName$3.default = void 0;
var fnNameMatchRegex = /^\s*function(?:\s|\s*\/\*.*\*\/\s*)+([^(\s/]*)\s*/;
function getFunctionName(fn) {
  var match = ("").concat(fn).match(fnNameMatchRegex);
  var name = match && match[1];
  return name || '';
}
function getDisplayName$2(Component) {
  if (typeof Component === 'string') {
    return Component;
  }
  if (!Component) {
    return undefined;
  }
  return Component.displayName || Component.name || getFunctionName(Component) || 'Component';
}
var _default$P = getDisplayName$2;
default_1$3 = getDisplayName$3.default = _default$P;
var ponyfillGlobal = {};
Object.defineProperty(ponyfillGlobal, "__esModule", {
  value: true
});
var default_1$2 = ponyfillGlobal.default = void 0;
var _default$O = typeof window != 'undefined' && window.Math == Math ? window : typeof self != 'undefined' && self.Math == Math ? self : Function('return this')();
default_1$2 = ponyfillGlobal.default = _default$O;
var index_es = Object.freeze({
  __proto__: null,
  get componentPropType() {
    return default_1$6;
  },
  get chainPropTypes() {
    return default_1$5;
  },
  get exactProp() {
    return default_1$4;
  },
  get getDisplayName() {
    return default_1$3;
  },
  get ponyfillGlobal() {
    return default_1$2;
  }
});
var require$$13$2 = getAugmentedNamespace(index_es);
var _interopRequireDefault$J = interopRequireDefault.exports;
Object.defineProperty(createTypography$1, "__esModule", {
  value: true
});
createTypography$1.default = createTypography;
var _extends2$k = _interopRequireDefault$J(_extends$1.exports);
var _objectWithoutProperties2$i = _interopRequireDefault$J(objectWithoutProperties.exports);
var _deepmerge$2 = _interopRequireDefault$J(umd.exports);
var _warning$b = _interopRequireDefault$J(warning_1);
var _utils$f = require$$13$2;
function round(value) {
  return Math.round(value * 1e5) / 1e5;
}
var caseAllCaps = {
  textTransform: 'uppercase'
};
var defaultFontFamily = '"Roboto", "Helvetica", "Arial", sans-serif';
function createTypography(palette, typography) {
  var _ref = typeof typography === 'function' ? typography(palette) : typography, _ref$fontFamily = _ref.fontFamily, fontFamily = _ref$fontFamily === void 0 ? defaultFontFamily : _ref$fontFamily, _ref$fontSize = _ref.fontSize, fontSize = _ref$fontSize === void 0 ? 14 : _ref$fontSize, _ref$fontWeightLight = _ref.fontWeightLight, fontWeightLight = _ref$fontWeightLight === void 0 ? 300 : _ref$fontWeightLight, _ref$fontWeightRegula = _ref.fontWeightRegular, fontWeightRegular = _ref$fontWeightRegula === void 0 ? 400 : _ref$fontWeightRegula, _ref$fontWeightMedium = _ref.fontWeightMedium, fontWeightMedium = _ref$fontWeightMedium === void 0 ? 500 : _ref$fontWeightMedium, _ref$htmlFontSize = _ref.htmlFontSize, htmlFontSize = _ref$htmlFontSize === void 0 ? 16 : _ref$htmlFontSize, _ref$useNextVariants = _ref.useNextVariants, useNextVariants = _ref$useNextVariants === void 0 ? Boolean(_utils$f.ponyfillGlobal.__MUI_USE_NEXT_TYPOGRAPHY_VARIANTS__) : _ref$useNextVariants, _ref$suppressWarning = _ref.suppressWarning, suppressWarning = _ref$suppressWarning === void 0 ? false : _ref$suppressWarning, allVariants = _ref.allVariants, other = (0, _objectWithoutProperties2$i.default)(_ref, ["fontFamily", "fontSize", "fontWeightLight", "fontWeightRegular", "fontWeightMedium", "htmlFontSize", "useNextVariants", "suppressWarning", "allVariants"]);
  (0, _warning$b.default)(useNextVariants || suppressWarning, 'Material-UI: you are using the deprecated typography variants ' + 'that will be removed in the next major release.' + '\nPlease read the migration guide under https://v3.material-ui.com/style/typography#migration-to-typography-v2');
  var coef = fontSize / 14;
  var pxToRem = function pxToRem(size) {
    return ("").concat(size / htmlFontSize * coef, "rem");
  };
  var buildVariant = function buildVariant(fontWeight, size, lineHeight, letterSpacing, casing) {
    return (0, _extends2$k.default)({
      color: palette.text.primary,
      fontFamily: fontFamily,
      fontWeight: fontWeight,
      fontSize: pxToRem(size),
      lineHeight: lineHeight
    }, fontFamily === defaultFontFamily ? {
      letterSpacing: ("").concat(round(letterSpacing / size), "em")
    } : {}, casing, allVariants);
  };
  var nextVariants = {
    h1: buildVariant(fontWeightLight, 96, 1, -1.5),
    h2: buildVariant(fontWeightLight, 60, 1, -0.5),
    h3: buildVariant(fontWeightRegular, 48, 1.04, 0),
    h4: buildVariant(fontWeightRegular, 34, 1.17, 0.25),
    h5: buildVariant(fontWeightRegular, 24, 1.33, 0),
    h6: buildVariant(fontWeightMedium, 20, 1.6, 0.15),
    subtitle1: buildVariant(fontWeightRegular, 16, 1.75, 0.15),
    subtitle2: buildVariant(fontWeightMedium, 14, 1.57, 0.1),
    body1Next: buildVariant(fontWeightRegular, 16, 1.5, 0.15),
    body2Next: buildVariant(fontWeightRegular, 14, 1.5, 0.15),
    buttonNext: buildVariant(fontWeightMedium, 14, 1.75, 0.4, caseAllCaps),
    captionNext: buildVariant(fontWeightRegular, 12, 1.66, 0.4),
    overline: buildVariant(fontWeightRegular, 12, 2.66, 1, caseAllCaps)
  };
  var oldVariants = {
    display4: (0, _extends2$k.default)({
      fontSize: pxToRem(112),
      fontWeight: fontWeightLight,
      fontFamily: fontFamily,
      letterSpacing: '-.04em',
      lineHeight: ("").concat(round(128 / 112), "em"),
      marginLeft: '-.04em',
      color: palette.text.secondary
    }, allVariants),
    display3: (0, _extends2$k.default)({
      fontSize: pxToRem(56),
      fontWeight: fontWeightRegular,
      fontFamily: fontFamily,
      letterSpacing: '-.02em',
      lineHeight: ("").concat(round(73 / 56), "em"),
      marginLeft: '-.02em',
      color: palette.text.secondary
    }, allVariants),
    display2: (0, _extends2$k.default)({
      fontSize: pxToRem(45),
      fontWeight: fontWeightRegular,
      fontFamily: fontFamily,
      lineHeight: ("").concat(round(51 / 45), "em"),
      marginLeft: '-.02em',
      color: palette.text.secondary
    }, allVariants),
    display1: (0, _extends2$k.default)({
      fontSize: pxToRem(34),
      fontWeight: fontWeightRegular,
      fontFamily: fontFamily,
      lineHeight: ("").concat(round(41 / 34), "em"),
      color: palette.text.secondary
    }, allVariants),
    headline: (0, _extends2$k.default)({
      fontSize: pxToRem(24),
      fontWeight: fontWeightRegular,
      fontFamily: fontFamily,
      lineHeight: ("").concat(round(32.5 / 24), "em"),
      color: palette.text.primary
    }, allVariants),
    title: (0, _extends2$k.default)({
      fontSize: pxToRem(21),
      fontWeight: fontWeightMedium,
      fontFamily: fontFamily,
      lineHeight: ("").concat(round(24.5 / 21), "em"),
      color: palette.text.primary
    }, allVariants),
    subheading: (0, _extends2$k.default)({
      fontSize: pxToRem(16),
      fontWeight: fontWeightRegular,
      fontFamily: fontFamily,
      lineHeight: ("").concat(round(24 / 16), "em"),
      color: palette.text.primary
    }, allVariants),
    body2: (0, _extends2$k.default)({
      fontSize: pxToRem(14),
      fontWeight: fontWeightMedium,
      fontFamily: fontFamily,
      lineHeight: ("").concat(round(24 / 14), "em"),
      color: palette.text.primary
    }, allVariants),
    body1: (0, _extends2$k.default)({
      fontSize: pxToRem(14),
      fontWeight: fontWeightRegular,
      fontFamily: fontFamily,
      lineHeight: ("").concat(round(20.5 / 14), "em"),
      color: palette.text.primary
    }, allVariants),
    caption: (0, _extends2$k.default)({
      fontSize: pxToRem(12),
      fontWeight: fontWeightRegular,
      fontFamily: fontFamily,
      lineHeight: ("").concat(round(16.5 / 12), "em"),
      color: palette.text.secondary
    }, allVariants),
    button: (0, _extends2$k.default)({
      fontSize: pxToRem(14),
      textTransform: 'uppercase',
      fontWeight: fontWeightMedium,
      fontFamily: fontFamily,
      color: palette.text.primary
    }, allVariants)
  };
  return (0, _deepmerge$2.default)((0, _extends2$k.default)({
    pxToRem: pxToRem,
    round: round,
    fontFamily: fontFamily,
    fontSize: fontSize,
    fontWeightLight: fontWeightLight,
    fontWeightRegular: fontWeightRegular,
    fontWeightMedium: fontWeightMedium
  }, oldVariants, nextVariants, useNextVariants ? {
    body1: nextVariants.body1Next,
    body2: nextVariants.body2Next,
    button: nextVariants.buttonNext,
    caption: nextVariants.captionNext
  } : {}, {
    useNextVariants: useNextVariants
  }), other, {
    clone: false
  });
}
var shadows$1 = {};
Object.defineProperty(shadows$1, "__esModule", {
  value: true
});
shadows$1.default = void 0;
var shadowKeyUmbraOpacity = 0.2;
var shadowKeyPenumbraOpacity = 0.14;
var shadowAmbientShadowOpacity = 0.12;
function createShadow() {
  return [("").concat(arguments.length <= 0 ? undefined : arguments[0], "px ").concat(arguments.length <= 1 ? undefined : arguments[1], "px ").concat(arguments.length <= 2 ? undefined : arguments[2], "px ").concat(arguments.length <= 3 ? undefined : arguments[3], "px rgba(0,0,0,").concat(shadowKeyUmbraOpacity, ")"), ("").concat(arguments.length <= 4 ? undefined : arguments[4], "px ").concat(arguments.length <= 5 ? undefined : arguments[5], "px ").concat(arguments.length <= 6 ? undefined : arguments[6], "px ").concat(arguments.length <= 7 ? undefined : arguments[7], "px rgba(0,0,0,").concat(shadowKeyPenumbraOpacity, ")"), ("").concat(arguments.length <= 8 ? undefined : arguments[8], "px ").concat(arguments.length <= 9 ? undefined : arguments[9], "px ").concat(arguments.length <= 10 ? undefined : arguments[10], "px ").concat(arguments.length <= 11 ? undefined : arguments[11], "px rgba(0,0,0,").concat(shadowAmbientShadowOpacity, ")")].join(',');
}
var shadows = ['none', createShadow(0, 1, 3, 0, 0, 1, 1, 0, 0, 2, 1, -1), createShadow(0, 1, 5, 0, 0, 2, 2, 0, 0, 3, 1, -2), createShadow(0, 1, 8, 0, 0, 3, 4, 0, 0, 3, 3, -2), createShadow(0, 2, 4, -1, 0, 4, 5, 0, 0, 1, 10, 0), createShadow(0, 3, 5, -1, 0, 5, 8, 0, 0, 1, 14, 0), createShadow(0, 3, 5, -1, 0, 6, 10, 0, 0, 1, 18, 0), createShadow(0, 4, 5, -2, 0, 7, 10, 1, 0, 2, 16, 1), createShadow(0, 5, 5, -3, 0, 8, 10, 1, 0, 3, 14, 2), createShadow(0, 5, 6, -3, 0, 9, 12, 1, 0, 3, 16, 2), createShadow(0, 6, 6, -3, 0, 10, 14, 1, 0, 4, 18, 3), createShadow(0, 6, 7, -4, 0, 11, 15, 1, 0, 4, 20, 3), createShadow(0, 7, 8, -4, 0, 12, 17, 2, 0, 5, 22, 4), createShadow(0, 7, 8, -4, 0, 13, 19, 2, 0, 5, 24, 4), createShadow(0, 7, 9, -4, 0, 14, 21, 2, 0, 5, 26, 4), createShadow(0, 8, 9, -5, 0, 15, 22, 2, 0, 6, 28, 5), createShadow(0, 8, 10, -5, 0, 16, 24, 2, 0, 6, 30, 5), createShadow(0, 8, 11, -5, 0, 17, 26, 2, 0, 6, 32, 5), createShadow(0, 9, 11, -5, 0, 18, 28, 2, 0, 7, 34, 6), createShadow(0, 9, 12, -6, 0, 19, 29, 2, 0, 7, 36, 6), createShadow(0, 10, 13, -6, 0, 20, 31, 3, 0, 8, 38, 7), createShadow(0, 10, 13, -6, 0, 21, 33, 3, 0, 8, 40, 7), createShadow(0, 10, 14, -6, 0, 22, 35, 3, 0, 8, 42, 7), createShadow(0, 11, 14, -7, 0, 23, 36, 3, 0, 9, 44, 8), createShadow(0, 11, 15, -7, 0, 24, 38, 3, 0, 9, 46, 8)];
var _default$N = shadows;
shadows$1.default = _default$N;
var shape$1 = {};
Object.defineProperty(shape$1, "__esModule", {
  value: true
});
shape$1.default = void 0;
var shape = {
  borderRadius: 4
};
var _default$M = shape;
shape$1.default = _default$M;
var spacing$1 = {};
Object.defineProperty(spacing$1, "__esModule", {
  value: true
});
spacing$1.default = void 0;
var spacing = {
  unit: 8
};
var _default$L = spacing;
spacing$1.default = _default$L;
var transitions = {};
var _interopRequireDefault$I = interopRequireDefault.exports;
Object.defineProperty(transitions, "__esModule", {
  value: true
});
transitions.default = transitions.isNumber = transitions.isString = transitions.formatMs = transitions.duration = transitions.easing = void 0;
var _objectWithoutProperties2$h = _interopRequireDefault$I(objectWithoutProperties.exports);
var _warning$a = _interopRequireDefault$I(warning_1);
var easing = {
  easeInOut: 'cubic-bezier(0.4, 0, 0.2, 1)',
  easeOut: 'cubic-bezier(0.0, 0, 0.2, 1)',
  easeIn: 'cubic-bezier(0.4, 0, 1, 1)',
  sharp: 'cubic-bezier(0.4, 0, 0.6, 1)'
};
transitions.easing = easing;
var duration = {
  shortest: 150,
  shorter: 200,
  short: 250,
  standard: 300,
  complex: 375,
  enteringScreen: 225,
  leavingScreen: 195
};
transitions.duration = duration;
var formatMs = function formatMs(milliseconds) {
  return ("").concat(Math.round(milliseconds), "ms");
};
transitions.formatMs = formatMs;
var isString = function isString(value) {
  return typeof value === 'string';
};
transitions.isString = isString;
var isNumber = function isNumber(value) {
  return !isNaN(parseFloat(value));
};
transitions.isNumber = isNumber;
var _default$K = {
  easing: easing,
  duration: duration,
  create: function create() {
    var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : ['all'];
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var _options$duration = options.duration, durationOption = _options$duration === void 0 ? duration.standard : _options$duration, _options$easing = options.easing, easingOption = _options$easing === void 0 ? easing.easeInOut : _options$easing, _options$delay = options.delay, delay = _options$delay === void 0 ? 0 : _options$delay, other = (0, _objectWithoutProperties2$h.default)(options, ["duration", "easing", "delay"]);
    (0, _warning$a.default)(isString(props) || Array.isArray(props), 'Material-UI: argument "props" must be a string or Array.');
    (0, _warning$a.default)(isNumber(durationOption) || isString(durationOption), ("Material-UI: argument \"duration\" must be a number or a string but found ").concat(durationOption, "."));
    (0, _warning$a.default)(isString(easingOption), 'Material-UI: argument "easing" must be a string.');
    (0, _warning$a.default)(isNumber(delay) || isString(delay), 'Material-UI: argument "delay" must be a number or a string.');
    (0, _warning$a.default)(Object.keys(other).length === 0, ("Material-UI: unrecognized argument(s) [").concat(Object.keys(other).join(','), "]"));
    return (Array.isArray(props) ? props : [props]).map(function (animatedProp) {
      return ("").concat(animatedProp, " ").concat(typeof durationOption === 'string' ? durationOption : formatMs(durationOption), " ").concat(easingOption, " ").concat(typeof delay === 'string' ? delay : formatMs(delay));
    }).join(',');
  },
  getAutoHeightDuration: function getAutoHeightDuration(height) {
    if (!height) {
      return 0;
    }
    var constant = height / 36;
    return Math.round((4 + 15 * Math.pow(constant, 0.25) + constant / 5) * 10);
  }
};
transitions.default = _default$K;
var zIndex$1 = {};
Object.defineProperty(zIndex$1, "__esModule", {
  value: true
});
zIndex$1.default = void 0;
var zIndex = {
  mobileStepper: 1000,
  appBar: 1100,
  drawer: 1200,
  modal: 1300,
  snackbar: 1400,
  tooltip: 1500
};
var _default$J = zIndex;
zIndex$1.default = _default$J;
var _interopRequireDefault$H = interopRequireDefault.exports;
Object.defineProperty(createMuiTheme$1, "__esModule", {
  value: true
});
createMuiTheme$1.default = void 0;
var _defineProperty2$c = _interopRequireDefault$H(defineProperty$1.exports);
var _extends2$j = _interopRequireDefault$H(_extends$1.exports);
var _objectWithoutProperties2$g = _interopRequireDefault$H(objectWithoutProperties.exports);
var _deepmerge$1 = _interopRequireDefault$H(umd.exports);
var _isPlainObject = _interopRequireDefault$H(isPlainObject);
var _warning$9 = _interopRequireDefault$H(warning_1);
var _createBreakpoints = _interopRequireDefault$H(createBreakpoints$1);
var _createMixins = _interopRequireDefault$H(createMixins$1);
var _createPalette = _interopRequireDefault$H(createPalette$1);
var _createTypography = _interopRequireDefault$H(createTypography$1);
var _shadows = _interopRequireDefault$H(shadows$1);
var _shape = _interopRequireDefault$H(shape$1);
var _spacing = _interopRequireDefault$H(spacing$1);
var _transitions$2 = _interopRequireDefault$H(transitions);
var _zIndex = _interopRequireDefault$H(zIndex$1);
function createMuiTheme() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var _options$breakpoints = options.breakpoints, breakpointsInput = _options$breakpoints === void 0 ? {} : _options$breakpoints, _options$mixins = options.mixins, mixinsInput = _options$mixins === void 0 ? {} : _options$mixins, _options$palette = options.palette, paletteInput = _options$palette === void 0 ? {} : _options$palette, shadowsInput = options.shadows, _options$spacing = options.spacing, spacingInput = _options$spacing === void 0 ? {} : _options$spacing, _options$typography = options.typography, typographyInput = _options$typography === void 0 ? {} : _options$typography, other = (0, _objectWithoutProperties2$g.default)(options, ["breakpoints", "mixins", "palette", "shadows", "spacing", "typography"]);
  var palette = (0, _createPalette.default)(paletteInput);
  var breakpoints = (0, _createBreakpoints.default)(breakpointsInput);
  var spacing = (0, _extends2$j.default)({}, _spacing.default, spacingInput);
  var muiTheme = (0, _extends2$j.default)({
    breakpoints: breakpoints,
    direction: 'ltr',
    mixins: (0, _createMixins.default)(breakpoints, spacing, mixinsInput),
    overrides: {},
    palette: palette,
    props: {},
    shadows: shadowsInput || _shadows.default,
    typography: (0, _createTypography.default)(palette, typographyInput)
  }, (0, _deepmerge$1.default)({
    shape: _shape.default,
    spacing: spacing,
    transitions: _transitions$2.default,
    zIndex: _zIndex.default
  }, other, {
    isMergeableObject: _isPlainObject.default
  }));
  {
    var statesWarning = ['disabled', 'focused', 'selected', 'checked'];
    var traverse = function traverse(node, parentKey) {
      var depth = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;
      var key;
      for (key in node) {
        var child = node[key];
        if (depth === 1) {
          if (key.indexOf('Mui') === 0 && child) {
            traverse(child, key, depth + 1);
          }
        } else if (statesWarning.indexOf(key) !== -1 && Object.keys(child).length > 0) {
          (0, _warning$9.default)(false, [("Material-UI: the `").concat(parentKey, "` component increases ") + ("the CSS specificity of the `").concat(key, "` internal state."), 'You can not override it like this: ', JSON.stringify(node, null, 2), '', 'Instead, you need to use the $ruleName syntax:', JSON.stringify((0, _defineProperty2$c.default)({}, ("&$").concat(key), child), null, 2), '', 'https://v3.material-ui.com/customization/overrides#internal-states'].join('\n'));
        }
      }
    };
    traverse(other.overrides);
  }
  (0, _warning$9.default)(muiTheme.shadows.length === 25, 'Material-UI: the shadows array provided to createMuiTheme should support 25 elevations.');
  return muiTheme;
}
var _default$I = createMuiTheme;
createMuiTheme$1.default = _default$I;
var jssPreset$1 = {};
var lib$7 = {};
var lib$6 = {};
var getDynamicStyles = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };
  exports['default'] = getDynamicStyles;
  function getDynamicStyles(styles) {
    var to = null;
    for (var key in styles) {
      var value = styles[key];
      var type = typeof value === 'undefined' ? 'undefined' : _typeof(value);
      if (type === 'function') {
        if (!to) to = {};
        to[key] = value;
      } else if (type === 'object' && value !== null && !Array.isArray(value)) {
        var extracted = getDynamicStyles(value);
        if (extracted) {
          if (!to) to = {};
          to[key] = extracted;
        }
      }
    }
    return to;
  }
})(getDynamicStyles);
getDefaultExportFromCjs(getDynamicStyles);
var toCssValue = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports['default'] = toCssValue;
  var join = function join(value, by) {
    var result = '';
    for (var i = 0; i < value.length; i++) {
      if (value[i] === '!important') break;
      if (result) result += by;
      result += value[i];
    }
    return result;
  };
  function toCssValue(value) {
    var ignoreImportant = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    if (!Array.isArray(value)) return value;
    var cssValue = '';
    if (Array.isArray(value[0])) {
      for (var i = 0; i < value.length; i++) {
        if (value[i] === '!important') break;
        if (cssValue) cssValue += ', ';
        cssValue += join(value[i], ' ');
      }
    } else cssValue = join(value, ', ');
    if (!ignoreImportant && value[value.length - 1] === '!important') {
      cssValue += ' !important';
    }
    return cssValue;
  }
})(toCssValue);
getDefaultExportFromCjs(toCssValue);
var SheetsRegistry = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _createClass = (function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if (("value" in descriptor)) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  })();
  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  var SheetsRegistry = (function () {
    function SheetsRegistry() {
      _classCallCheck(this, SheetsRegistry);
      this.registry = [];
    }
    _createClass(SheetsRegistry, [{
      key: 'add',
      value: function add(sheet) {
        var registry = this.registry;
        var index = sheet.options.index;
        if (registry.indexOf(sheet) !== -1) return;
        if (registry.length === 0 || index >= this.index) {
          registry.push(sheet);
          return;
        }
        for (var i = 0; i < registry.length; i++) {
          if (registry[i].options.index > index) {
            registry.splice(i, 0, sheet);
            return;
          }
        }
      }
    }, {
      key: 'reset',
      value: function reset() {
        this.registry = [];
      }
    }, {
      key: 'remove',
      value: function remove(sheet) {
        var index = this.registry.indexOf(sheet);
        this.registry.splice(index, 1);
      }
    }, {
      key: 'toString',
      value: function toString(options) {
        return this.registry.filter(function (sheet) {
          return sheet.attached;
        }).map(function (sheet) {
          return sheet.toString(options);
        }).join('\n');
      }
    }, {
      key: 'index',
      get: function get() {
        return this.registry.length === 0 ? 0 : this.registry[this.registry.length - 1].options.index;
      }
    }]);
    return SheetsRegistry;
  })();
  exports['default'] = SheetsRegistry;
})(SheetsRegistry);
getDefaultExportFromCjs(SheetsRegistry);
var SheetsManager = {};
var warning$1 = function () {};
{
  warning$1 = function (condition, format, args) {
    var len = arguments.length;
    args = new Array(len > 2 ? len - 2 : 0);
    for (var key = 2; key < len; key++) {
      args[key - 2] = arguments[key];
    }
    if (format === undefined) {
      throw new Error('`warning(condition, format, ...args)` requires a warning ' + 'message argument');
    }
    if (format.length < 10 || (/^[s\W]*$/).test(format)) {
      throw new Error('The warning format should be able to uniquely identify this ' + 'warning. Please, use a more descriptive format than: ' + format);
    }
    if (!condition) {
      var argIndex = 0;
      var message = 'Warning: ' + format.replace(/%s/g, function () {
        return args[argIndex++];
      });
      if (typeof console !== 'undefined') {
        console.error(message);
      }
      try {
        throw new Error(message);
      } catch (x) {}
    }
  };
}
var browser$1 = warning$1;
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _createClass = (function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if (("value" in descriptor)) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  })();
  var _warning = browser$1;
  var _warning2 = _interopRequireDefault(_warning);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  var SheetsManager = (function () {
    function SheetsManager() {
      _classCallCheck(this, SheetsManager);
      this.sheets = [];
      this.refs = [];
      this.keys = [];
    }
    _createClass(SheetsManager, [{
      key: 'get',
      value: function get(key) {
        var index = this.keys.indexOf(key);
        return this.sheets[index];
      }
    }, {
      key: 'add',
      value: function add(key, sheet) {
        var sheets = this.sheets, refs = this.refs, keys = this.keys;
        var index = sheets.indexOf(sheet);
        if (index !== -1) return index;
        sheets.push(sheet);
        refs.push(0);
        keys.push(key);
        return sheets.length - 1;
      }
    }, {
      key: 'manage',
      value: function manage(key) {
        var index = this.keys.indexOf(key);
        var sheet = this.sheets[index];
        if (this.refs[index] === 0) sheet.attach();
        this.refs[index]++;
        if (!this.keys[index]) this.keys.splice(index, 0, key);
        return sheet;
      }
    }, {
      key: 'unmanage',
      value: function unmanage(key) {
        var index = this.keys.indexOf(key);
        if (index === -1) {
          (0, _warning2['default'])(false, "SheetsManager: can't find sheet to unmanage");
          return;
        }
        if (this.refs[index] > 0) {
          this.refs[index]--;
          if (this.refs[index] === 0) this.sheets[index].detach();
        }
      }
    }, {
      key: 'size',
      get: function get() {
        return this.keys.length;
      }
    }]);
    return SheetsManager;
  })();
  exports['default'] = SheetsManager;
})(SheetsManager);
getDefaultExportFromCjs(SheetsManager);
var RuleList = {};
var createRule = {};
var StyleRule = {};
var toCss = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports['default'] = toCss;
  var _toCssValue = toCssValue;
  var _toCssValue2 = _interopRequireDefault(_toCssValue);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  function indentStr(str, indent) {
    var result = '';
    for (var index = 0; index < indent; index++) {
      result += '  ';
    }
    return result + str;
  }
  function toCss(selector, style) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var result = '';
    if (!style) return result;
    var _options$indent = options.indent, indent = _options$indent === undefined ? 0 : _options$indent;
    var fallbacks = style.fallbacks;
    indent++;
    if (fallbacks) {
      if (Array.isArray(fallbacks)) {
        for (var index = 0; index < fallbacks.length; index++) {
          var fallback = fallbacks[index];
          for (var prop in fallback) {
            var value = fallback[prop];
            if (value != null) {
              result += '\n' + indentStr(prop + ': ' + (0, _toCssValue2['default'])(value) + ';', indent);
            }
          }
        }
      } else {
        for (var _prop in fallbacks) {
          var _value = fallbacks[_prop];
          if (_value != null) {
            result += '\n' + indentStr(_prop + ': ' + (0, _toCssValue2['default'])(_value) + ';', indent);
          }
        }
      }
    }
    for (var _prop2 in style) {
      var _value2 = style[_prop2];
      if (_value2 != null && _prop2 !== 'fallbacks') {
        result += '\n' + indentStr(_prop2 + ': ' + (0, _toCssValue2['default'])(_value2) + ';', indent);
      }
    }
    if (!result && !options.allowEmpty) return result;
    indent--;
    result = indentStr(selector + ' {' + result + '\n', indent) + indentStr('}', indent);
    return result;
  }
})(toCss);
getDefaultExportFromCjs(toCss);
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _extends = Object.assign || (function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  });
  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };
  var _createClass = (function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if (("value" in descriptor)) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  })();
  var _warning = browser$1;
  var _warning2 = _interopRequireDefault(_warning);
  var _toCss = toCss;
  var _toCss2 = _interopRequireDefault(_toCss);
  var _toCssValue = toCssValue;
  var _toCssValue2 = _interopRequireDefault(_toCssValue);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  var StyleRule = (function () {
    function StyleRule(key, style, options) {
      _classCallCheck(this, StyleRule);
      this.type = 'style';
      this.isProcessed = false;
      var sheet = options.sheet, Renderer = options.Renderer, selector = options.selector;
      this.key = key;
      this.options = options;
      this.style = style;
      if (selector) this.selectorText = selector;
      this.renderer = sheet ? sheet.renderer : new Renderer();
    }
    _createClass(StyleRule, [{
      key: 'prop',
      value: function prop(name, value) {
        if (value === undefined) return this.style[name];
        if (this.style[name] === value) return this;
        value = this.options.jss.plugins.onChangeValue(value, name, this);
        var isEmpty = value == null || value === false;
        var isDefined = (name in this.style);
        if (isEmpty && !isDefined) return this;
        var remove = isEmpty && isDefined;
        if (remove) delete this.style[name]; else this.style[name] = value;
        if (this.renderable) {
          if (remove) this.renderer.removeProperty(this.renderable, name); else this.renderer.setProperty(this.renderable, name, value);
          return this;
        }
        var sheet = this.options.sheet;
        if (sheet && sheet.attached) {
          (0, _warning2['default'])(false, 'Rule is not linked. Missing sheet option "link: true".');
        }
        return this;
      }
    }, {
      key: 'applyTo',
      value: function applyTo(renderable) {
        var json = this.toJSON();
        for (var prop in json) {
          this.renderer.setProperty(renderable, prop, json[prop]);
        }
        return this;
      }
    }, {
      key: 'toJSON',
      value: function toJSON() {
        var json = {};
        for (var prop in this.style) {
          var value = this.style[prop];
          if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) !== 'object') json[prop] = value; else if (Array.isArray(value)) json[prop] = (0, _toCssValue2['default'])(value);
        }
        return json;
      }
    }, {
      key: 'toString',
      value: function toString(options) {
        var sheet = this.options.sheet;
        var link = sheet ? sheet.options.link : false;
        var opts = link ? _extends({}, options, {
          allowEmpty: true
        }) : options;
        return (0, _toCss2['default'])(this.selector, this.style, opts);
      }
    }, {
      key: 'selector',
      set: function set(selector) {
        if (selector === this.selectorText) return;
        this.selectorText = selector;
        if (!this.renderable) return;
        var hasChanged = this.renderer.setSelector(this.renderable, selector);
        if (!hasChanged && this.renderable) {
          var renderable = this.renderer.replaceRule(this.renderable, this);
          if (renderable) this.renderable = renderable;
        }
      },
      get: function get() {
        return this.selectorText;
      }
    }]);
    return StyleRule;
  })();
  exports['default'] = StyleRule;
})(StyleRule);
getDefaultExportFromCjs(StyleRule);
var cloneStyle = {};
var isObservable = {};
function symbolObservablePonyfill(root) {
  var result;
  var Symbol = root.Symbol;
  if (typeof Symbol === 'function') {
    if (Symbol.observable) {
      result = Symbol.observable;
    } else {
      result = Symbol('observable');
      Symbol.observable = result;
    }
  } else {
    result = '@@observable';
  }
  return result;
}
var root;
if (typeof self !== 'undefined') {
  root = self;
} else if (typeof window !== 'undefined') {
  root = window;
} else if (typeof global !== 'undefined') {
  root = global;
} else if (typeof module !== 'undefined') {
  root = module;
} else {
  root = Function('return this')();
}
var result = symbolObservablePonyfill(root);
var es = Object.freeze({
  __proto__: null,
  'default': result
});
var require$$0$6 = getAugmentedNamespace(es);
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _symbolObservable = require$$0$6;
  var _symbolObservable2 = _interopRequireDefault(_symbolObservable);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  exports['default'] = function (value) {
    return value && value[_symbolObservable2['default']] && value === value[_symbolObservable2['default']]();
  };
})(isObservable);
getDefaultExportFromCjs(isObservable);
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };
  exports['default'] = cloneStyle;
  var _isObservable = isObservable;
  var _isObservable2 = _interopRequireDefault(_isObservable);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  var isArray = Array.isArray;
  function cloneStyle(style) {
    if (style == null) return style;
    var typeOfStyle = typeof style === 'undefined' ? 'undefined' : _typeof(style);
    if (typeOfStyle === 'string' || typeOfStyle === 'number' || typeOfStyle === 'function') {
      return style;
    }
    if (isArray(style)) return style.map(cloneStyle);
    if ((0, _isObservable2['default'])(style)) return style;
    var newStyle = {};
    for (var name in style) {
      var value = style[name];
      if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object') {
        newStyle[name] = cloneStyle(value);
        continue;
      }
      newStyle[name] = value;
    }
    return newStyle;
  }
})(cloneStyle);
getDefaultExportFromCjs(cloneStyle);
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports['default'] = createRule;
  var _warning = browser$1;
  var _warning2 = _interopRequireDefault(_warning);
  var _StyleRule = StyleRule;
  var _StyleRule2 = _interopRequireDefault(_StyleRule);
  var _cloneStyle = cloneStyle;
  var _cloneStyle2 = _interopRequireDefault(_cloneStyle);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  function createRule() {
    var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'unnamed';
    var decl = arguments[1];
    var options = arguments[2];
    var jss = options.jss;
    var declCopy = (0, _cloneStyle2['default'])(decl);
    var rule = jss.plugins.onCreateRule(name, declCopy, options);
    if (rule) return rule;
    if (name[0] === '@') {
      (0, _warning2['default'])(false, '[JSS] Unknown at-rule %s', name);
    }
    return new _StyleRule2['default'](name, declCopy, options);
  }
})(createRule);
getDefaultExportFromCjs(createRule);
var linkRule = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = linkRule;
  function linkRule(rule, cssRule) {
    rule.renderable = cssRule;
    if (rule.rules && cssRule.cssRules) rule.rules.link(cssRule.cssRules);
  }
})(linkRule);
getDefaultExportFromCjs(linkRule);
var _escape = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var CSS = commonjsGlobal.CSS;
  var escapeRegex = /([[\].#*$><+~=|^:(),"'`])/g;
  exports['default'] = function (str) {
    if (!CSS || !CSS.escape) {
      return str.replace(escapeRegex, '\\$1');
    }
    return CSS.escape(str);
  };
})(_escape);
getDefaultExportFromCjs(_escape);
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _extends = Object.assign || (function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  });
  var _createClass = (function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if (("value" in descriptor)) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  })();
  var _createRule = createRule;
  var _createRule2 = _interopRequireDefault(_createRule);
  var _linkRule = linkRule;
  var _linkRule2 = _interopRequireDefault(_linkRule);
  var _StyleRule = StyleRule;
  var _StyleRule2 = _interopRequireDefault(_StyleRule);
  var _escape$1 = _escape;
  var _escape2 = _interopRequireDefault(_escape$1);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  var RuleList = (function () {
    function RuleList(options) {
      var _this = this;
      _classCallCheck(this, RuleList);
      this.map = {};
      this.raw = {};
      this.index = [];
      this.update = function (name, data) {
        var _options = _this.options, plugins = _options.jss.plugins, sheet = _options.sheet;
        if (typeof name === 'string') {
          plugins.onUpdate(data, _this.get(name), sheet);
        } else {
          for (var index = 0; index < _this.index.length; index++) {
            plugins.onUpdate(name, _this.index[index], sheet);
          }
        }
      };
      this.options = options;
      this.classes = options.classes;
    }
    _createClass(RuleList, [{
      key: 'add',
      value: function add(name, decl, options) {
        var _options2 = this.options, parent = _options2.parent, sheet = _options2.sheet, jss = _options2.jss, Renderer = _options2.Renderer, generateClassName = _options2.generateClassName;
        options = _extends({
          classes: this.classes,
          parent: parent,
          sheet: sheet,
          jss: jss,
          Renderer: Renderer,
          generateClassName: generateClassName
        }, options);
        if (!options.selector && this.classes[name]) {
          options.selector = '.' + (0, _escape2['default'])(this.classes[name]);
        }
        this.raw[name] = decl;
        var rule = (0, _createRule2['default'])(name, decl, options);
        var className = void 0;
        if (!options.selector && rule instanceof _StyleRule2['default']) {
          className = generateClassName(rule, sheet);
          rule.selector = '.' + (0, _escape2['default'])(className);
        }
        this.register(rule, className);
        var index = options.index === undefined ? this.index.length : options.index;
        this.index.splice(index, 0, rule);
        return rule;
      }
    }, {
      key: 'get',
      value: function get(name) {
        return this.map[name];
      }
    }, {
      key: 'remove',
      value: function remove(rule) {
        this.unregister(rule);
        this.index.splice(this.indexOf(rule), 1);
      }
    }, {
      key: 'indexOf',
      value: function indexOf(rule) {
        return this.index.indexOf(rule);
      }
    }, {
      key: 'process',
      value: function process() {
        var plugins = this.options.jss.plugins;
        this.index.slice(0).forEach(plugins.onProcessRule, plugins);
      }
    }, {
      key: 'register',
      value: function register(rule, className) {
        this.map[rule.key] = rule;
        if (rule instanceof _StyleRule2['default']) {
          this.map[rule.selector] = rule;
          if (className) this.classes[rule.key] = className;
        }
      }
    }, {
      key: 'unregister',
      value: function unregister(rule) {
        delete this.map[rule.key];
        if (rule instanceof _StyleRule2['default']) {
          delete this.map[rule.selector];
          delete this.classes[rule.key];
        }
      }
    }, {
      key: 'link',
      value: function link(cssRules) {
        var map = this.options.sheet.renderer.getUnescapedKeysMap(this.index);
        for (var i = 0; i < cssRules.length; i++) {
          var cssRule = cssRules[i];
          var _key = this.options.sheet.renderer.getKey(cssRule);
          if (map[_key]) _key = map[_key];
          var rule = this.map[_key];
          if (rule) (0, _linkRule2['default'])(rule, cssRule);
        }
      }
    }, {
      key: 'toString',
      value: function toString(options) {
        var str = '';
        var sheet = this.options.sheet;
        var link = sheet ? sheet.options.link : false;
        for (var index = 0; index < this.index.length; index++) {
          var rule = this.index[index];
          var css = rule.toString(options);
          if (!css && !link) continue;
          if (str) str += '\n';
          str += css;
        }
        return str;
      }
    }]);
    return RuleList;
  })();
  exports['default'] = RuleList;
})(RuleList);
getDefaultExportFromCjs(RuleList);
var sheets = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _SheetsRegistry = SheetsRegistry;
  var _SheetsRegistry2 = _interopRequireDefault(_SheetsRegistry);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  exports['default'] = new _SheetsRegistry2['default']();
})(sheets);
getDefaultExportFromCjs(sheets);
var createGenerateClassName = {};
var StyleSheet = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _extends = Object.assign || (function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  });
  var _createClass = (function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if (("value" in descriptor)) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  })();
  var _linkRule = linkRule;
  var _linkRule2 = _interopRequireDefault(_linkRule);
  var _RuleList = RuleList;
  var _RuleList2 = _interopRequireDefault(_RuleList);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  var StyleSheet = (function () {
    function StyleSheet(styles, options) {
      var _this = this;
      _classCallCheck(this, StyleSheet);
      this.update = function (name, data) {
        if (typeof name === 'string') {
          _this.rules.update(name, data);
        } else {
          _this.rules.update(name);
        }
        return _this;
      };
      this.attached = false;
      this.deployed = false;
      this.linked = false;
      this.classes = {};
      this.options = _extends({}, options, {
        sheet: this,
        parent: this,
        classes: this.classes
      });
      this.renderer = new options.Renderer(this);
      this.rules = new _RuleList2['default'](this.options);
      for (var _name in styles) {
        this.rules.add(_name, styles[_name]);
      }
      this.rules.process();
    }
    _createClass(StyleSheet, [{
      key: 'attach',
      value: function attach() {
        if (this.attached) return this;
        if (!this.deployed) this.deploy();
        this.renderer.attach();
        if (!this.linked && this.options.link) this.link();
        this.attached = true;
        return this;
      }
    }, {
      key: 'detach',
      value: function detach() {
        if (!this.attached) return this;
        this.renderer.detach();
        this.attached = false;
        return this;
      }
    }, {
      key: 'addRule',
      value: function addRule(name, decl, options) {
        var queue = this.queue;
        if (this.attached && !queue) this.queue = [];
        var rule = this.rules.add(name, decl, options);
        this.options.jss.plugins.onProcessRule(rule);
        if (this.attached) {
          if (!this.deployed) return rule;
          if (queue) queue.push(rule); else {
            this.insertRule(rule);
            if (this.queue) {
              this.queue.forEach(this.insertRule, this);
              this.queue = undefined;
            }
          }
          return rule;
        }
        this.deployed = false;
        return rule;
      }
    }, {
      key: 'insertRule',
      value: function insertRule(rule) {
        var renderable = this.renderer.insertRule(rule);
        if (renderable && this.options.link) (0, _linkRule2['default'])(rule, renderable);
      }
    }, {
      key: 'addRules',
      value: function addRules(styles, options) {
        var added = [];
        for (var _name2 in styles) {
          added.push(this.addRule(_name2, styles[_name2], options));
        }
        return added;
      }
    }, {
      key: 'getRule',
      value: function getRule(name) {
        return this.rules.get(name);
      }
    }, {
      key: 'deleteRule',
      value: function deleteRule(name) {
        var rule = this.rules.get(name);
        if (!rule) return false;
        this.rules.remove(rule);
        if (this.attached && rule.renderable) {
          return this.renderer.deleteRule(rule.renderable);
        }
        return true;
      }
    }, {
      key: 'indexOf',
      value: function indexOf(rule) {
        return this.rules.indexOf(rule);
      }
    }, {
      key: 'deploy',
      value: function deploy() {
        this.renderer.deploy();
        this.deployed = true;
        return this;
      }
    }, {
      key: 'link',
      value: function link() {
        var cssRules = this.renderer.getRules();
        if (cssRules) this.rules.link(cssRules);
        this.linked = true;
        return this;
      }
    }, {
      key: 'toString',
      value: function toString(options) {
        return this.rules.toString(options);
      }
    }]);
    return StyleSheet;
  })();
  exports['default'] = StyleSheet;
})(StyleSheet);
getDefaultExportFromCjs(StyleSheet);
var moduleId = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var ns = '2f1acc6c3a606b082e5eef5e54414ffb';
  if (commonjsGlobal[ns] == null) commonjsGlobal[ns] = 0;
  exports['default'] = commonjsGlobal[ns]++;
})(moduleId);
getDefaultExportFromCjs(moduleId);
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _warning = browser$1;
  var _warning2 = _interopRequireDefault(_warning);
  var _StyleSheet = StyleSheet;
  _interopRequireDefault(_StyleSheet);
  var _moduleId = moduleId;
  var _moduleId2 = _interopRequireDefault(_moduleId);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  var maxRules = 1e10;
  exports['default'] = function () {
    var ruleCounter = 0;
    var defaultPrefix = '';
    return function (rule, sheet) {
      ruleCounter += 1;
      if (ruleCounter > maxRules) {
        (0, _warning2['default'])(false, '[JSS] You might have a memory leak. Rule counter is at %s.', ruleCounter);
      }
      var prefix = defaultPrefix;
      var jssId = '';
      if (sheet) {
        prefix = sheet.options.classNamePrefix || defaultPrefix;
        if (sheet.options.jss.id != null) jssId += sheet.options.jss.id;
      }
      return prefix + rule.key + '-' + _moduleId2['default'] + (jssId && '-' + jssId) + '-' + ruleCounter;
    };
  };
})(createGenerateClassName);
getDefaultExportFromCjs(createGenerateClassName);
var Jss = {};
var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};
var isBrowser = (typeof window === "undefined" ? "undefined" : _typeof(window)) === "object" && (typeof document === "undefined" ? "undefined" : _typeof(document)) === 'object' && document.nodeType === 9;
var module$1 = Object.freeze({
  __proto__: null,
  isBrowser: isBrowser,
  'default': isBrowser
});
var require$$0$5 = getAugmentedNamespace(module$1);
var PluginsRegistry = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _createClass = (function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if (("value" in descriptor)) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  })();
  var _warning = browser$1;
  var _warning2 = _interopRequireDefault(_warning);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  var PluginsRegistry = (function () {
    function PluginsRegistry() {
      _classCallCheck(this, PluginsRegistry);
      this.hooks = {
        onCreateRule: [],
        onProcessRule: [],
        onProcessStyle: [],
        onProcessSheet: [],
        onChangeValue: [],
        onUpdate: []
      };
    }
    _createClass(PluginsRegistry, [{
      key: 'onCreateRule',
      value: function onCreateRule(name, decl, options) {
        for (var i = 0; i < this.hooks.onCreateRule.length; i++) {
          var rule = this.hooks.onCreateRule[i](name, decl, options);
          if (rule) return rule;
        }
        return null;
      }
    }, {
      key: 'onProcessRule',
      value: function onProcessRule(rule) {
        if (rule.isProcessed) return;
        var sheet = rule.options.sheet;
        for (var i = 0; i < this.hooks.onProcessRule.length; i++) {
          this.hooks.onProcessRule[i](rule, sheet);
        }
        if (rule.style) this.onProcessStyle(rule.style, rule, sheet);
        rule.isProcessed = true;
      }
    }, {
      key: 'onProcessStyle',
      value: function onProcessStyle(style, rule, sheet) {
        var nextStyle = style;
        for (var i = 0; i < this.hooks.onProcessStyle.length; i++) {
          nextStyle = this.hooks.onProcessStyle[i](nextStyle, rule, sheet);
          rule.style = nextStyle;
        }
      }
    }, {
      key: 'onProcessSheet',
      value: function onProcessSheet(sheet) {
        for (var i = 0; i < this.hooks.onProcessSheet.length; i++) {
          this.hooks.onProcessSheet[i](sheet);
        }
      }
    }, {
      key: 'onUpdate',
      value: function onUpdate(data, rule, sheet) {
        for (var i = 0; i < this.hooks.onUpdate.length; i++) {
          this.hooks.onUpdate[i](data, rule, sheet);
        }
      }
    }, {
      key: 'onChangeValue',
      value: function onChangeValue(value, prop, rule) {
        var processedValue = value;
        for (var i = 0; i < this.hooks.onChangeValue.length; i++) {
          processedValue = this.hooks.onChangeValue[i](processedValue, prop, rule);
        }
        return processedValue;
      }
    }, {
      key: 'use',
      value: function use(plugin) {
        for (var name in plugin) {
          if (this.hooks[name]) this.hooks[name].push(plugin[name]); else (0, _warning2['default'])(false, '[JSS] Unknown hook "%s".', name);
        }
      }
    }]);
    return PluginsRegistry;
  })();
  exports['default'] = PluginsRegistry;
})(PluginsRegistry);
getDefaultExportFromCjs(PluginsRegistry);
var rules = {};
var SimpleRule = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _createClass = (function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if (("value" in descriptor)) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  })();
  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  var SimpleRule = (function () {
    function SimpleRule(key, value, options) {
      _classCallCheck(this, SimpleRule);
      this.type = 'simple';
      this.isProcessed = false;
      this.key = key;
      this.value = value;
      this.options = options;
    }
    _createClass(SimpleRule, [{
      key: 'toString',
      value: function toString(options) {
        if (Array.isArray(this.value)) {
          var str = '';
          for (var index = 0; index < this.value.length; index++) {
            str += this.key + ' ' + this.value[index] + ';';
            if (this.value[index + 1]) str += '\n';
          }
          return str;
        }
        return this.key + ' ' + this.value + ';';
      }
    }]);
    return SimpleRule;
  })();
  exports['default'] = SimpleRule;
})(SimpleRule);
getDefaultExportFromCjs(SimpleRule);
var KeyframesRule = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _extends = Object.assign || (function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  });
  var _createClass = (function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if (("value" in descriptor)) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  })();
  var _RuleList = RuleList;
  var _RuleList2 = _interopRequireDefault(_RuleList);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  var KeyframesRule = (function () {
    function KeyframesRule(key, frames, options) {
      _classCallCheck(this, KeyframesRule);
      this.type = 'keyframes';
      this.isProcessed = false;
      this.key = key;
      this.options = options;
      this.rules = new _RuleList2['default'](_extends({}, options, {
        parent: this
      }));
      for (var name in frames) {
        this.rules.add(name, frames[name], _extends({}, this.options, {
          parent: this,
          selector: name
        }));
      }
      this.rules.process();
    }
    _createClass(KeyframesRule, [{
      key: 'toString',
      value: function toString() {
        var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
          indent: 1
        };
        var inner = this.rules.toString(options);
        if (inner) inner += '\n';
        return this.key + ' {\n' + inner + '}';
      }
    }]);
    return KeyframesRule;
  })();
  exports['default'] = KeyframesRule;
})(KeyframesRule);
getDefaultExportFromCjs(KeyframesRule);
var ConditionalRule = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _extends = Object.assign || (function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  });
  var _createClass = (function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if (("value" in descriptor)) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  })();
  var _RuleList = RuleList;
  var _RuleList2 = _interopRequireDefault(_RuleList);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  var ConditionalRule = (function () {
    function ConditionalRule(key, styles, options) {
      _classCallCheck(this, ConditionalRule);
      this.type = 'conditional';
      this.isProcessed = false;
      this.key = key;
      this.options = options;
      this.rules = new _RuleList2['default'](_extends({}, options, {
        parent: this
      }));
      for (var name in styles) {
        this.rules.add(name, styles[name]);
      }
      this.rules.process();
    }
    _createClass(ConditionalRule, [{
      key: 'getRule',
      value: function getRule(name) {
        return this.rules.get(name);
      }
    }, {
      key: 'indexOf',
      value: function indexOf(rule) {
        return this.rules.indexOf(rule);
      }
    }, {
      key: 'addRule',
      value: function addRule(name, style, options) {
        var rule = this.rules.add(name, style, options);
        this.options.jss.plugins.onProcessRule(rule);
        return rule;
      }
    }, {
      key: 'toString',
      value: function toString() {
        var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
          indent: 1
        };
        var inner = this.rules.toString(options);
        return inner ? this.key + ' {\n' + inner + '\n}' : '';
      }
    }]);
    return ConditionalRule;
  })();
  exports['default'] = ConditionalRule;
})(ConditionalRule);
getDefaultExportFromCjs(ConditionalRule);
var FontFaceRule = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _createClass = (function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if (("value" in descriptor)) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  })();
  var _toCss = toCss;
  var _toCss2 = _interopRequireDefault(_toCss);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  var FontFaceRule = (function () {
    function FontFaceRule(key, style, options) {
      _classCallCheck(this, FontFaceRule);
      this.type = 'font-face';
      this.isProcessed = false;
      this.key = key;
      this.style = style;
      this.options = options;
    }
    _createClass(FontFaceRule, [{
      key: 'toString',
      value: function toString(options) {
        if (Array.isArray(this.style)) {
          var str = '';
          for (var index = 0; index < this.style.length; index++) {
            str += (0, _toCss2['default'])(this.key, this.style[index]);
            if (this.style[index + 1]) str += '\n';
          }
          return str;
        }
        return (0, _toCss2['default'])(this.key, this.style, options);
      }
    }]);
    return FontFaceRule;
  })();
  exports['default'] = FontFaceRule;
})(FontFaceRule);
getDefaultExportFromCjs(FontFaceRule);
var ViewportRule = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _createClass = (function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if (("value" in descriptor)) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  })();
  var _toCss = toCss;
  var _toCss2 = _interopRequireDefault(_toCss);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  var ViewportRule = (function () {
    function ViewportRule(key, style, options) {
      _classCallCheck(this, ViewportRule);
      this.type = 'viewport';
      this.isProcessed = false;
      this.key = key;
      this.style = style;
      this.options = options;
    }
    _createClass(ViewportRule, [{
      key: 'toString',
      value: function toString(options) {
        return (0, _toCss2['default'])(this.key, this.style, options);
      }
    }]);
    return ViewportRule;
  })();
  exports['default'] = ViewportRule;
})(ViewportRule);
getDefaultExportFromCjs(ViewportRule);
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _SimpleRule = SimpleRule;
  var _SimpleRule2 = _interopRequireDefault(_SimpleRule);
  var _KeyframesRule = KeyframesRule;
  var _KeyframesRule2 = _interopRequireDefault(_KeyframesRule);
  var _ConditionalRule = ConditionalRule;
  var _ConditionalRule2 = _interopRequireDefault(_ConditionalRule);
  var _FontFaceRule = FontFaceRule;
  var _FontFaceRule2 = _interopRequireDefault(_FontFaceRule);
  var _ViewportRule = ViewportRule;
  var _ViewportRule2 = _interopRequireDefault(_ViewportRule);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  var classes = {
    '@charset': _SimpleRule2['default'],
    '@import': _SimpleRule2['default'],
    '@namespace': _SimpleRule2['default'],
    '@keyframes': _KeyframesRule2['default'],
    '@media': _ConditionalRule2['default'],
    '@supports': _ConditionalRule2['default'],
    '@font-face': _FontFaceRule2['default'],
    '@viewport': _ViewportRule2['default'],
    '@-ms-viewport': _ViewportRule2['default']
  };
  var plugins = Object.keys(classes).map(function (key) {
    var re = new RegExp('^' + key);
    var RuleClass = classes[key];
    var onCreateRule = function onCreateRule(name, decl, options) {
      return re.test(name) ? new RuleClass(name, decl, options) : null;
    };
    return {
      onCreateRule: onCreateRule
    };
  });
  exports['default'] = plugins;
})(rules);
getDefaultExportFromCjs(rules);
var observables = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _StyleRule = StyleRule;
  var _StyleRule2 = _interopRequireDefault(_StyleRule);
  var _createRule = createRule;
  var _createRule2 = _interopRequireDefault(_createRule);
  var _isObservable = isObservable;
  var _isObservable2 = _interopRequireDefault(_isObservable);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  exports['default'] = {
    onCreateRule: function onCreateRule(name, decl, options) {
      if (!(0, _isObservable2['default'])(decl)) return null;
      var style$ = decl;
      var rule = (0, _createRule2['default'])(name, {}, options);
      style$.subscribe(function (style) {
        for (var prop in style) {
          rule.prop(prop, style[prop]);
        }
      });
      return rule;
    },
    onProcessRule: function onProcessRule(rule) {
      if (!(rule instanceof _StyleRule2['default'])) return;
      var styleRule = rule;
      var style = styleRule.style;
      var _loop = function _loop(prop) {
        var value = style[prop];
        if (!(0, _isObservable2['default'])(value)) return 'continue';
        delete style[prop];
        value.subscribe({
          next: function next(nextValue) {
            styleRule.prop(prop, nextValue);
          }
        });
      };
      for (var prop in style) {
        var _ret = _loop(prop);
        if (_ret === 'continue') continue;
      }
    }
  };
})(observables);
getDefaultExportFromCjs(observables);
var functions = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _RuleList = RuleList;
  var _RuleList2 = _interopRequireDefault(_RuleList);
  var _StyleRule = StyleRule;
  var _StyleRule2 = _interopRequireDefault(_StyleRule);
  var _createRule = createRule;
  var _createRule2 = _interopRequireDefault(_createRule);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  var now = Date.now();
  var fnValuesNs = 'fnValues' + now;
  var fnStyleNs = 'fnStyle' + ++now;
  exports['default'] = {
    onCreateRule: function onCreateRule(name, decl, options) {
      if (typeof decl !== 'function') return null;
      var rule = (0, _createRule2['default'])(name, {}, options);
      rule[fnStyleNs] = decl;
      return rule;
    },
    onProcessStyle: function onProcessStyle(style, rule) {
      var fn = {};
      for (var prop in style) {
        var value = style[prop];
        if (typeof value !== 'function') continue;
        delete style[prop];
        fn[prop] = value;
      }
      rule = rule;
      rule[fnValuesNs] = fn;
      return style;
    },
    onUpdate: function onUpdate(data, rule) {
      if (rule.rules instanceof _RuleList2['default']) {
        rule.rules.update(data);
        return;
      }
      if (!(rule instanceof _StyleRule2['default'])) return;
      rule = rule;
      if (rule[fnValuesNs]) {
        for (var prop in rule[fnValuesNs]) {
          rule.prop(prop, rule[fnValuesNs][prop](data));
        }
      }
      rule = rule;
      var fnStyle = rule[fnStyleNs];
      if (fnStyle) {
        var style = fnStyle(data);
        for (var _prop in style) {
          rule.prop(_prop, style[_prop]);
        }
      }
    }
  };
})(functions);
getDefaultExportFromCjs(functions);
var DomRenderer = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _createClass = (function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if (("value" in descriptor)) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  })();
  var _warning = browser$1;
  var _warning2 = _interopRequireDefault(_warning);
  var _sheets = sheets;
  var _sheets2 = _interopRequireDefault(_sheets);
  var _StyleRule = StyleRule;
  var _StyleRule2 = _interopRequireDefault(_StyleRule);
  var _toCssValue = toCssValue;
  var _toCssValue2 = _interopRequireDefault(_toCssValue);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  var memoize = function memoize(fn) {
    var value = void 0;
    return function () {
      if (!value) value = fn();
      return value;
    };
  };
  function getPropertyValue(cssRule, prop) {
    try {
      return cssRule.style.getPropertyValue(prop);
    } catch (err) {
      return '';
    }
  }
  function setProperty(cssRule, prop, value) {
    try {
      var cssValue = value;
      if (Array.isArray(value)) {
        cssValue = (0, _toCssValue2['default'])(value, true);
        if (value[value.length - 1] === '!important') {
          cssRule.style.setProperty(prop, cssValue, 'important');
          return true;
        }
      }
      cssRule.style.setProperty(prop, cssValue);
    } catch (err) {
      return false;
    }
    return true;
  }
  function removeProperty(cssRule, prop) {
    try {
      cssRule.style.removeProperty(prop);
    } catch (err) {
      (0, _warning2['default'])(false, '[JSS] DOMException "%s" was thrown. Tried to remove property "%s".', err.message, prop);
    }
  }
  var CSSRuleTypes = {
    STYLE_RULE: 1,
    KEYFRAMES_RULE: 7
  };
  var getKey = (function () {
    var extractKey = function extractKey(cssText) {
      var from = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      return cssText.substr(from, cssText.indexOf('{') - 1);
    };
    return function (cssRule) {
      if (cssRule.type === CSSRuleTypes.STYLE_RULE) return cssRule.selectorText;
      if (cssRule.type === CSSRuleTypes.KEYFRAMES_RULE) {
        var name = cssRule.name;
        if (name) return '@keyframes ' + name;
        var cssText = cssRule.cssText;
        return '@' + extractKey(cssText, cssText.indexOf('keyframes'));
      }
      return extractKey(cssRule.cssText);
    };
  })();
  function setSelector(cssRule, selectorText) {
    cssRule.selectorText = selectorText;
    return cssRule.selectorText === selectorText;
  }
  var getHead = memoize(function () {
    return document.head || document.getElementsByTagName('head')[0];
  });
  var getUnescapedKeysMap = (function () {
    var style = void 0;
    var isAttached = false;
    return function (rules) {
      var map = {};
      if (!style) style = document.createElement('style');
      for (var i = 0; i < rules.length; i++) {
        var rule = rules[i];
        if (!(rule instanceof _StyleRule2['default'])) continue;
        var selector = rule.selector;
        if (selector && selector.indexOf('\\') !== -1) {
          if (!isAttached) {
            getHead().appendChild(style);
            isAttached = true;
          }
          style.textContent = selector + ' {}';
          var _style = style, sheet = _style.sheet;
          if (sheet) {
            var cssRules = sheet.cssRules;
            if (cssRules) map[cssRules[0].selectorText] = rule.key;
          }
        }
      }
      if (isAttached) {
        getHead().removeChild(style);
        isAttached = false;
      }
      return map;
    };
  })();
  function findHigherSheet(registry, options) {
    for (var i = 0; i < registry.length; i++) {
      var sheet = registry[i];
      if (sheet.attached && sheet.options.index > options.index && sheet.options.insertionPoint === options.insertionPoint) {
        return sheet;
      }
    }
    return null;
  }
  function findHighestSheet(registry, options) {
    for (var i = registry.length - 1; i >= 0; i--) {
      var sheet = registry[i];
      if (sheet.attached && sheet.options.insertionPoint === options.insertionPoint) {
        return sheet;
      }
    }
    return null;
  }
  function findCommentNode(text) {
    var head = getHead();
    for (var i = 0; i < head.childNodes.length; i++) {
      var node = head.childNodes[i];
      if (node.nodeType === 8 && node.nodeValue.trim() === text) {
        return node;
      }
    }
    return null;
  }
  function findPrevNode(options) {
    var registry = _sheets2['default'].registry;
    if (registry.length > 0) {
      var sheet = findHigherSheet(registry, options);
      if (sheet) return sheet.renderer.element;
      sheet = findHighestSheet(registry, options);
      if (sheet) return sheet.renderer.element.nextElementSibling;
    }
    var insertionPoint = options.insertionPoint;
    if (insertionPoint && typeof insertionPoint === 'string') {
      var comment = findCommentNode(insertionPoint);
      if (comment) return comment.nextSibling;
      (0, _warning2['default'])(insertionPoint === 'jss', '[JSS] Insertion point "%s" not found.', insertionPoint);
    }
    return null;
  }
  function insertStyle(style, options) {
    var insertionPoint = options.insertionPoint;
    var prevNode = findPrevNode(options);
    if (prevNode) {
      var parentNode = prevNode.parentNode;
      if (parentNode) parentNode.insertBefore(style, prevNode);
      return;
    }
    if (insertionPoint && typeof insertionPoint.nodeType === 'number') {
      var insertionPointElement = insertionPoint;
      var _parentNode = insertionPointElement.parentNode;
      if (_parentNode) _parentNode.insertBefore(style, insertionPointElement.nextSibling); else (0, _warning2['default'])(false, '[JSS] Insertion point is not in the DOM.');
      return;
    }
    getHead().insertBefore(style, prevNode);
  }
  var getNonce = memoize(function () {
    var node = document.querySelector('meta[property="csp-nonce"]');
    return node ? node.getAttribute('content') : null;
  });
  var DomRenderer = (function () {
    function DomRenderer(sheet) {
      _classCallCheck(this, DomRenderer);
      this.getPropertyValue = getPropertyValue;
      this.setProperty = setProperty;
      this.removeProperty = removeProperty;
      this.setSelector = setSelector;
      this.getKey = getKey;
      this.getUnescapedKeysMap = getUnescapedKeysMap;
      this.hasInsertedRules = false;
      if (sheet) _sheets2['default'].add(sheet);
      this.sheet = sheet;
      var _ref = this.sheet ? this.sheet.options : {}, media = _ref.media, meta = _ref.meta, element = _ref.element;
      this.element = element || document.createElement('style');
      this.element.setAttribute('data-jss', '');
      if (media) this.element.setAttribute('media', media);
      if (meta) this.element.setAttribute('data-meta', meta);
      var nonce = getNonce();
      if (nonce) this.element.setAttribute('nonce', nonce);
    }
    _createClass(DomRenderer, [{
      key: 'attach',
      value: function attach() {
        if (this.element.parentNode || !this.sheet) return;
        if (this.hasInsertedRules) {
          this.deploy();
          this.hasInsertedRules = false;
        }
        insertStyle(this.element, this.sheet.options);
      }
    }, {
      key: 'detach',
      value: function detach() {
        this.element.parentNode.removeChild(this.element);
      }
    }, {
      key: 'deploy',
      value: function deploy() {
        if (!this.sheet) return;
        this.element.textContent = '\n' + this.sheet.toString() + '\n';
      }
    }, {
      key: 'insertRule',
      value: function insertRule(rule, index) {
        var sheet = this.element.sheet;
        var cssRules = sheet.cssRules;
        var str = rule.toString();
        if (!index) index = cssRules.length;
        if (!str) return false;
        try {
          sheet.insertRule(str, index);
        } catch (err) {
          (0, _warning2['default'])(false, '[JSS] Can not insert an unsupported rule \n\r%s', rule);
          return false;
        }
        this.hasInsertedRules = true;
        return cssRules[index];
      }
    }, {
      key: 'deleteRule',
      value: function deleteRule(cssRule) {
        var sheet = this.element.sheet;
        var index = this.indexOf(cssRule);
        if (index === -1) return false;
        sheet.deleteRule(index);
        return true;
      }
    }, {
      key: 'indexOf',
      value: function indexOf(cssRule) {
        var cssRules = this.element.sheet.cssRules;
        for (var _index = 0; _index < cssRules.length; _index++) {
          if (cssRule === cssRules[_index]) return _index;
        }
        return -1;
      }
    }, {
      key: 'replaceRule',
      value: function replaceRule(cssRule, rule) {
        var index = this.indexOf(cssRule);
        var newCssRule = this.insertRule(rule, index);
        this.element.sheet.deleteRule(index);
        return newCssRule;
      }
    }, {
      key: 'getRules',
      value: function getRules() {
        return this.element.sheet.cssRules;
      }
    }]);
    return DomRenderer;
  })();
  exports['default'] = DomRenderer;
})(DomRenderer);
getDefaultExportFromCjs(DomRenderer);
var VirtualRenderer = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _createClass = (function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if (("value" in descriptor)) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  })();
  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  var VirtualRenderer = (function () {
    function VirtualRenderer() {
      _classCallCheck(this, VirtualRenderer);
    }
    _createClass(VirtualRenderer, [{
      key: 'setProperty',
      value: function setProperty() {
        return true;
      }
    }, {
      key: 'getPropertyValue',
      value: function getPropertyValue() {
        return '';
      }
    }, {
      key: 'removeProperty',
      value: function removeProperty() {}
    }, {
      key: 'setSelector',
      value: function setSelector() {
        return true;
      }
    }, {
      key: 'getKey',
      value: function getKey() {
        return '';
      }
    }, {
      key: 'attach',
      value: function attach() {}
    }, {
      key: 'detach',
      value: function detach() {}
    }, {
      key: 'deploy',
      value: function deploy() {}
    }, {
      key: 'insertRule',
      value: function insertRule() {
        return false;
      }
    }, {
      key: 'deleteRule',
      value: function deleteRule() {
        return true;
      }
    }, {
      key: 'replaceRule',
      value: function replaceRule() {
        return false;
      }
    }, {
      key: 'getRules',
      value: function getRules() {}
    }, {
      key: 'indexOf',
      value: function indexOf() {
        return -1;
      }
    }]);
    return VirtualRenderer;
  })();
  exports['default'] = VirtualRenderer;
})(VirtualRenderer);
getDefaultExportFromCjs(VirtualRenderer);
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };
  var _extends = Object.assign || (function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  });
  var _createClass = (function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if (("value" in descriptor)) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  })();
  var _isInBrowser = require$$0$5;
  var _isInBrowser2 = _interopRequireDefault(_isInBrowser);
  var _StyleSheet = StyleSheet;
  var _StyleSheet2 = _interopRequireDefault(_StyleSheet);
  var _PluginsRegistry = PluginsRegistry;
  var _PluginsRegistry2 = _interopRequireDefault(_PluginsRegistry);
  var _rules = rules;
  var _rules2 = _interopRequireDefault(_rules);
  var _observables = observables;
  var _observables2 = _interopRequireDefault(_observables);
  var _functions = functions;
  var _functions2 = _interopRequireDefault(_functions);
  var _sheets = sheets;
  var _sheets2 = _interopRequireDefault(_sheets);
  var _StyleRule = StyleRule;
  var _StyleRule2 = _interopRequireDefault(_StyleRule);
  var _createGenerateClassName = createGenerateClassName;
  var _createGenerateClassName2 = _interopRequireDefault(_createGenerateClassName);
  var _createRule2 = createRule;
  var _createRule3 = _interopRequireDefault(_createRule2);
  var _DomRenderer = DomRenderer;
  var _DomRenderer2 = _interopRequireDefault(_DomRenderer);
  var _VirtualRenderer = VirtualRenderer;
  var _VirtualRenderer2 = _interopRequireDefault(_VirtualRenderer);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  var defaultPlugins = _rules2['default'].concat([_observables2['default'], _functions2['default']]);
  var instanceCounter = 0;
  var Jss = (function () {
    function Jss(options) {
      _classCallCheck(this, Jss);
      this.id = instanceCounter++;
      this.version = "9.8.7";
      this.plugins = new _PluginsRegistry2['default']();
      this.options = {
        createGenerateClassName: _createGenerateClassName2['default'],
        Renderer: _isInBrowser2['default'] ? _DomRenderer2['default'] : _VirtualRenderer2['default'],
        plugins: []
      };
      this.generateClassName = (0, _createGenerateClassName2['default'])();
      this.use.apply(this, defaultPlugins);
      this.setup(options);
    }
    _createClass(Jss, [{
      key: 'setup',
      value: function setup() {
        var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        if (options.createGenerateClassName) {
          this.options.createGenerateClassName = options.createGenerateClassName;
          this.generateClassName = options.createGenerateClassName();
        }
        if (options.insertionPoint != null) this.options.insertionPoint = options.insertionPoint;
        if (options.virtual || options.Renderer) {
          this.options.Renderer = options.Renderer || (options.virtual ? _VirtualRenderer2['default'] : _DomRenderer2['default']);
        }
        if (options.plugins) this.use.apply(this, options.plugins);
        return this;
      }
    }, {
      key: 'createStyleSheet',
      value: function createStyleSheet(styles) {
        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        var index = options.index;
        if (typeof index !== 'number') {
          index = _sheets2['default'].index === 0 ? 0 : _sheets2['default'].index + 1;
        }
        var sheet = new _StyleSheet2['default'](styles, _extends({}, options, {
          jss: this,
          generateClassName: options.generateClassName || this.generateClassName,
          insertionPoint: this.options.insertionPoint,
          Renderer: this.options.Renderer,
          index: index
        }));
        this.plugins.onProcessSheet(sheet);
        return sheet;
      }
    }, {
      key: 'removeStyleSheet',
      value: function removeStyleSheet(sheet) {
        sheet.detach();
        _sheets2['default'].remove(sheet);
        return this;
      }
    }, {
      key: 'createRule',
      value: function createRule(name) {
        var style = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
        if ((typeof name === 'undefined' ? 'undefined' : _typeof(name)) === 'object') {
          options = style;
          style = name;
          name = undefined;
        }
        var ruleOptions = options;
        ruleOptions.jss = this;
        ruleOptions.Renderer = this.options.Renderer;
        if (!ruleOptions.generateClassName) ruleOptions.generateClassName = this.generateClassName;
        if (!ruleOptions.classes) ruleOptions.classes = {};
        var rule = (0, _createRule3['default'])(name, style, ruleOptions);
        if (!ruleOptions.selector && rule instanceof _StyleRule2['default']) {
          rule.selector = '.' + ruleOptions.generateClassName(rule);
        }
        this.plugins.onProcessRule(rule);
        return rule;
      }
    }, {
      key: 'use',
      value: function use() {
        var _this = this;
        for (var _len = arguments.length, plugins = Array(_len), _key = 0; _key < _len; _key++) {
          plugins[_key] = arguments[_key];
        }
        plugins.forEach(function (plugin) {
          if (_this.options.plugins.indexOf(plugin) === -1) {
            _this.options.plugins.push(plugin);
            _this.plugins.use(plugin);
          }
        });
        return this;
      }
    }]);
    return Jss;
  })();
  exports['default'] = Jss;
})(Jss);
getDefaultExportFromCjs(Jss);
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.create = exports.createGenerateClassName = exports.sheets = exports.RuleList = exports.SheetsManager = exports.SheetsRegistry = exports.toCssValue = exports.getDynamicStyles = undefined;
  var _getDynamicStyles = getDynamicStyles;
  Object.defineProperty(exports, 'getDynamicStyles', {
    enumerable: true,
    get: function get() {
      return _interopRequireDefault(_getDynamicStyles)['default'];
    }
  });
  var _toCssValue = toCssValue;
  Object.defineProperty(exports, 'toCssValue', {
    enumerable: true,
    get: function get() {
      return _interopRequireDefault(_toCssValue)['default'];
    }
  });
  var _SheetsRegistry = SheetsRegistry;
  Object.defineProperty(exports, 'SheetsRegistry', {
    enumerable: true,
    get: function get() {
      return _interopRequireDefault(_SheetsRegistry)['default'];
    }
  });
  var _SheetsManager = SheetsManager;
  Object.defineProperty(exports, 'SheetsManager', {
    enumerable: true,
    get: function get() {
      return _interopRequireDefault(_SheetsManager)['default'];
    }
  });
  var _RuleList = RuleList;
  Object.defineProperty(exports, 'RuleList', {
    enumerable: true,
    get: function get() {
      return _interopRequireDefault(_RuleList)['default'];
    }
  });
  var _sheets = sheets;
  Object.defineProperty(exports, 'sheets', {
    enumerable: true,
    get: function get() {
      return _interopRequireDefault(_sheets)['default'];
    }
  });
  var _createGenerateClassName = createGenerateClassName;
  Object.defineProperty(exports, 'createGenerateClassName', {
    enumerable: true,
    get: function get() {
      return _interopRequireDefault(_createGenerateClassName)['default'];
    }
  });
  var _Jss = Jss;
  var _Jss2 = _interopRequireDefault(_Jss);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  var create = exports.create = function create(options) {
    return new _Jss2['default'](options);
  };
  exports['default'] = create();
})(lib$6);
getDefaultExportFromCjs(lib$6);
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _extends = Object.assign || (function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  });
  var _createClass = (function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if (("value" in descriptor)) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  })();
  exports['default'] = jssGlobal;
  var _jss = lib$6;
  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  var propKey = '@global';
  var prefixKey = '@global ';
  var GlobalContainerRule = (function () {
    function GlobalContainerRule(key, styles, options) {
      _classCallCheck(this, GlobalContainerRule);
      this.type = 'global';
      this.key = key;
      this.options = options;
      this.rules = new _jss.RuleList(_extends({}, options, {
        parent: this
      }));
      for (var selector in styles) {
        this.rules.add(selector, styles[selector], {
          selector: selector
        });
      }
      this.rules.process();
    }
    _createClass(GlobalContainerRule, [{
      key: 'getRule',
      value: function getRule(name) {
        return this.rules.get(name);
      }
    }, {
      key: 'addRule',
      value: function addRule(name, style, options) {
        var rule = this.rules.add(name, style, options);
        this.options.jss.plugins.onProcessRule(rule);
        return rule;
      }
    }, {
      key: 'indexOf',
      value: function indexOf(rule) {
        return this.rules.indexOf(rule);
      }
    }, {
      key: 'toString',
      value: function toString() {
        return this.rules.toString();
      }
    }]);
    return GlobalContainerRule;
  })();
  var GlobalPrefixedRule = (function () {
    function GlobalPrefixedRule(name, style, options) {
      _classCallCheck(this, GlobalPrefixedRule);
      this.name = name;
      this.options = options;
      var selector = name.substr(prefixKey.length);
      this.rule = options.jss.createRule(selector, style, _extends({}, options, {
        parent: this,
        selector: selector
      }));
    }
    _createClass(GlobalPrefixedRule, [{
      key: 'toString',
      value: function toString(options) {
        return this.rule.toString(options);
      }
    }]);
    return GlobalPrefixedRule;
  })();
  var separatorRegExp = /\s*,\s*/g;
  function addScope(selector, scope) {
    var parts = selector.split(separatorRegExp);
    var scoped = '';
    for (var i = 0; i < parts.length; i++) {
      scoped += scope + ' ' + parts[i].trim();
      if (parts[i + 1]) scoped += ', ';
    }
    return scoped;
  }
  function handleNestedGlobalContainerRule(rule) {
    var options = rule.options, style = rule.style;
    var rules = style[propKey];
    if (!rules) return;
    for (var name in rules) {
      options.sheet.addRule(name, rules[name], _extends({}, options, {
        selector: addScope(name, rule.selector)
      }));
    }
    delete style[propKey];
  }
  function handlePrefixedGlobalRule(rule) {
    var options = rule.options, style = rule.style;
    for (var prop in style) {
      if (prop.substr(0, propKey.length) !== propKey) continue;
      var selector = addScope(prop.substr(propKey.length), rule.selector);
      options.sheet.addRule(selector, style[prop], _extends({}, options, {
        selector: selector
      }));
      delete style[prop];
    }
  }
  function jssGlobal() {
    function onCreateRule(name, styles, options) {
      if (name === propKey) {
        return new GlobalContainerRule(name, styles, options);
      }
      if (name[0] === '@' && name.substr(0, prefixKey.length) === prefixKey) {
        return new GlobalPrefixedRule(name, styles, options);
      }
      var parent = options.parent;
      if (parent) {
        if (parent.type === 'global' || parent.options.parent.type === 'global') {
          options.global = true;
        }
      }
      if (options.global) options.selector = name;
      return null;
    }
    function onProcessRule(rule) {
      if (rule.type !== 'style') return;
      handleNestedGlobalContainerRule(rule);
      handlePrefixedGlobalRule(rule);
    }
    return {
      onCreateRule: onCreateRule,
      onProcessRule: onProcessRule
    };
  }
})(lib$7);
getDefaultExportFromCjs(lib$7);
var lib$5 = {};
var warning = function () {};
{
  warning = function (condition, format, args) {
    var len = arguments.length;
    args = new Array(len > 2 ? len - 2 : 0);
    for (var key = 2; key < len; key++) {
      args[key - 2] = arguments[key];
    }
    if (format === undefined) {
      throw new Error('`warning(condition, format, ...args)` requires a warning ' + 'message argument');
    }
    if (format.length < 10 || (/^[s\W]*$/).test(format)) {
      throw new Error('The warning format should be able to uniquely identify this ' + 'warning. Please, use a more descriptive format than: ' + format);
    }
    if (!condition) {
      var argIndex = 0;
      var message = 'Warning: ' + format.replace(/%s/g, function () {
        return args[argIndex++];
      });
      if (typeof console !== 'undefined') {
        console.error(message);
      }
      try {
        throw new Error(message);
      } catch (x) {}
    }
  };
}
var browser = warning;
Object.defineProperty(lib$5, "__esModule", {
  value: true
});
var _extends = Object.assign || (function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];
    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }
  return target;
});
lib$5.default = jssNested;
var _warning$8 = browser;
var _warning2 = _interopRequireDefault$G(_warning$8);
function _interopRequireDefault$G(obj) {
  return obj && obj.__esModule ? obj : {
    default: obj
  };
}
var separatorRegExp = /\s*,\s*/g;
var parentRegExp = /&/g;
var refRegExp = /\$([\w-]+)/g;
function jssNested() {
  function getReplaceRef(container) {
    return function (match, key) {
      var rule = container.getRule(key);
      if (rule) return rule.selector;
      (0, _warning2.default)(false, '[JSS] Could not find the referenced rule %s in %s.', key, container.options.meta || container);
      return key;
    };
  }
  var hasAnd = function hasAnd(str) {
    return str.indexOf('&') !== -1;
  };
  function replaceParentRefs(nestedProp, parentProp) {
    var parentSelectors = parentProp.split(separatorRegExp);
    var nestedSelectors = nestedProp.split(separatorRegExp);
    var result = '';
    for (var i = 0; i < parentSelectors.length; i++) {
      var parent = parentSelectors[i];
      for (var j = 0; j < nestedSelectors.length; j++) {
        var nested = nestedSelectors[j];
        if (result) result += ', ';
        result += hasAnd(nested) ? nested.replace(parentRegExp, parent) : parent + ' ' + nested;
      }
    }
    return result;
  }
  function getOptions(rule, container, options) {
    if (options) return _extends({}, options, {
      index: options.index + 1
    });
    var nestingLevel = rule.options.nestingLevel;
    nestingLevel = nestingLevel === undefined ? 1 : nestingLevel + 1;
    return _extends({}, rule.options, {
      nestingLevel: nestingLevel,
      index: container.indexOf(rule) + 1
    });
  }
  function onProcessStyle(style, rule) {
    if (rule.type !== 'style') return style;
    var container = rule.options.parent;
    var options = void 0;
    var replaceRef = void 0;
    for (var prop in style) {
      var isNested = hasAnd(prop);
      var isNestedConditional = prop[0] === '@';
      if (!isNested && !isNestedConditional) continue;
      options = getOptions(rule, container, options);
      if (isNested) {
        var selector = replaceParentRefs(prop, rule.selector);
        if (!replaceRef) replaceRef = getReplaceRef(container);
        selector = selector.replace(refRegExp, replaceRef);
        container.addRule(selector, style[prop], _extends({}, options, {
          selector: selector
        }));
      } else if (isNestedConditional) {
        container.addRule(prop, null, options).addRule(rule.key, style[prop], {
          selector: rule.selector
        });
      }
      delete style[prop];
    }
    return style;
  }
  return {
    onProcessStyle: onProcessStyle
  };
}
var lib$4 = {};
var uppercasePattern = /[A-Z]/g;
var msPattern = /^ms-/;
var cache = {};
function toHyphenLower(match) {
  return '-' + match.toLowerCase();
}
function hyphenateStyleName(name) {
  if (cache.hasOwnProperty(name)) {
    return cache[name];
  }
  var hName = name.replace(uppercasePattern, toHyphenLower);
  return cache[name] = msPattern.test(hName) ? '-' + hName : hName;
}
var hyphenateStyleName$1 = Object.freeze({
  __proto__: null,
  'default': hyphenateStyleName
});
var require$$0$4 = getAugmentedNamespace(hyphenateStyleName$1);
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports['default'] = camelCase;
  var _hyphenateStyleName = require$$0$4;
  var _hyphenateStyleName2 = _interopRequireDefault(_hyphenateStyleName);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  function convertCase(style) {
    var converted = {};
    for (var prop in style) {
      converted[(0, _hyphenateStyleName2['default'])(prop)] = style[prop];
    }
    if (style.fallbacks) {
      if (Array.isArray(style.fallbacks)) converted.fallbacks = style.fallbacks.map(convertCase); else converted.fallbacks = convertCase(style.fallbacks);
    }
    return converted;
  }
  function camelCase() {
    function onProcessStyle(style) {
      if (Array.isArray(style)) {
        for (var index = 0; index < style.length; index++) {
          style[index] = convertCase(style[index]);
        }
        return style;
      }
      return convertCase(style);
    }
    function onChangeValue(value, prop, rule) {
      var hyphenatedProp = (0, _hyphenateStyleName2['default'])(prop);
      if (prop === hyphenatedProp) return value;
      rule.prop(hyphenatedProp, value);
      return null;
    }
    return {
      onProcessStyle: onProcessStyle,
      onChangeValue: onChangeValue
    };
  }
})(lib$4);
getDefaultExportFromCjs(lib$4);
var lib$3 = {};
var defaultUnits = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports['default'] = {
    'animation-delay': 'ms',
    'animation-duration': 'ms',
    'background-position': 'px',
    'background-position-x': 'px',
    'background-position-y': 'px',
    'background-size': 'px',
    border: 'px',
    'border-bottom': 'px',
    'border-bottom-left-radius': 'px',
    'border-bottom-right-radius': 'px',
    'border-bottom-width': 'px',
    'border-left': 'px',
    'border-left-width': 'px',
    'border-radius': 'px',
    'border-right': 'px',
    'border-right-width': 'px',
    'border-spacing': 'px',
    'border-top': 'px',
    'border-top-left-radius': 'px',
    'border-top-right-radius': 'px',
    'border-top-width': 'px',
    'border-width': 'px',
    'border-after-width': 'px',
    'border-before-width': 'px',
    'border-end-width': 'px',
    'border-horizontal-spacing': 'px',
    'border-start-width': 'px',
    'border-vertical-spacing': 'px',
    bottom: 'px',
    'box-shadow': 'px',
    'column-gap': 'px',
    'column-rule': 'px',
    'column-rule-width': 'px',
    'column-width': 'px',
    'flex-basis': 'px',
    'font-size': 'px',
    'font-size-delta': 'px',
    height: 'px',
    left: 'px',
    'letter-spacing': 'px',
    'logical-height': 'px',
    'logical-width': 'px',
    margin: 'px',
    'margin-after': 'px',
    'margin-before': 'px',
    'margin-bottom': 'px',
    'margin-left': 'px',
    'margin-right': 'px',
    'margin-top': 'px',
    'max-height': 'px',
    'max-width': 'px',
    'margin-end': 'px',
    'margin-start': 'px',
    'mask-position-x': 'px',
    'mask-position-y': 'px',
    'mask-size': 'px',
    'max-logical-height': 'px',
    'max-logical-width': 'px',
    'min-height': 'px',
    'min-width': 'px',
    'min-logical-height': 'px',
    'min-logical-width': 'px',
    motion: 'px',
    'motion-offset': 'px',
    outline: 'px',
    'outline-offset': 'px',
    'outline-width': 'px',
    padding: 'px',
    'padding-bottom': 'px',
    'padding-left': 'px',
    'padding-right': 'px',
    'padding-top': 'px',
    'padding-after': 'px',
    'padding-before': 'px',
    'padding-end': 'px',
    'padding-start': 'px',
    'perspective-origin-x': '%',
    'perspective-origin-y': '%',
    perspective: 'px',
    right: 'px',
    'shape-margin': 'px',
    size: 'px',
    'text-indent': 'px',
    'text-stroke': 'px',
    'text-stroke-width': 'px',
    top: 'px',
    'transform-origin': '%',
    'transform-origin-x': '%',
    'transform-origin-y': '%',
    'transform-origin-z': '%',
    'transition-delay': 'ms',
    'transition-duration': 'ms',
    'vertical-align': 'px',
    width: 'px',
    'word-spacing': 'px',
    'box-shadow-x': 'px',
    'box-shadow-y': 'px',
    'box-shadow-blur': 'px',
    'box-shadow-spread': 'px',
    'font-line-height': 'px',
    'text-shadow-x': 'px',
    'text-shadow-y': 'px',
    'text-shadow-blur': 'px'
  };
})(defaultUnits);
getDefaultExportFromCjs(defaultUnits);
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };
  exports['default'] = defaultUnit;
  var _defaultUnits = defaultUnits;
  var _defaultUnits2 = _interopRequireDefault(_defaultUnits);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  function addCamelCasedVersion(obj) {
    var regExp = /(-[a-z])/g;
    var replace = function replace(str) {
      return str[1].toUpperCase();
    };
    var newObj = {};
    for (var key in obj) {
      newObj[key] = obj[key];
      newObj[key.replace(regExp, replace)] = obj[key];
    }
    return newObj;
  }
  var units = addCamelCasedVersion(_defaultUnits2['default']);
  function iterate(prop, value, options) {
    if (!value) return value;
    var convertedValue = value;
    var type = typeof value === 'undefined' ? 'undefined' : _typeof(value);
    if (type === 'object' && Array.isArray(value)) type = 'array';
    switch (type) {
      case 'object':
        if (prop === 'fallbacks') {
          for (var innerProp in value) {
            value[innerProp] = iterate(innerProp, value[innerProp], options);
          }
          break;
        }
        for (var _innerProp in value) {
          value[_innerProp] = iterate(prop + '-' + _innerProp, value[_innerProp], options);
        }
        break;
      case 'array':
        for (var i = 0; i < value.length; i++) {
          value[i] = iterate(prop, value[i], options);
        }
        break;
      case 'number':
        if (value !== 0) {
          convertedValue = value + (options[prop] || units[prop] || '');
        }
        break;
    }
    return convertedValue;
  }
  function defaultUnit() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var camelCasedOptions = addCamelCasedVersion(options);
    function onProcessStyle(style, rule) {
      if (rule.type !== 'style') return style;
      for (var prop in style) {
        style[prop] = iterate(prop, style[prop], camelCasedOptions);
      }
      return style;
    }
    function onChangeValue(value, prop) {
      return iterate(prop, value, camelCasedOptions);
    }
    return {
      onProcessStyle: onProcessStyle,
      onChangeValue: onChangeValue
    };
  }
})(lib$3);
getDefaultExportFromCjs(lib$3);
var lib$2 = {};
var lib$1 = {};
var prefix$1 = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _isInBrowser = require$$0$5;
  var _isInBrowser2 = _interopRequireDefault(_isInBrowser);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  var js = '';
  var css = '';
  if (_isInBrowser2['default']) {
    var jsCssMap = {
      Moz: '-moz-',
      ms: '-ms-',
      O: '-o-',
      Webkit: '-webkit-'
    };
    var style = document.createElement('p').style;
    var testProp = 'Transform';
    for (var key in jsCssMap) {
      if ((key + testProp in style)) {
        js = key;
        css = jsCssMap[key];
        break;
      }
    }
  }
  exports['default'] = {
    js: js,
    css: css
  };
})(prefix$1);
getDefaultExportFromCjs(prefix$1);
var supportedProperty = {};
var camelize$1 = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports['default'] = camelize;
  var regExp = /[-\s]+(.)?/g;
  function camelize(str) {
    return str.replace(regExp, toUpper);
  }
  function toUpper(match, c) {
    return c ? c.toUpperCase() : '';
  }
})(camelize$1);
getDefaultExportFromCjs(camelize$1);
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports['default'] = supportedProperty;
  var _isInBrowser = require$$0$5;
  var _isInBrowser2 = _interopRequireDefault(_isInBrowser);
  var _prefix = prefix$1;
  var _prefix2 = _interopRequireDefault(_prefix);
  var _camelize = camelize$1;
  var _camelize2 = _interopRequireDefault(_camelize);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  var el = void 0;
  var cache = {};
  if (_isInBrowser2['default']) {
    el = document.createElement('p');
    var computed = window.getComputedStyle(document.documentElement, '');
    for (var key in computed) {
      if (!isNaN(key)) cache[computed[key]] = computed[key];
    }
  }
  function supportedProperty(prop) {
    if (!el) return prop;
    if (cache[prop] != null) return cache[prop];
    if (((0, _camelize2['default'])(prop) in el.style)) {
      cache[prop] = prop;
    } else if ((_prefix2['default'].js + (0, _camelize2['default'])('-' + prop) in el.style)) {
      cache[prop] = _prefix2['default'].css + prop;
    } else {
      cache[prop] = false;
    }
    return cache[prop];
  }
})(supportedProperty);
getDefaultExportFromCjs(supportedProperty);
var supportedValue = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports['default'] = supportedValue;
  var _isInBrowser = require$$0$5;
  var _isInBrowser2 = _interopRequireDefault(_isInBrowser);
  var _prefix = prefix$1;
  var _prefix2 = _interopRequireDefault(_prefix);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  var cache = {};
  var el = void 0;
  if (_isInBrowser2['default']) el = document.createElement('p');
  function supportedValue(property, value) {
    if (!el) return value;
    if (typeof value !== 'string' || !isNaN(parseInt(value, 10))) return value;
    var cacheKey = property + value;
    if (cache[cacheKey] != null) return cache[cacheKey];
    try {
      el.style[property] = value;
    } catch (err) {
      cache[cacheKey] = false;
      return false;
    }
    if (el.style[property] !== '') {
      cache[cacheKey] = value;
    } else {
      value = _prefix2['default'].css + value;
      if (value === '-ms-flex') value = '-ms-flexbox';
      el.style[property] = value;
      if (el.style[property] !== '') cache[cacheKey] = value;
    }
    if (!cache[cacheKey]) cache[cacheKey] = false;
    el.style[property] = '';
    return cache[cacheKey];
  }
})(supportedValue);
getDefaultExportFromCjs(supportedValue);
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.supportedValue = exports.supportedProperty = exports.prefix = undefined;
  var _prefix = prefix$1;
  var _prefix2 = _interopRequireDefault(_prefix);
  var _supportedProperty = supportedProperty;
  var _supportedProperty2 = _interopRequireDefault(_supportedProperty);
  var _supportedValue = supportedValue;
  var _supportedValue2 = _interopRequireDefault(_supportedValue);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      'default': obj
    };
  }
  exports['default'] = {
    prefix: _prefix2['default'],
    supportedProperty: _supportedProperty2['default'],
    supportedValue: _supportedValue2['default']
  };
  exports.prefix = _prefix2['default'];
  exports.supportedProperty = _supportedProperty2['default'];
  exports.supportedValue = _supportedValue2['default'];
})(lib$1);
getDefaultExportFromCjs(lib$1);
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports['default'] = jssVendorPrefixer;
  var _cssVendor = lib$1;
  var vendor = _interopRequireWildcard(_cssVendor);
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    } else {
      var newObj = {};
      if (obj != null) {
        for (var key in obj) {
          if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
        }
      }
      newObj['default'] = obj;
      return newObj;
    }
  }
  function jssVendorPrefixer() {
    function onProcessRule(rule) {
      if (rule.type === 'keyframes') {
        rule.key = '@' + vendor.prefix.css + rule.key.substr(1);
      }
    }
    function onProcessStyle(style, rule) {
      if (rule.type !== 'style') return style;
      for (var prop in style) {
        var value = style[prop];
        var changeProp = false;
        var supportedProp = vendor.supportedProperty(prop);
        if (supportedProp && supportedProp !== prop) changeProp = true;
        var changeValue = false;
        var supportedValue = vendor.supportedValue(supportedProp, value);
        if (supportedValue && supportedValue !== value) changeValue = true;
        if (changeProp || changeValue) {
          if (changeProp) delete style[prop];
          style[supportedProp || prop] = supportedValue || value;
        }
      }
      return style;
    }
    function onChangeValue(value, prop) {
      return vendor.supportedValue(prop, value);
    }
    return {
      onProcessRule: onProcessRule,
      onProcessStyle: onProcessStyle,
      onChangeValue: onChangeValue
    };
  }
})(lib$2);
getDefaultExportFromCjs(lib$2);
var lib = {};
(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports['default'] = jssPropsSort;
  function jssPropsSort() {
    function sort(prop0, prop1) {
      return prop0.length - prop1.length;
    }
    function onProcessStyle(style, rule) {
      if (rule.type !== 'style') return style;
      var newStyle = {};
      var props = Object.keys(style).sort(sort);
      for (var prop in props) {
        newStyle[props[prop]] = style[props[prop]];
      }
      return newStyle;
    }
    return {
      onProcessStyle: onProcessStyle
    };
  }
})(lib);
getDefaultExportFromCjs(lib);
var _interopRequireDefault$F = interopRequireDefault.exports;
Object.defineProperty(jssPreset$1, "__esModule", {
  value: true
});
jssPreset$1.default = void 0;
var _jssGlobal = _interopRequireDefault$F(lib$7);
var _jssNested = _interopRequireDefault$F(lib$5);
var _jssCamelCase = _interopRequireDefault$F(lib$4);
var _jssDefaultUnit = _interopRequireDefault$F(lib$3);
var _jssVendorPrefixer = _interopRequireDefault$F(lib$2);
var _jssPropsSort = _interopRequireDefault$F(lib);
function jssPreset() {
  return {
    plugins: [(0, _jssGlobal.default)(), (0, _jssNested.default)(), (0, _jssCamelCase.default)(), (0, _jssDefaultUnit.default)(), typeof window === 'undefined' ? null : (0, _jssVendorPrefixer.default)(), (0, _jssPropsSort.default)()]
  };
}
var _default$H = jssPreset;
jssPreset$1.default = _default$H;
var MuiThemeProvider = {};
var interopRequireWildcard = {
  exports: {}
};
(function (module) {
  var _typeof = _typeof$1.exports["default"];
  function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;
    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
      return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
  }
  function _interopRequireWildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
      return obj;
    }
    if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
      return {
        "default": obj
      };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj["default"] = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
  (module.exports = _interopRequireWildcard, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(interopRequireWildcard);
getDefaultExportFromCjs(interopRequireWildcard.exports);
var classCallCheck = {
  exports: {}
};
(function (module) {
  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  (module.exports = _classCallCheck, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(classCallCheck);
getDefaultExportFromCjs(classCallCheck.exports);
var createClass = {
  exports: {}
};
(function (module) {
  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if (("value" in descriptor)) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }
  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    Object.defineProperty(Constructor, "prototype", {
      writable: false
    });
    return Constructor;
  }
  (module.exports = _createClass, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(createClass);
getDefaultExportFromCjs(createClass.exports);
var possibleConstructorReturn = {
  exports: {}
};
var assertThisInitialized = {
  exports: {}
};
(function (module) {
  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
  }
  (module.exports = _assertThisInitialized, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(assertThisInitialized);
getDefaultExportFromCjs(assertThisInitialized.exports);
(function (module) {
  var _typeof = _typeof$1.exports["default"];
  var assertThisInitialized$1 = assertThisInitialized.exports;
  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    } else if (call !== void 0) {
      throw new TypeError("Derived constructors may only return object or undefined");
    }
    return assertThisInitialized$1(self);
  }
  (module.exports = _possibleConstructorReturn, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(possibleConstructorReturn);
getDefaultExportFromCjs(possibleConstructorReturn.exports);
var getPrototypeOf$1 = {
  exports: {}
};
(function (module) {
  function _getPrototypeOf(o) {
    (module.exports = _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    }, module.exports.__esModule = true, module.exports["default"] = module.exports);
    return _getPrototypeOf(o);
  }
  (module.exports = _getPrototypeOf, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(getPrototypeOf$1);
getDefaultExportFromCjs(getPrototypeOf$1.exports);
var inherits = {
  exports: {}
};
var setPrototypeOf = {
  exports: {}
};
(function (module) {
  function _setPrototypeOf(o, p) {
    (module.exports = _setPrototypeOf = Object.setPrototypeOf || (function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    }), module.exports.__esModule = true, module.exports["default"] = module.exports);
    return _setPrototypeOf(o, p);
  }
  (module.exports = _setPrototypeOf, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(setPrototypeOf);
getDefaultExportFromCjs(setPrototypeOf.exports);
(function (module) {
  var setPrototypeOf$1 = setPrototypeOf.exports;
  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    Object.defineProperty(subClass, "prototype", {
      writable: false
    });
    if (superClass) setPrototypeOf$1(subClass, superClass);
  }
  (module.exports = _inherits, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(inherits);
getDefaultExportFromCjs(inherits.exports);
function createBroadcast(initialState) {
  var listeners = {};
  var id = 1;
  var _state = initialState;
  function getState() {
    return _state;
  }
  function setState(state) {
    _state = state;
    var keys = Object.keys(listeners);
    var i = 0;
    var len = keys.length;
    for (; i < len; i++) {
      if (listeners[keys[i]]) {
        listeners[keys[i]](state);
      }
    }
  }
  function subscribe(listener) {
    if (typeof listener !== 'function') {
      throw new Error('listener must be a function.');
    }
    var currentId = id;
    listeners[currentId] = listener;
    id += 1;
    return currentId;
  }
  function unsubscribe(id) {
    delete listeners[id];
  }
  return {
    getState: getState,
    setState: setState,
    subscribe: subscribe,
    unsubscribe: unsubscribe
  };
}
var brcast_es = Object.freeze({
  __proto__: null,
  'default': createBroadcast
});
var require$$12$3 = getAugmentedNamespace(brcast_es);
var themeListener$1 = {};
var _interopRequireDefault$E = interopRequireDefault.exports;
Object.defineProperty(themeListener$1, "__esModule", {
  value: true
});
themeListener$1.default = themeListener$1.CHANNEL = void 0;
var _defineProperty2$b = _interopRequireDefault$E(defineProperty$1.exports);
var CHANNEL = '__THEMING__';
themeListener$1.CHANNEL = CHANNEL;
var themeListener = {
  contextTypes: (0, _defineProperty2$b.default)({}, CHANNEL, function () {}),
  initial: function initial(context) {
    if (!context[CHANNEL]) {
      return null;
    }
    return context[CHANNEL].getState();
  },
  subscribe: function subscribe(context, cb) {
    if (!context[CHANNEL]) {
      return null;
    }
    return context[CHANNEL].subscribe(cb);
  },
  unsubscribe: function unsubscribe(context, subscriptionId) {
    if (context[CHANNEL]) {
      context[CHANNEL].unsubscribe(subscriptionId);
    }
  }
};
var _default$G = themeListener;
themeListener$1.default = _default$G;
const require$$9$5 = _dll_react;
const require$$10$6 = _dll_prop_types;
var _interopRequireWildcard$1 = interopRequireWildcard.exports;
var _interopRequireDefault$D = interopRequireDefault.exports;
Object.defineProperty(MuiThemeProvider, "__esModule", {
  value: true
});
MuiThemeProvider.default = MuiThemeProvider.MuiThemeProviderOld = void 0;
var _extends2$i = _interopRequireDefault$D(_extends$1.exports);
var _defineProperty2$a = _interopRequireDefault$D(defineProperty$1.exports);
var _classCallCheck2$c = _interopRequireDefault$D(classCallCheck.exports);
var _createClass2$c = _interopRequireDefault$D(createClass.exports);
var _possibleConstructorReturn2$b = _interopRequireDefault$D(possibleConstructorReturn.exports);
var _getPrototypeOf2$4 = _interopRequireDefault$D(getPrototypeOf$1.exports);
var _inherits2$b = _interopRequireDefault$D(inherits.exports);
var _react$r = _interopRequireDefault$D(require$$9$5);
var _propTypes$l = _interopRequireDefault$D(require$$10$6);
var _warning$7 = _interopRequireDefault$D(warning_1);
var _brcast = _interopRequireDefault$D(require$$12$3);
var _utils$e = require$$13$2;
var _themeListener$2 = _interopRequireWildcard$1(themeListener$1);
var MuiThemeProviderOld = (function (_React$Component) {
  (0, _inherits2$b.default)(MuiThemeProviderOld, _React$Component);
  function MuiThemeProviderOld(props, context) {
    var _this;
    (0, _classCallCheck2$c.default)(this, MuiThemeProviderOld);
    _this = (0, _possibleConstructorReturn2$b.default)(this, (0, _getPrototypeOf2$4.default)(MuiThemeProviderOld).call(this));
    _this.broadcast = (0, _brcast.default)();
    _this.outerTheme = _themeListener$2.default.initial(context);
    _this.broadcast.setState(_this.mergeOuterLocalTheme(props.theme));
    return _this;
  }
  (0, _createClass2$c.default)(MuiThemeProviderOld, [{
    key: "getChildContext",
    value: function getChildContext() {
      var _ref;
      var _this$props = this.props, disableStylesGeneration = _this$props.disableStylesGeneration, sheetsCache = _this$props.sheetsCache, sheetsManager = _this$props.sheetsManager;
      var muiThemeProviderOptions = this.context.muiThemeProviderOptions || ({});
      if (disableStylesGeneration !== undefined) {
        muiThemeProviderOptions.disableStylesGeneration = disableStylesGeneration;
      }
      if (sheetsCache !== undefined) {
        muiThemeProviderOptions.sheetsCache = sheetsCache;
      }
      if (sheetsManager !== undefined) {
        muiThemeProviderOptions.sheetsManager = sheetsManager;
      }
      return (_ref = {}, (0, _defineProperty2$a.default)(_ref, _themeListener$2.CHANNEL, this.broadcast), (0, _defineProperty2$a.default)(_ref, "muiThemeProviderOptions", muiThemeProviderOptions), _ref);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      this.unsubscribeId = _themeListener$2.default.subscribe(this.context, function (outerTheme) {
        _this2.outerTheme = outerTheme;
        _this2.broadcast.setState(_this2.mergeOuterLocalTheme(_this2.props.theme));
      });
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.theme !== prevProps.theme) {
        this.broadcast.setState(this.mergeOuterLocalTheme(this.props.theme));
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.unsubscribeId !== null) {
        _themeListener$2.default.unsubscribe(this.context, this.unsubscribeId);
      }
    }
  }, {
    key: "mergeOuterLocalTheme",
    value: function mergeOuterLocalTheme(localTheme) {
      if (typeof localTheme === 'function') {
        (0, _warning$7.default)(this.outerTheme, ['Material-UI: you are providing a theme function property ' + 'to the MuiThemeProvider component:', '<MuiThemeProvider theme={outerTheme => outerTheme} />', 'However, no outer theme is present.', 'Make sure a theme is already injected higher in the React tree ' + 'or provide a theme object.'].join('\n'));
        return localTheme(this.outerTheme);
      }
      if (!this.outerTheme) {
        return localTheme;
      }
      return (0, _extends2$i.default)({}, this.outerTheme, localTheme);
    }
  }, {
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }]);
  return MuiThemeProviderOld;
})(_react$r.default.Component);
MuiThemeProvider.MuiThemeProviderOld = MuiThemeProviderOld;
MuiThemeProviderOld.propTypes = {
  children: _propTypes$l.default.node.isRequired,
  disableStylesGeneration: _propTypes$l.default.bool,
  sheetsCache: _propTypes$l.default.object,
  sheetsManager: _propTypes$l.default.object,
  theme: _propTypes$l.default.oneOfType([_propTypes$l.default.object, _propTypes$l.default.func]).isRequired
};
{
  MuiThemeProviderOld.propTypes = (0, _utils$e.exactProp)(MuiThemeProviderOld.propTypes);
}
MuiThemeProviderOld.childContextTypes = (0, _extends2$i.default)({}, _themeListener$2.default.contextTypes, {
  muiThemeProviderOptions: _propTypes$l.default.object
});
MuiThemeProviderOld.contextTypes = (0, _extends2$i.default)({}, _themeListener$2.default.contextTypes, {
  muiThemeProviderOptions: _propTypes$l.default.object
});
if (!_utils$e.ponyfillGlobal.__MUI_STYLES__) {
  _utils$e.ponyfillGlobal.__MUI_STYLES__ = {};
}
if (!_utils$e.ponyfillGlobal.__MUI_STYLES__.MuiThemeProvider) {
  _utils$e.ponyfillGlobal.__MUI_STYLES__.MuiThemeProvider = MuiThemeProviderOld;
}
var _default$F = _utils$e.ponyfillGlobal.__MUI_STYLES__.MuiThemeProvider;
MuiThemeProvider.default = _default$F;
var createStyles$1 = {};
Object.defineProperty(createStyles$1, "__esModule", {
  value: true
});
createStyles$1.default = createStyles;
function createStyles(styles) {
  return styles;
}
var withStyles = {};
var reactIs = reactIs$1.exports;
var REACT_STATICS = {
  childContextTypes: true,
  contextType: true,
  contextTypes: true,
  defaultProps: true,
  displayName: true,
  getDefaultProps: true,
  getDerivedStateFromError: true,
  getDerivedStateFromProps: true,
  mixins: true,
  propTypes: true,
  type: true
};
var KNOWN_STATICS = {
  name: true,
  length: true,
  prototype: true,
  caller: true,
  callee: true,
  arguments: true,
  arity: true
};
var FORWARD_REF_STATICS = {
  '$$typeof': true,
  render: true,
  defaultProps: true,
  displayName: true,
  propTypes: true
};
var MEMO_STATICS = {
  '$$typeof': true,
  compare: true,
  defaultProps: true,
  displayName: true,
  propTypes: true,
  type: true
};
var TYPE_STATICS = {};
TYPE_STATICS[reactIs.ForwardRef] = FORWARD_REF_STATICS;
TYPE_STATICS[reactIs.Memo] = MEMO_STATICS;
function getStatics(component) {
  if (reactIs.isMemo(component)) {
    return MEMO_STATICS;
  }
  return TYPE_STATICS[component['$$typeof']] || REACT_STATICS;
}
var defineProperty = Object.defineProperty;
var getOwnPropertyNames = Object.getOwnPropertyNames;
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
var getPrototypeOf = Object.getPrototypeOf;
var objectPrototype = Object.prototype;
function hoistNonReactStatics(targetComponent, sourceComponent, blacklist) {
  if (typeof sourceComponent !== 'string') {
    if (objectPrototype) {
      var inheritedComponent = getPrototypeOf(sourceComponent);
      if (inheritedComponent && inheritedComponent !== objectPrototype) {
        hoistNonReactStatics(targetComponent, inheritedComponent, blacklist);
      }
    }
    var keys = getOwnPropertyNames(sourceComponent);
    if (getOwnPropertySymbols) {
      keys = keys.concat(getOwnPropertySymbols(sourceComponent));
    }
    var targetStatics = getStatics(targetComponent);
    var sourceStatics = getStatics(sourceComponent);
    for (var i = 0; i < keys.length; ++i) {
      var key = keys[i];
      if (!KNOWN_STATICS[key] && !(blacklist && blacklist[key]) && !(sourceStatics && sourceStatics[key]) && !(targetStatics && targetStatics[key])) {
        var descriptor = getOwnPropertyDescriptor(sourceComponent, key);
        try {
          defineProperty(targetComponent, key, descriptor);
        } catch (e) {}
      }
    }
  }
  return targetComponent;
}
var hoistNonReactStatics_cjs = hoistNonReactStatics;
var reactJssContext = {};
Object.defineProperty(reactJssContext, "__esModule", {
  value: true
});
reactJssContext.default = void 0;
var ns = {
  jss: '64a55d578f856d258dc345b094a2a2b3',
  sheetsRegistry: 'd4bd0baacbc52bbd48bbb9eb24344ecd',
  sheetOptions: '6fc570d6bd61383819d0f9e7407c452d'
};
var _default$E = ns;
reactJssContext.default = _default$E;
var mergeClasses$1 = {};
var _interopRequireDefault$C = interopRequireDefault.exports;
Object.defineProperty(mergeClasses$1, "__esModule", {
  value: true
});
mergeClasses$1.default = void 0;
var _extends2$h = _interopRequireDefault$C(_extends$1.exports);
var _warning$6 = _interopRequireDefault$C(warning_1);
var _utils$d = require$$13$2;
function mergeClasses() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var baseClasses = options.baseClasses, newClasses = options.newClasses, Component = options.Component;
  if (!newClasses) {
    return baseClasses;
  }
  var nextClasses = (0, _extends2$h.default)({}, baseClasses);
  if (typeof newClasses === 'string') {
    (0, _warning$6.default)(false, [("Material-UI: the value `").concat(newClasses, "` ") + ("provided to the classes property of ").concat((0, _utils$d.getDisplayName)(Component), " is incorrect."), 'You might want to use the className property instead.'].join('\n'));
    return baseClasses;
  }
  Object.keys(newClasses).forEach(function (key) {
    (0, _warning$6.default)(baseClasses[key] || !newClasses[key], [("Material-UI: the key `").concat(key, "` ") + ("provided to the classes property is not implemented in ").concat((0, _utils$d.getDisplayName)(Component), "."), ("You can only override one of the following: ").concat(Object.keys(baseClasses).join(','), ".")].join('\n'));
    (0, _warning$6.default)(!newClasses[key] || typeof newClasses[key] === 'string', [("Material-UI: the key `").concat(key, "` ") + ("provided to the classes property is not valid for ").concat((0, _utils$d.getDisplayName)(Component), "."), ("You need to provide a non empty string instead of: ").concat(newClasses[key], ".")].join('\n'));
    if (newClasses[key]) {
      nextClasses[key] = ("").concat(baseClasses[key], " ").concat(newClasses[key]);
    }
  });
  return nextClasses;
}
var _default$D = mergeClasses;
mergeClasses$1.default = _default$D;
var multiKeyStore$1 = {};
Object.defineProperty(multiKeyStore$1, "__esModule", {
  value: true
});
multiKeyStore$1.default = void 0;
var multiKeyStore = {
  set: function set(cache, key1, key2, value) {
    var subCache = cache.get(key1);
    if (!subCache) {
      subCache = new Map();
      cache.set(key1, subCache);
    }
    subCache.set(key2, value);
  },
  get: function get(cache, key1, key2) {
    var subCache = cache.get(key1);
    return subCache ? subCache.get(key2) : undefined;
  },
  delete: function _delete(cache, key1, key2) {
    var subCache = cache.get(key1);
    subCache.delete(key2);
  }
};
var _default$C = multiKeyStore;
multiKeyStore$1.default = _default$C;
var getStylesCreator$1 = {};
var _interopRequireDefault$B = interopRequireDefault.exports;
Object.defineProperty(getStylesCreator$1, "__esModule", {
  value: true
});
getStylesCreator$1.default = void 0;
var _extends2$g = _interopRequireDefault$B(_extends$1.exports);
var _typeof2$1 = _interopRequireDefault$B(_typeof$1.exports);
var _warning$5 = _interopRequireDefault$B(warning_1);
var _deepmerge = _interopRequireDefault$B(umd.exports);
function arrayMerge(destination, source) {
  return source;
}
function getStylesCreator(stylesOrCreator) {
  var themingEnabled = typeof stylesOrCreator === 'function';
  (0, _warning$5.default)((0, _typeof2$1.default)(stylesOrCreator) === 'object' || themingEnabled, ['Material-UI: the first argument provided to withStyles() is invalid.', 'You need to provide a function generating the styles or a styles object.'].join('\n'));
  function create(theme, name) {
    var styles = themingEnabled ? stylesOrCreator(theme) : stylesOrCreator;
    if (!name || !theme.overrides || !theme.overrides[name]) {
      return styles;
    }
    var overrides = theme.overrides[name];
    var stylesWithOverrides = (0, _extends2$g.default)({}, styles);
    Object.keys(overrides).forEach(function (key) {
      (0, _warning$5.default)(stylesWithOverrides[key], ['Material-UI: you are trying to override a style that does not exist.', ("Fix the `").concat(key, "` key of `theme.overrides.").concat(name, "`.")].join('\n'));
      stylesWithOverrides[key] = (0, _deepmerge.default)(stylesWithOverrides[key], overrides[key], {
        arrayMerge: arrayMerge
      });
    });
    return stylesWithOverrides;
  }
  return {
    create: create,
    options: {},
    themingEnabled: themingEnabled
  };
}
var _default$B = getStylesCreator;
getStylesCreator$1.default = _default$B;
var getThemeProps$1 = {};
Object.defineProperty(getThemeProps$1, "__esModule", {
  value: true
});
getThemeProps$1.default = void 0;
function getThemeProps(params) {
  var theme = params.theme, name = params.name, props = params.props;
  if (!theme.props || !name || !theme.props[name]) {
    return props;
  }
  var defaultProps = theme.props[name];
  var propName;
  for (propName in defaultProps) {
    if (props[propName] === undefined) {
      props[propName] = defaultProps[propName];
    }
  }
  return props;
}
var _default$A = getThemeProps;
getThemeProps$1.default = _default$A;
const require$$9$4 = _dll_react;
const require$$10$5 = _dll_prop_types;
var _interopRequireDefault$A = interopRequireDefault.exports;
Object.defineProperty(withStyles, "__esModule", {
  value: true
});
withStyles.default = withStyles.sheetsManager = void 0;
var _defineProperty2$9 = _interopRequireDefault$A(defineProperty$1.exports);
var _extends3 = _interopRequireDefault$A(_extends$1.exports);
var _classCallCheck2$b = _interopRequireDefault$A(classCallCheck.exports);
var _createClass2$b = _interopRequireDefault$A(createClass.exports);
var _possibleConstructorReturn2$a = _interopRequireDefault$A(possibleConstructorReturn.exports);
var _getPrototypeOf2$3 = _interopRequireDefault$A(getPrototypeOf$1.exports);
var _inherits2$a = _interopRequireDefault$A(inherits.exports);
var _objectWithoutProperties2$f = _interopRequireDefault$A(objectWithoutProperties.exports);
var _react$q = _interopRequireDefault$A(require$$9$4);
var _propTypes$k = _interopRequireDefault$A(require$$10$5);
var _warning$4 = _interopRequireDefault$A(warning_1);
var _hoistNonReactStatics$1 = _interopRequireDefault$A(hoistNonReactStatics_cjs);
var _utils$c = require$$13$2;
var _jss = lib$6;
var _reactJssContext = _interopRequireDefault$A(reactJssContext);
var _jssPreset = _interopRequireDefault$A(jssPreset$1);
var _mergeClasses = _interopRequireDefault$A(mergeClasses$1);
var _multiKeyStore = _interopRequireDefault$A(multiKeyStore$1);
var _createMuiTheme$1 = _interopRequireDefault$A(createMuiTheme$1);
var _themeListener$1 = _interopRequireDefault$A(themeListener$1);
var _createGenerateClassName = _interopRequireDefault$A(createGenerateClassName$2);
var _getStylesCreator = _interopRequireDefault$A(getStylesCreator$1);
var _getThemeProps = _interopRequireDefault$A(getThemeProps$1);
var jss = (0, _jss.create)((0, _jssPreset.default)());
var generateClassName = (0, _createGenerateClassName.default)();
var indexCounter = -10e10;
var sheetsManager = new Map();
withStyles.sheetsManager = sheetsManager;
var noopTheme = {};
var defaultTheme$1 = (0, _createMuiTheme$1.default)({
  typography: {
    suppressWarning: true
  }
});
var withStylesOld = function withStylesOld(stylesOrCreator) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return function (Component) {
    var _extends2;
    var _options$withTheme = options.withTheme, withTheme = _options$withTheme === void 0 ? false : _options$withTheme, _options$flip = options.flip, flip = _options$flip === void 0 ? null : _options$flip, name = options.name, styleSheetOptions = (0, _objectWithoutProperties2$f.default)(options, ["withTheme", "flip", "name"]);
    var stylesCreator = (0, _getStylesCreator.default)(stylesOrCreator);
    var listenToTheme = stylesCreator.themingEnabled || typeof name === 'string' || withTheme;
    indexCounter += 1;
    stylesCreator.options.index = indexCounter;
    (0, _warning$4.default)(indexCounter < 0, ['Material-UI: you might have a memory leak.', 'The indexCounter is not supposed to grow that much.'].join('\n'));
    var WithStyles = (function (_React$Component) {
      (0, _inherits2$a.default)(WithStyles, _React$Component);
      function WithStyles(props, context) {
        var _this;
        (0, _classCallCheck2$b.default)(this, WithStyles);
        _this = (0, _possibleConstructorReturn2$a.default)(this, (0, _getPrototypeOf2$3.default)(WithStyles).call(this, props, context));
        _this.jss = context[_reactJssContext.default.jss] || jss;
        _this.sheetsManager = sheetsManager;
        _this.unsubscribeId = null;
        var muiThemeProviderOptions = context.muiThemeProviderOptions;
        if (muiThemeProviderOptions) {
          if (muiThemeProviderOptions.sheetsManager) {
            _this.sheetsManager = muiThemeProviderOptions.sheetsManager;
          }
          _this.sheetsCache = muiThemeProviderOptions.sheetsCache;
          _this.disableStylesGeneration = muiThemeProviderOptions.disableStylesGeneration;
        }
        _this.stylesCreatorSaved = stylesCreator;
        _this.sheetOptions = (0, _extends3.default)({
          generateClassName: generateClassName
        }, context[_reactJssContext.default.sheetOptions]);
        _this.theme = listenToTheme ? _themeListener$1.default.initial(context) || defaultTheme$1 : noopTheme;
        _this.attach(_this.theme);
        _this.cacheClasses = {
          value: null,
          lastProp: null,
          lastJSS: {}
        };
        return _this;
      }
      (0, _createClass2$b.default)(WithStyles, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          var _this2 = this;
          if (!listenToTheme) {
            return;
          }
          this.unsubscribeId = _themeListener$1.default.subscribe(this.context, function (theme) {
            var oldTheme = _this2.theme;
            _this2.theme = theme;
            _this2.attach(_this2.theme);
            _this2.setState({}, function () {
              _this2.detach(oldTheme);
            });
          });
        }
      }, {
        key: "componentDidUpdate",
        value: function componentDidUpdate() {
          if (this.stylesCreatorSaved === stylesCreator || "development" === 'production') {
            return;
          }
          this.detach(this.theme);
          this.stylesCreatorSaved = stylesCreator;
          this.attach(this.theme);
          this.forceUpdate();
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          this.detach(this.theme);
          if (this.unsubscribeId !== null) {
            _themeListener$1.default.unsubscribe(this.context, this.unsubscribeId);
          }
        }
      }, {
        key: "getClasses",
        value: function getClasses() {
          if (this.disableStylesGeneration) {
            return this.props.classes || ({});
          }
          var generate = false;
          var sheetManager = _multiKeyStore.default.get(this.sheetsManager, this.stylesCreatorSaved, this.theme);
          if (sheetManager.sheet.classes !== this.cacheClasses.lastJSS) {
            this.cacheClasses.lastJSS = sheetManager.sheet.classes;
            generate = true;
          }
          if (this.props.classes !== this.cacheClasses.lastProp) {
            this.cacheClasses.lastProp = this.props.classes;
            generate = true;
          }
          if (generate) {
            this.cacheClasses.value = (0, _mergeClasses.default)({
              baseClasses: this.cacheClasses.lastJSS,
              newClasses: this.props.classes,
              Component: Component
            });
          }
          return this.cacheClasses.value;
        }
      }, {
        key: "attach",
        value: function attach(theme) {
          if (this.disableStylesGeneration) {
            return;
          }
          var stylesCreatorSaved = this.stylesCreatorSaved;
          var sheetManager = _multiKeyStore.default.get(this.sheetsManager, stylesCreatorSaved, theme);
          if (!sheetManager) {
            sheetManager = {
              refs: 0,
              sheet: null
            };
            _multiKeyStore.default.set(this.sheetsManager, stylesCreatorSaved, theme, sheetManager);
          }
          if (sheetManager.refs === 0) {
            var sheet;
            if (this.sheetsCache) {
              sheet = _multiKeyStore.default.get(this.sheetsCache, stylesCreatorSaved, theme);
            }
            if (!sheet) {
              sheet = this.createSheet(theme);
              sheet.attach();
              if (this.sheetsCache) {
                _multiKeyStore.default.set(this.sheetsCache, stylesCreatorSaved, theme, sheet);
              }
            }
            sheetManager.sheet = sheet;
            var sheetsRegistry = this.context[_reactJssContext.default.sheetsRegistry];
            if (sheetsRegistry) {
              sheetsRegistry.add(sheet);
            }
          }
          sheetManager.refs += 1;
        }
      }, {
        key: "createSheet",
        value: function createSheet(theme) {
          var styles = this.stylesCreatorSaved.create(theme, name);
          var meta = name;
          if (!meta) {
            meta = (0, _utils$c.getDisplayName)(Component);
            (0, _warning$4.default)(typeof meta === 'string', ['Material-UI: the component displayName is invalid. It needs to be a string.', ("Please fix the following component: ").concat(Component, ".")].join('\n'));
          }
          var sheet = this.jss.createStyleSheet(styles, (0, _extends3.default)({
            meta: meta,
            classNamePrefix: meta,
            flip: typeof flip === 'boolean' ? flip : theme.direction === 'rtl',
            link: false
          }, this.sheetOptions, this.stylesCreatorSaved.options, {
            name: name || Component.displayName
          }, styleSheetOptions));
          return sheet;
        }
      }, {
        key: "detach",
        value: function detach(theme) {
          if (this.disableStylesGeneration) {
            return;
          }
          var sheetManager = _multiKeyStore.default.get(this.sheetsManager, this.stylesCreatorSaved, theme);
          sheetManager.refs -= 1;
          if (sheetManager.refs === 0) {
            _multiKeyStore.default.delete(this.sheetsManager, this.stylesCreatorSaved, theme);
            this.jss.removeStyleSheet(sheetManager.sheet);
            var sheetsRegistry = this.context[_reactJssContext.default.sheetsRegistry];
            if (sheetsRegistry) {
              sheetsRegistry.remove(sheetManager.sheet);
            }
          }
        }
      }, {
        key: "render",
        value: function render() {
          var _this$props = this.props;
          _this$props.classes;
          var innerRef = _this$props.innerRef, other = (0, _objectWithoutProperties2$f.default)(_this$props, ["classes", "innerRef"]);
          var more = (0, _getThemeProps.default)({
            theme: this.theme,
            name: name,
            props: other
          });
          if (withTheme && !more.theme) {
            more.theme = this.theme;
          }
          return _react$q.default.createElement(Component, (0, _extends3.default)({}, more, {
            classes: this.getClasses(),
            ref: innerRef
          }));
        }
      }]);
      return WithStyles;
    })(_react$q.default.Component);
    WithStyles.propTypes = {
      classes: _propTypes$k.default.object,
      innerRef: _propTypes$k.default.oneOfType([_propTypes$k.default.func, _propTypes$k.default.object])
    };
    WithStyles.contextTypes = (0, _extends3.default)((_extends2 = {
      muiThemeProviderOptions: _propTypes$k.default.object
    }, (0, _defineProperty2$9.default)(_extends2, _reactJssContext.default.jss, _propTypes$k.default.object), (0, _defineProperty2$9.default)(_extends2, _reactJssContext.default.sheetOptions, _propTypes$k.default.object), (0, _defineProperty2$9.default)(_extends2, _reactJssContext.default.sheetsRegistry, _propTypes$k.default.object), _extends2), listenToTheme ? _themeListener$1.default.contextTypes : {});
    {
      WithStyles.displayName = ("WithStyles(").concat((0, _utils$c.getDisplayName)(Component), ")");
    }
    (0, _hoistNonReactStatics$1.default)(WithStyles, Component);
    {
      WithStyles.Naked = Component;
      WithStyles.options = options;
    }
    return WithStyles;
  };
};
if (!_utils$c.ponyfillGlobal.__MUI_STYLES__) {
  _utils$c.ponyfillGlobal.__MUI_STYLES__ = {};
}
if (!_utils$c.ponyfillGlobal.__MUI_STYLES__.withStyles) {
  _utils$c.ponyfillGlobal.__MUI_STYLES__.withStyles = withStylesOld;
}
var _default$z = function _default(styles, options) {
  return _utils$c.ponyfillGlobal.__MUI_STYLES__.withStyles(styles, (0, _extends3.default)({
    defaultTheme: defaultTheme$1
  }, options));
};
withStyles.default = _default$z;
var withTheme = {};
const require$$8$3 = _dll_react;
const require$$9$3 = _dll_prop_types;
var _interopRequireDefault$z = interopRequireDefault.exports;
Object.defineProperty(withTheme, "__esModule", {
  value: true
});
withTheme.default = void 0;
var _extends2$f = _interopRequireDefault$z(_extends$1.exports);
var _objectWithoutProperties2$e = _interopRequireDefault$z(objectWithoutProperties.exports);
var _classCallCheck2$a = _interopRequireDefault$z(classCallCheck.exports);
var _createClass2$a = _interopRequireDefault$z(createClass.exports);
var _possibleConstructorReturn2$9 = _interopRequireDefault$z(possibleConstructorReturn.exports);
var _getPrototypeOf2$2 = _interopRequireDefault$z(getPrototypeOf$1.exports);
var _inherits2$9 = _interopRequireDefault$z(inherits.exports);
var _react$p = _interopRequireDefault$z(require$$8$3);
var _propTypes$j = _interopRequireDefault$z(require$$9$3);
var _hoistNonReactStatics = _interopRequireDefault$z(hoistNonReactStatics_cjs);
var _utils$b = require$$13$2;
var _createMuiTheme = _interopRequireDefault$z(createMuiTheme$1);
var _themeListener = _interopRequireDefault$z(themeListener$1);
var defaultTheme;
function getDefaultTheme() {
  if (defaultTheme) {
    return defaultTheme;
  }
  defaultTheme = (0, _createMuiTheme.default)({
    typography: {
      suppressWarning: true
    }
  });
  return defaultTheme;
}
var withThemeOld = function withThemeOld() {
  return function (Component) {
    var WithTheme = (function (_React$Component) {
      (0, _inherits2$9.default)(WithTheme, _React$Component);
      function WithTheme(props, context) {
        var _this;
        (0, _classCallCheck2$a.default)(this, WithTheme);
        _this = (0, _possibleConstructorReturn2$9.default)(this, (0, _getPrototypeOf2$2.default)(WithTheme).call(this));
        _this.state = {
          theme: _themeListener.default.initial(context) || getDefaultTheme()
        };
        return _this;
      }
      (0, _createClass2$a.default)(WithTheme, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          var _this2 = this;
          this.unsubscribeId = _themeListener.default.subscribe(this.context, function (theme) {
            _this2.setState({
              theme: theme
            });
          });
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          if (this.unsubscribeId !== null) {
            _themeListener.default.unsubscribe(this.context, this.unsubscribeId);
          }
        }
      }, {
        key: "render",
        value: function render() {
          var _this$props = this.props, innerRef = _this$props.innerRef, other = (0, _objectWithoutProperties2$e.default)(_this$props, ["innerRef"]);
          return _react$p.default.createElement(Component, (0, _extends2$f.default)({
            theme: this.state.theme,
            ref: innerRef
          }, other));
        }
      }]);
      return WithTheme;
    })(_react$p.default.Component);
    WithTheme.propTypes = {
      innerRef: _propTypes$j.default.oneOfType([_propTypes$j.default.func, _propTypes$j.default.object])
    };
    WithTheme.contextTypes = _themeListener.default.contextTypes;
    {
      WithTheme.displayName = ("WithTheme(").concat((0, _utils$b.getDisplayName)(Component), ")");
    }
    (0, _hoistNonReactStatics.default)(WithTheme, Component);
    {
      WithTheme.Naked = Component;
    }
    return WithTheme;
  };
};
if (!_utils$b.ponyfillGlobal.__MUI_STYLES__) {
  _utils$b.ponyfillGlobal.__MUI_STYLES__ = {};
}
if (!_utils$b.ponyfillGlobal.__MUI_STYLES__.withTheme) {
  _utils$b.ponyfillGlobal.__MUI_STYLES__.withTheme = withThemeOld;
}
var _default$y = _utils$b.ponyfillGlobal.__MUI_STYLES__.withTheme;
withTheme.default = _default$y;
(function (exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "createGenerateClassName", {
    enumerable: true,
    get: function get() {
      return _createGenerateClassName.default;
    }
  });
  Object.defineProperty(exports, "createMuiTheme", {
    enumerable: true,
    get: function get() {
      return _createMuiTheme.default;
    }
  });
  Object.defineProperty(exports, "jssPreset", {
    enumerable: true,
    get: function get() {
      return _jssPreset.default;
    }
  });
  Object.defineProperty(exports, "MuiThemeProvider", {
    enumerable: true,
    get: function get() {
      return _MuiThemeProvider.default;
    }
  });
  Object.defineProperty(exports, "createStyles", {
    enumerable: true,
    get: function get() {
      return _createStyles.default;
    }
  });
  Object.defineProperty(exports, "withStyles", {
    enumerable: true,
    get: function get() {
      return _withStyles.default;
    }
  });
  Object.defineProperty(exports, "withTheme", {
    enumerable: true,
    get: function get() {
      return _withTheme.default;
    }
  });
  var _createGenerateClassName = _interopRequireDefault(createGenerateClassName$2);
  var _createMuiTheme = _interopRequireDefault(createMuiTheme$1);
  var _jssPreset = _interopRequireDefault(jssPreset$1);
  var _MuiThemeProvider = _interopRequireDefault(MuiThemeProvider);
  var _createStyles = _interopRequireDefault(createStyles$1);
  var _withStyles = _interopRequireDefault(withStyles);
  var _withTheme = _interopRequireDefault(withTheme);
})(styles$e);
getDefaultExportFromCjs(styles$e);
var Typography$3 = {};
var Typography$2 = {};
var helpers = {};
var _interopRequireDefault$y = interopRequireDefault.exports;
Object.defineProperty(helpers, "__esModule", {
  value: true
});
helpers.capitalize = capitalize;
helpers.contains = contains;
helpers.findIndex = findIndex;
helpers.find = find;
helpers.createChainedFunction = createChainedFunction;
var _typeof2 = _interopRequireDefault$y(_typeof$1.exports);
var _warning$3 = _interopRequireDefault$y(warning_1);
function capitalize(string) {
  if (typeof string !== 'string') {
    throw new Error('Material-UI: capitalize(string) expects a string argument.');
  }
  return string.charAt(0).toUpperCase() + string.slice(1);
}
function contains(obj, pred) {
  return Object.keys(pred).every(function (key) {
    return obj.hasOwnProperty(key) && obj[key] === pred[key];
  });
}
function findIndex(arr, pred) {
  var predType = (0, _typeof2.default)(pred);
  for (var i = 0; i < arr.length; i += 1) {
    if (predType === 'function' && !!pred(arr[i], i, arr) === true) {
      return i;
    }
    if (predType === 'object' && contains(arr[i], pred)) {
      return i;
    }
    if (['string', 'number', 'boolean'].indexOf(predType) !== -1) {
      return arr.indexOf(pred);
    }
  }
  return -1;
}
function find(arr, pred) {
  var index = findIndex(arr, pred);
  return index > -1 ? arr[index] : undefined;
}
function createChainedFunction() {
  for (var _len = arguments.length, funcs = new Array(_len), _key = 0; _key < _len; _key++) {
    funcs[_key] = arguments[_key];
  }
  return funcs.reduce(function (acc, func) {
    if (func == null) {
      return acc;
    }
    (0, _warning$3.default)(typeof func === 'function', 'Material-UI: invalid Argument Type, must only provide functions, undefined, or null.');
    return function chainedFunction() {
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }
      acc.apply(this, args);
      func.apply(this, args);
    };
  }, function () {});
}
const require$$4$7 = _dll_react;
const require$$5$7 = _dll_prop_types;
const require$$6$7 = _dll_classnames;
var _interopRequireDefault$x = interopRequireDefault.exports;
Object.defineProperty(Typography$2, "__esModule", {
  value: true
});
Typography$2.default = Typography$2.styles = void 0;
var _extends2$e = _interopRequireDefault$x(_extends$1.exports);
var _defineProperty2$8 = _interopRequireDefault$x(defineProperty$1.exports);
var _objectWithoutProperties2$d = _interopRequireDefault$x(objectWithoutProperties.exports);
var _react$o = _interopRequireDefault$x(require$$4$7);
var _propTypes$i = _interopRequireDefault$x(require$$5$7);
var _classnames$d = _interopRequireDefault$x(require$$6$7);
var _utils$a = require$$13$2;
var _withStyles$c = _interopRequireDefault$x(withStyles);
var _helpers$4 = helpers;
var styles$d = function styles(theme) {
  return {
    root: {
      display: 'block',
      margin: 0
    },
    display4: theme.typography.display4,
    display3: theme.typography.display3,
    display2: theme.typography.display2,
    display1: theme.typography.display1,
    headline: theme.typography.headline,
    title: theme.typography.title,
    subheading: theme.typography.subheading,
    body2: theme.typography.body2,
    body1: theme.typography.body1,
    caption: theme.typography.caption,
    button: theme.typography.button,
    h1: theme.typography.h1,
    h2: theme.typography.h2,
    h3: theme.typography.h3,
    h4: theme.typography.h4,
    h5: theme.typography.h5,
    h6: theme.typography.h6,
    subtitle1: theme.typography.subtitle1,
    subtitle2: theme.typography.subtitle2,
    overline: theme.typography.overline,
    srOnly: {
      position: 'absolute',
      height: 1,
      width: 1,
      overflow: 'hidden'
    },
    alignLeft: {
      textAlign: 'left'
    },
    alignCenter: {
      textAlign: 'center'
    },
    alignRight: {
      textAlign: 'right'
    },
    alignJustify: {
      textAlign: 'justify'
    },
    noWrap: {
      overflow: 'hidden',
      textOverflow: 'ellipsis',
      whiteSpace: 'nowrap'
    },
    gutterBottom: {
      marginBottom: '0.35em'
    },
    paragraph: {
      marginBottom: 16
    },
    colorInherit: {
      color: 'inherit'
    },
    colorPrimary: {
      color: theme.palette.primary.main
    },
    colorSecondary: {
      color: theme.palette.secondary.main
    },
    colorTextPrimary: {
      color: theme.palette.text.primary
    },
    colorTextSecondary: {
      color: theme.palette.text.secondary
    },
    colorError: {
      color: theme.palette.error.main
    },
    inline: {
      display: 'inline'
    }
  };
};
Typography$2.styles = styles$d;
var nextVariants = {
  display4: 'h1',
  display3: 'h2',
  display2: 'h3',
  display1: 'h4',
  headline: 'h5',
  title: 'h6',
  subheading: 'subtitle1'
};
function getVariant(theme, variantProp) {
  var typography = theme.typography;
  var variant = variantProp;
  if (!variant) {
    variant = typography.useNextVariants ? 'body2' : 'body1';
  }
  if (typography.useNextVariants) {
    variant = nextVariants[variant] || variant;
  }
  return variant;
}
var defaultHeadlineMapping = {
  h1: 'h1',
  h2: 'h2',
  h3: 'h3',
  h4: 'h4',
  h5: 'h5',
  h6: 'h6',
  subtitle1: 'h6',
  subtitle2: 'h6',
  body1: 'p',
  body2: 'p',
  display4: 'h1',
  display3: 'h1',
  display2: 'h1',
  display1: 'h1',
  headline: 'h1',
  title: 'h2',
  subheading: 'h3'
};
function Typography$1(props) {
  var _classNames;
  var align = props.align, classes = props.classes, classNameProp = props.className, color = props.color, componentProp = props.component, gutterBottom = props.gutterBottom, headlineMapping = props.headlineMapping, inline = props.inline;
  props.internalDeprecatedVariant;
  var noWrap = props.noWrap, paragraph = props.paragraph, theme = props.theme, variantProp = props.variant, other = (0, _objectWithoutProperties2$d.default)(props, ["align", "classes", "className", "color", "component", "gutterBottom", "headlineMapping", "inline", "internalDeprecatedVariant", "noWrap", "paragraph", "theme", "variant"]);
  var variant = getVariant(theme, variantProp);
  var className = (0, _classnames$d.default)(classes.root, (_classNames = {}, (0, _defineProperty2$8.default)(_classNames, classes[variant], variant !== 'inherit'), (0, _defineProperty2$8.default)(_classNames, classes[("color").concat((0, _helpers$4.capitalize)(color))], color !== 'default'), (0, _defineProperty2$8.default)(_classNames, classes.noWrap, noWrap), (0, _defineProperty2$8.default)(_classNames, classes.gutterBottom, gutterBottom), (0, _defineProperty2$8.default)(_classNames, classes.paragraph, paragraph), (0, _defineProperty2$8.default)(_classNames, classes[("align").concat((0, _helpers$4.capitalize)(align))], align !== 'inherit'), (0, _defineProperty2$8.default)(_classNames, classes.inline, inline), _classNames), classNameProp);
  var Component = componentProp || (paragraph ? 'p' : headlineMapping[variant] || defaultHeadlineMapping[variant]) || 'span';
  return _react$o.default.createElement(Component, (0, _extends2$e.default)({
    className: className
  }, other));
}
Typography$1.propTypes = {
  align: _propTypes$i.default.oneOf(['inherit', 'left', 'center', 'right', 'justify']),
  children: _propTypes$i.default.node,
  classes: _propTypes$i.default.object.isRequired,
  className: _propTypes$i.default.string,
  color: _propTypes$i.default.oneOf(['default', 'error', 'inherit', 'primary', 'secondary', 'textPrimary', 'textSecondary']),
  component: _utils$a.componentPropType,
  gutterBottom: _propTypes$i.default.bool,
  headlineMapping: _propTypes$i.default.object,
  inline: _propTypes$i.default.bool,
  internalDeprecatedVariant: _propTypes$i.default.bool,
  noWrap: _propTypes$i.default.bool,
  paragraph: _propTypes$i.default.bool,
  theme: _propTypes$i.default.object.isRequired,
  variant: (0, _utils$a.chainPropTypes)(_propTypes$i.default.oneOf(['h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'subtitle1', 'subtitle2', 'body1', 'body2', 'caption', 'button', 'overline', 'srOnly', 'inherit', 'display4', 'display3', 'display2', 'display1', 'headline', 'title', 'subheading']), function (props) {
    var deprecatedVariants = ['display4', 'display3', 'display2', 'display1', 'headline', 'title', 'subheading'];
    if (props.theme.typography.useNextVariants && !props.internalDeprecatedVariant && deprecatedVariants.indexOf(props.variant) !== -1) {
      return new Error('Material-UI: you are using a deprecated typography variant: ' + ("`").concat(props.variant, "` that will be removed in the next major release.\n") + 'Please read the migration guide under https://v3.material-ui.com/style/typography#migration-to-typography-v2.');
    }
    return null;
  })
};
Typography$1.defaultProps = {
  align: 'inherit',
  color: 'default',
  gutterBottom: false,
  headlineMapping: defaultHeadlineMapping,
  inline: false,
  noWrap: false,
  paragraph: false
};
var _default$x = (0, _withStyles$c.default)(styles$d, {
  name: 'MuiTypography',
  withTheme: true
})(Typography$1);
Typography$2.default = _default$x;
(function (exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function get() {
      return _Typography.default;
    }
  });
  var _Typography = _interopRequireDefault(Typography$2);
})(Typography$3);
var Typography = getDefaultExportFromCjs(Typography$3);
var Paper$2 = {};
var Paper$1 = {};
const require$$4$6 = _dll_react;
const require$$5$6 = _dll_prop_types;
const require$$6$6 = _dll_classnames;
var _interopRequireDefault$w = interopRequireDefault.exports;
Object.defineProperty(Paper$1, "__esModule", {
  value: true
});
Paper$1.default = Paper$1.styles = void 0;
var _defineProperty2$7 = _interopRequireDefault$w(defineProperty$1.exports);
var _objectWithoutProperties2$c = _interopRequireDefault$w(objectWithoutProperties.exports);
var _extends2$d = _interopRequireDefault$w(_extends$1.exports);
var _react$n = _interopRequireDefault$w(require$$4$6);
var _propTypes$h = _interopRequireDefault$w(require$$5$6);
var _classnames$c = _interopRequireDefault$w(require$$6$6);
var _warning$2 = _interopRequireDefault$w(warning_1);
var _utils$9 = require$$13$2;
var _withStyles$b = _interopRequireDefault$w(withStyles);
var styles$c = function styles(theme) {
  var elevations = {};
  theme.shadows.forEach(function (shadow, index) {
    elevations[("elevation").concat(index)] = {
      boxShadow: shadow
    };
  });
  return (0, _extends2$d.default)({
    root: {
      backgroundColor: theme.palette.background.paper
    },
    rounded: {
      borderRadius: theme.shape.borderRadius
    }
  }, elevations);
};
Paper$1.styles = styles$c;
function Paper(props) {
  var classes = props.classes, classNameProp = props.className, Component = props.component, square = props.square, elevation = props.elevation, other = (0, _objectWithoutProperties2$c.default)(props, ["classes", "className", "component", "square", "elevation"]);
  (0, _warning$2.default)(elevation >= 0 && elevation < 25, ("Material-UI: this elevation `").concat(elevation, "` is not implemented."));
  var className = (0, _classnames$c.default)(classes.root, classes[("elevation").concat(elevation)], (0, _defineProperty2$7.default)({}, classes.rounded, !square), classNameProp);
  return _react$n.default.createElement(Component, (0, _extends2$d.default)({
    className: className
  }, other));
}
Paper.propTypes = {
  children: _propTypes$h.default.node,
  classes: _propTypes$h.default.object.isRequired,
  className: _propTypes$h.default.string,
  component: _utils$9.componentPropType,
  elevation: _propTypes$h.default.number,
  square: _propTypes$h.default.bool
};
Paper.defaultProps = {
  component: 'div',
  elevation: 2,
  square: false
};
var _default$w = (0, _withStyles$b.default)(styles$c, {
  name: 'MuiPaper'
})(Paper);
Paper$1.default = _default$w;
(function (exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function get() {
      return _Paper.default;
    }
  });
  var _Paper = _interopRequireDefault(Paper$1);
})(Paper$2);
getDefaultExportFromCjs(Paper$2);
var Backdrop$2 = {};
var Backdrop$1 = {};
var Fade$2 = {};
var Fade$1 = {};
var Transition$1 = {};
function componentWillMount() {
  var state = this.constructor.getDerivedStateFromProps(this.props, this.state);
  if (state !== null && state !== undefined) {
    this.setState(state);
  }
}
function componentWillReceiveProps(nextProps) {
  function updater(prevState) {
    var state = this.constructor.getDerivedStateFromProps(nextProps, prevState);
    return state !== null && state !== undefined ? state : null;
  }
  this.setState(updater.bind(this));
}
function componentWillUpdate(nextProps, nextState) {
  try {
    var prevProps = this.props;
    var prevState = this.state;
    this.props = nextProps;
    this.state = nextState;
    this.__reactInternalSnapshotFlag = true;
    this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(prevProps, prevState);
  } finally {
    this.props = prevProps;
    this.state = prevState;
  }
}
componentWillMount.__suppressDeprecationWarning = true;
componentWillReceiveProps.__suppressDeprecationWarning = true;
componentWillUpdate.__suppressDeprecationWarning = true;
function polyfill(Component) {
  var prototype = Component.prototype;
  if (!prototype || !prototype.isReactComponent) {
    throw new Error('Can only polyfill class components');
  }
  if (typeof Component.getDerivedStateFromProps !== 'function' && typeof prototype.getSnapshotBeforeUpdate !== 'function') {
    return Component;
  }
  var foundWillMountName = null;
  var foundWillReceivePropsName = null;
  var foundWillUpdateName = null;
  if (typeof prototype.componentWillMount === 'function') {
    foundWillMountName = 'componentWillMount';
  } else if (typeof prototype.UNSAFE_componentWillMount === 'function') {
    foundWillMountName = 'UNSAFE_componentWillMount';
  }
  if (typeof prototype.componentWillReceiveProps === 'function') {
    foundWillReceivePropsName = 'componentWillReceiveProps';
  } else if (typeof prototype.UNSAFE_componentWillReceiveProps === 'function') {
    foundWillReceivePropsName = 'UNSAFE_componentWillReceiveProps';
  }
  if (typeof prototype.componentWillUpdate === 'function') {
    foundWillUpdateName = 'componentWillUpdate';
  } else if (typeof prototype.UNSAFE_componentWillUpdate === 'function') {
    foundWillUpdateName = 'UNSAFE_componentWillUpdate';
  }
  if (foundWillMountName !== null || foundWillReceivePropsName !== null || foundWillUpdateName !== null) {
    var componentName = Component.displayName || Component.name;
    var newApiName = typeof Component.getDerivedStateFromProps === 'function' ? 'getDerivedStateFromProps()' : 'getSnapshotBeforeUpdate()';
    throw Error('Unsafe legacy lifecycles will not be called for components using new component APIs.\n\n' + componentName + ' uses ' + newApiName + ' but also contains the following legacy lifecycles:' + (foundWillMountName !== null ? '\n  ' + foundWillMountName : '') + (foundWillReceivePropsName !== null ? '\n  ' + foundWillReceivePropsName : '') + (foundWillUpdateName !== null ? '\n  ' + foundWillUpdateName : '') + '\n\nThe above lifecycles should be removed. Learn more about this warning here:\n' + 'https://fb.me/react-async-component-lifecycle-hooks');
  }
  if (typeof Component.getDerivedStateFromProps === 'function') {
    prototype.componentWillMount = componentWillMount;
    prototype.componentWillReceiveProps = componentWillReceiveProps;
  }
  if (typeof prototype.getSnapshotBeforeUpdate === 'function') {
    if (typeof prototype.componentDidUpdate !== 'function') {
      throw new Error('Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype');
    }
    prototype.componentWillUpdate = componentWillUpdate;
    var componentDidUpdate = prototype.componentDidUpdate;
    prototype.componentDidUpdate = function componentDidUpdatePolyfill(prevProps, prevState, maybeSnapshot) {
      var snapshot = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : maybeSnapshot;
      componentDidUpdate.call(this, prevProps, prevState, snapshot);
    };
  }
  return Component;
}
var reactLifecyclesCompat_es = Object.freeze({
  __proto__: null,
  polyfill: polyfill
});
var require$$2$4 = getAugmentedNamespace(reactLifecyclesCompat_es);
var PropTypes$4 = {};
const require$$0$3 = _dll_prop_types;
PropTypes$4.__esModule = true;
PropTypes$4.classNamesShape = PropTypes$4.timeoutsShape = void 0;
var _propTypes$g = _interopRequireDefault$v(require$$0$3);
function _interopRequireDefault$v(obj) {
  return obj && obj.__esModule ? obj : {
    default: obj
  };
}
var timeoutsShape = _propTypes$g.default.oneOfType([_propTypes$g.default.number, _propTypes$g.default.shape({
  enter: _propTypes$g.default.number,
  exit: _propTypes$g.default.number,
  appear: _propTypes$g.default.number
}).isRequired]);
PropTypes$4.timeoutsShape = timeoutsShape;
var classNamesShape = _propTypes$g.default.oneOfType([_propTypes$g.default.string, _propTypes$g.default.shape({
  enter: _propTypes$g.default.string,
  exit: _propTypes$g.default.string,
  active: _propTypes$g.default.string
}), _propTypes$g.default.shape({
  enter: _propTypes$g.default.string,
  enterDone: _propTypes$g.default.string,
  enterActive: _propTypes$g.default.string,
  exit: _propTypes$g.default.string,
  exitDone: _propTypes$g.default.string,
  exitActive: _propTypes$g.default.string
})]);
PropTypes$4.classNamesShape = classNamesShape;
const require$$0$2 = _dll_prop_types;
const require$$1$5 = _dll_react;
const require$$2$3 = _dll_react_dom;
Transition$1.__esModule = true;
Transition$1.default = Transition$1.EXITING = Transition$1.ENTERED = Transition$1.ENTERING = Transition$1.EXITED = Transition$1.UNMOUNTED = void 0;
var PropTypes$3 = _interopRequireWildcard(require$$0$2);
var _react$m = _interopRequireDefault$u(require$$1$5);
var _reactDom$5 = _interopRequireDefault$u(require$$2$3);
var _reactLifecyclesCompat = require$$2$4;
var _PropTypes = PropTypes$4;
function _interopRequireDefault$u(obj) {
  return obj && obj.__esModule ? obj : {
    default: obj
  };
}
function _interopRequireWildcard(obj) {
  if (obj && obj.__esModule) {
    return obj;
  } else {
    var newObj = {};
    if (obj != null) {
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {};
          if (desc.get || desc.set) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
    }
    newObj.default = obj;
    return newObj;
  }
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  subClass.__proto__ = superClass;
}
var UNMOUNTED = 'unmounted';
Transition$1.UNMOUNTED = UNMOUNTED;
var EXITED = 'exited';
Transition$1.EXITED = EXITED;
var ENTERING = 'entering';
Transition$1.ENTERING = ENTERING;
var ENTERED = 'entered';
Transition$1.ENTERED = ENTERED;
var EXITING = 'exiting';
Transition$1.EXITING = EXITING;
var Transition = (function (_React$Component) {
  _inheritsLoose(Transition, _React$Component);
  function Transition(props, context) {
    var _this;
    _this = _React$Component.call(this, props, context) || this;
    var parentGroup = context.transitionGroup;
    var appear = parentGroup && !parentGroup.isMounting ? props.enter : props.appear;
    var initialStatus;
    _this.appearStatus = null;
    if (props.in) {
      if (appear) {
        initialStatus = EXITED;
        _this.appearStatus = ENTERING;
      } else {
        initialStatus = ENTERED;
      }
    } else {
      if (props.unmountOnExit || props.mountOnEnter) {
        initialStatus = UNMOUNTED;
      } else {
        initialStatus = EXITED;
      }
    }
    _this.state = {
      status: initialStatus
    };
    _this.nextCallback = null;
    return _this;
  }
  var _proto = Transition.prototype;
  _proto.getChildContext = function getChildContext() {
    return {
      transitionGroup: null
    };
  };
  Transition.getDerivedStateFromProps = function getDerivedStateFromProps(_ref, prevState) {
    var nextIn = _ref.in;
    if (nextIn && prevState.status === UNMOUNTED) {
      return {
        status: EXITED
      };
    }
    return null;
  };
  _proto.componentDidMount = function componentDidMount() {
    this.updateStatus(true, this.appearStatus);
  };
  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    var nextStatus = null;
    if (prevProps !== this.props) {
      var status = this.state.status;
      if (this.props.in) {
        if (status !== ENTERING && status !== ENTERED) {
          nextStatus = ENTERING;
        }
      } else {
        if (status === ENTERING || status === ENTERED) {
          nextStatus = EXITING;
        }
      }
    }
    this.updateStatus(false, nextStatus);
  };
  _proto.componentWillUnmount = function componentWillUnmount() {
    this.cancelNextCallback();
  };
  _proto.getTimeouts = function getTimeouts() {
    var timeout = this.props.timeout;
    var exit, enter, appear;
    exit = enter = appear = timeout;
    if (timeout != null && typeof timeout !== 'number') {
      exit = timeout.exit;
      enter = timeout.enter;
      appear = timeout.appear !== undefined ? timeout.appear : enter;
    }
    return {
      exit: exit,
      enter: enter,
      appear: appear
    };
  };
  _proto.updateStatus = function updateStatus(mounting, nextStatus) {
    if (mounting === void 0) {
      mounting = false;
    }
    if (nextStatus !== null) {
      this.cancelNextCallback();
      var node = _reactDom$5.default.findDOMNode(this);
      if (nextStatus === ENTERING) {
        this.performEnter(node, mounting);
      } else {
        this.performExit(node);
      }
    } else if (this.props.unmountOnExit && this.state.status === EXITED) {
      this.setState({
        status: UNMOUNTED
      });
    }
  };
  _proto.performEnter = function performEnter(node, mounting) {
    var _this2 = this;
    var enter = this.props.enter;
    var appearing = this.context.transitionGroup ? this.context.transitionGroup.isMounting : mounting;
    var timeouts = this.getTimeouts();
    var enterTimeout = appearing ? timeouts.appear : timeouts.enter;
    if (!mounting && !enter) {
      this.safeSetState({
        status: ENTERED
      }, function () {
        _this2.props.onEntered(node);
      });
      return;
    }
    this.props.onEnter(node, appearing);
    this.safeSetState({
      status: ENTERING
    }, function () {
      _this2.props.onEntering(node, appearing);
      _this2.onTransitionEnd(node, enterTimeout, function () {
        _this2.safeSetState({
          status: ENTERED
        }, function () {
          _this2.props.onEntered(node, appearing);
        });
      });
    });
  };
  _proto.performExit = function performExit(node) {
    var _this3 = this;
    var exit = this.props.exit;
    var timeouts = this.getTimeouts();
    if (!exit) {
      this.safeSetState({
        status: EXITED
      }, function () {
        _this3.props.onExited(node);
      });
      return;
    }
    this.props.onExit(node);
    this.safeSetState({
      status: EXITING
    }, function () {
      _this3.props.onExiting(node);
      _this3.onTransitionEnd(node, timeouts.exit, function () {
        _this3.safeSetState({
          status: EXITED
        }, function () {
          _this3.props.onExited(node);
        });
      });
    });
  };
  _proto.cancelNextCallback = function cancelNextCallback() {
    if (this.nextCallback !== null) {
      this.nextCallback.cancel();
      this.nextCallback = null;
    }
  };
  _proto.safeSetState = function safeSetState(nextState, callback) {
    callback = this.setNextCallback(callback);
    this.setState(nextState, callback);
  };
  _proto.setNextCallback = function setNextCallback(callback) {
    var _this4 = this;
    var active = true;
    this.nextCallback = function (event) {
      if (active) {
        active = false;
        _this4.nextCallback = null;
        callback(event);
      }
    };
    this.nextCallback.cancel = function () {
      active = false;
    };
    return this.nextCallback;
  };
  _proto.onTransitionEnd = function onTransitionEnd(node, timeout, handler) {
    this.setNextCallback(handler);
    var doesNotHaveTimeoutOrListener = timeout == null && !this.props.addEndListener;
    if (!node || doesNotHaveTimeoutOrListener) {
      setTimeout(this.nextCallback, 0);
      return;
    }
    if (this.props.addEndListener) {
      this.props.addEndListener(node, this.nextCallback);
    }
    if (timeout != null) {
      setTimeout(this.nextCallback, timeout);
    }
  };
  _proto.render = function render() {
    var status = this.state.status;
    if (status === UNMOUNTED) {
      return null;
    }
    var _this$props = this.props, children = _this$props.children, childProps = _objectWithoutPropertiesLoose(_this$props, ["children"]);
    delete childProps.in;
    delete childProps.mountOnEnter;
    delete childProps.unmountOnExit;
    delete childProps.appear;
    delete childProps.enter;
    delete childProps.exit;
    delete childProps.timeout;
    delete childProps.addEndListener;
    delete childProps.onEnter;
    delete childProps.onEntering;
    delete childProps.onEntered;
    delete childProps.onExit;
    delete childProps.onExiting;
    delete childProps.onExited;
    if (typeof children === 'function') {
      return children(status, childProps);
    }
    var child = _react$m.default.Children.only(children);
    return _react$m.default.cloneElement(child, childProps);
  };
  return Transition;
})(_react$m.default.Component);
Transition.contextTypes = {
  transitionGroup: PropTypes$3.object
};
Transition.childContextTypes = {
  transitionGroup: function transitionGroup() {}
};
Transition.propTypes = {
  children: PropTypes$3.oneOfType([PropTypes$3.func.isRequired, PropTypes$3.element.isRequired]).isRequired,
  in: PropTypes$3.bool,
  mountOnEnter: PropTypes$3.bool,
  unmountOnExit: PropTypes$3.bool,
  appear: PropTypes$3.bool,
  enter: PropTypes$3.bool,
  exit: PropTypes$3.bool,
  timeout: function timeout(props) {
    var pt = _PropTypes.timeoutsShape;
    if (!props.addEndListener) pt = pt.isRequired;
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }
    return pt.apply(void 0, [props].concat(args));
  },
  addEndListener: PropTypes$3.func,
  onEnter: PropTypes$3.func,
  onEntering: PropTypes$3.func,
  onEntered: PropTypes$3.func,
  onExit: PropTypes$3.func,
  onExiting: PropTypes$3.func,
  onExited: PropTypes$3.func
};
function noop() {}
Transition.defaultProps = {
  in: false,
  mountOnEnter: false,
  unmountOnExit: false,
  appear: false,
  enter: true,
  exit: true,
  onEnter: noop,
  onEntering: noop,
  onEntered: noop,
  onExit: noop,
  onExiting: noop,
  onExited: noop
};
Transition.UNMOUNTED = 0;
Transition.EXITED = 1;
Transition.ENTERING = 2;
Transition.ENTERED = 3;
Transition.EXITING = 4;
var _default$v = (0, _reactLifecyclesCompat.polyfill)(Transition);
Transition$1.default = _default$v;
var utils = {};
Object.defineProperty(utils, "__esModule", {
  value: true
});
utils.getTransitionProps = getTransitionProps;
utils.reflow = void 0;
var reflow = function reflow(node) {
  return node.scrollTop;
};
utils.reflow = reflow;
function getTransitionProps(props, options) {
  var timeout = props.timeout, _props$style = props.style, style = _props$style === void 0 ? {} : _props$style;
  return {
    duration: style.transitionDuration || typeof timeout === 'number' ? timeout : timeout[options.mode],
    delay: style.transitionDelay
  };
}
const require$$8$2 = _dll_react;
const require$$9$2 = _dll_prop_types;
var _interopRequireDefault$t = interopRequireDefault.exports;
Object.defineProperty(Fade$1, "__esModule", {
  value: true
});
Fade$1.default = void 0;
var _extends2$c = _interopRequireDefault$t(_extends$1.exports);
var _objectWithoutProperties2$b = _interopRequireDefault$t(objectWithoutProperties.exports);
var _classCallCheck2$9 = _interopRequireDefault$t(classCallCheck.exports);
var _createClass2$9 = _interopRequireDefault$t(createClass.exports);
var _possibleConstructorReturn2$8 = _interopRequireDefault$t(possibleConstructorReturn.exports);
var _getPrototypeOf3$6 = _interopRequireDefault$t(getPrototypeOf$1.exports);
var _inherits2$8 = _interopRequireDefault$t(inherits.exports);
var _react$l = _interopRequireDefault$t(require$$8$2);
var _propTypes$f = _interopRequireDefault$t(require$$9$2);
var _Transition$1 = _interopRequireDefault$t(Transition$1);
var _transitions$1 = transitions;
var _withTheme = _interopRequireDefault$t(withTheme);
var _utils$8 = utils;
var styles$b = {
  entering: {
    opacity: 1
  },
  entered: {
    opacity: 1
  }
};
var Fade = (function (_React$Component) {
  (0, _inherits2$8.default)(Fade, _React$Component);
  function Fade() {
    var _getPrototypeOf2;
    var _this;
    (0, _classCallCheck2$9.default)(this, Fade);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = (0, _possibleConstructorReturn2$8.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3$6.default)(Fade)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.handleEnter = function (node) {
      var theme = _this.props.theme;
      (0, _utils$8.reflow)(node);
      var transitionProps = (0, _utils$8.getTransitionProps)(_this.props, {
        mode: 'enter'
      });
      node.style.webkitTransition = theme.transitions.create('opacity', transitionProps);
      node.style.transition = theme.transitions.create('opacity', transitionProps);
      if (_this.props.onEnter) {
        _this.props.onEnter(node);
      }
    };
    _this.handleExit = function (node) {
      var theme = _this.props.theme;
      var transitionProps = (0, _utils$8.getTransitionProps)(_this.props, {
        mode: 'exit'
      });
      node.style.webkitTransition = theme.transitions.create('opacity', transitionProps);
      node.style.transition = theme.transitions.create('opacity', transitionProps);
      if (_this.props.onExit) {
        _this.props.onExit(node);
      }
    };
    return _this;
  }
  (0, _createClass2$9.default)(Fade, [{
    key: "render",
    value: function render() {
      var _this$props = this.props, children = _this$props.children;
      _this$props.onEnter;
      _this$props.onExit;
      var styleProp = _this$props.style;
      _this$props.theme;
      var other = (0, _objectWithoutProperties2$b.default)(_this$props, ["children", "onEnter", "onExit", "style", "theme"]);
      var style = (0, _extends2$c.default)({}, styleProp, _react$l.default.isValidElement(children) ? children.props.style : {});
      return _react$l.default.createElement(_Transition$1.default, (0, _extends2$c.default)({
        appear: true,
        onEnter: this.handleEnter,
        onExit: this.handleExit
      }, other), function (state, childProps) {
        return _react$l.default.cloneElement(children, (0, _extends2$c.default)({
          style: (0, _extends2$c.default)({
            opacity: 0
          }, styles$b[state], style)
        }, childProps));
      });
    }
  }]);
  return Fade;
})(_react$l.default.Component);
Fade.propTypes = {
  children: _propTypes$f.default.oneOfType([_propTypes$f.default.element, _propTypes$f.default.func]),
  in: _propTypes$f.default.bool,
  onEnter: _propTypes$f.default.func,
  onExit: _propTypes$f.default.func,
  style: _propTypes$f.default.object,
  theme: _propTypes$f.default.object.isRequired,
  timeout: _propTypes$f.default.oneOfType([_propTypes$f.default.number, _propTypes$f.default.shape({
    enter: _propTypes$f.default.number,
    exit: _propTypes$f.default.number
  })])
};
Fade.defaultProps = {
  timeout: {
    enter: _transitions$1.duration.enteringScreen,
    exit: _transitions$1.duration.leavingScreen
  }
};
var _default$u = (0, _withTheme.default)()(Fade);
Fade$1.default = _default$u;
(function (exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function get() {
      return _Fade.default;
    }
  });
  var _Fade = _interopRequireDefault(Fade$1);
})(Fade$2);
getDefaultExportFromCjs(Fade$2);
const require$$4$5 = _dll_react;
const require$$5$5 = _dll_prop_types;
const require$$6$5 = _dll_classnames;
var _interopRequireDefault$s = interopRequireDefault.exports;
Object.defineProperty(Backdrop$1, "__esModule", {
  value: true
});
Backdrop$1.default = Backdrop$1.styles = void 0;
var _extends2$b = _interopRequireDefault$s(_extends$1.exports);
var _defineProperty2$6 = _interopRequireDefault$s(defineProperty$1.exports);
var _objectWithoutProperties2$a = _interopRequireDefault$s(objectWithoutProperties.exports);
var _react$k = _interopRequireDefault$s(require$$4$5);
var _propTypes$e = _interopRequireDefault$s(require$$5$5);
var _classnames$b = _interopRequireDefault$s(require$$6$5);
var _withStyles$a = _interopRequireDefault$s(withStyles);
var _Fade$1 = _interopRequireDefault$s(Fade$2);
var styles$a = {
  root: {
    zIndex: -1,
    position: 'fixed',
    right: 0,
    bottom: 0,
    top: 0,
    left: 0,
    backgroundColor: 'rgba(0, 0, 0, 0.5)',
    WebkitTapHighlightColor: 'transparent',
    touchAction: 'none'
  },
  invisible: {
    backgroundColor: 'transparent'
  }
};
Backdrop$1.styles = styles$a;
function Backdrop(props) {
  var classes = props.classes, className = props.className, invisible = props.invisible, open = props.open, transitionDuration = props.transitionDuration, other = (0, _objectWithoutProperties2$a.default)(props, ["classes", "className", "invisible", "open", "transitionDuration"]);
  return _react$k.default.createElement(_Fade$1.default, (0, _extends2$b.default)({
    in: open,
    timeout: transitionDuration
  }, other), _react$k.default.createElement("div", {
    className: (0, _classnames$b.default)(classes.root, (0, _defineProperty2$6.default)({}, classes.invisible, invisible), className),
    "aria-hidden": "true"
  }));
}
Backdrop.propTypes = {
  classes: _propTypes$e.default.object.isRequired,
  className: _propTypes$e.default.string,
  invisible: _propTypes$e.default.bool,
  open: _propTypes$e.default.bool.isRequired,
  transitionDuration: _propTypes$e.default.oneOfType([_propTypes$e.default.number, _propTypes$e.default.shape({
    enter: _propTypes$e.default.number,
    exit: _propTypes$e.default.number
  })])
};
Backdrop.defaultProps = {
  invisible: false
};
var _default$t = (0, _withStyles$a.default)(styles$a, {
  name: 'MuiBackdrop'
})(Backdrop);
Backdrop$1.default = _default$t;
(function (exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function get() {
      return _Backdrop.default;
    }
  });
  var _Backdrop = _interopRequireDefault(Backdrop$1);
})(Backdrop$2);
getDefaultExportFromCjs(Backdrop$2);
var ButtonBase$2 = {};
var ButtonBase$1 = {};
var ownerWindow$1 = {};
var ownerDocument$1 = {};
Object.defineProperty(ownerDocument$1, "__esModule", {
  value: true
});
ownerDocument$1.default = void 0;
function ownerDocument(node) {
  return node && node.ownerDocument || document;
}
var _default$s = ownerDocument;
ownerDocument$1.default = _default$s;
var _interopRequireDefault$r = interopRequireDefault.exports;
Object.defineProperty(ownerWindow$1, "__esModule", {
  value: true
});
ownerWindow$1.default = void 0;
var _ownerDocument$5 = _interopRequireDefault$r(ownerDocument$1);
function ownerWindow(node) {
  var fallback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : window;
  var doc = (0, _ownerDocument$5.default)(node);
  return doc.defaultView || doc.parentView || fallback;
}
var _default$r = ownerWindow;
ownerWindow$1.default = _default$r;
var NoSsr$2 = {};
var NoSsr$1 = {};
const require$$6$4 = _dll_react;
const require$$7$2 = _dll_prop_types;
var _interopRequireDefault$q = interopRequireDefault.exports;
Object.defineProperty(NoSsr$1, "__esModule", {
  value: true
});
NoSsr$1.default = void 0;
var _classCallCheck2$8 = _interopRequireDefault$q(classCallCheck.exports);
var _createClass2$8 = _interopRequireDefault$q(createClass.exports);
var _possibleConstructorReturn2$7 = _interopRequireDefault$q(possibleConstructorReturn.exports);
var _getPrototypeOf3$5 = _interopRequireDefault$q(getPrototypeOf$1.exports);
var _inherits2$7 = _interopRequireDefault$q(inherits.exports);
var _react$j = _interopRequireDefault$q(require$$6$4);
var _propTypes$d = _interopRequireDefault$q(require$$7$2);
var _utils$7 = require$$13$2;
var NoSsr = (function (_React$Component) {
  (0, _inherits2$7.default)(NoSsr, _React$Component);
  function NoSsr() {
    var _getPrototypeOf2;
    var _this;
    (0, _classCallCheck2$8.default)(this, NoSsr);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = (0, _possibleConstructorReturn2$7.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3$5.default)(NoSsr)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.mounted = false;
    _this.state = {
      mounted: false
    };
    return _this;
  }
  (0, _createClass2$8.default)(NoSsr, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      this.mounted = true;
      if (this.props.defer) {
        requestAnimationFrame(function () {
          requestAnimationFrame(function () {
            if (_this2.mounted) {
              _this2.setState({
                mounted: true
              });
            }
          });
        });
      } else {
        this.setState({
          mounted: true
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.mounted = false;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props, children = _this$props.children, fallback = _this$props.fallback;
      return this.state.mounted ? children : fallback;
    }
  }]);
  return NoSsr;
})(_react$j.default.Component);
NoSsr.propTypes = {
  children: _propTypes$d.default.node.isRequired,
  defer: _propTypes$d.default.bool,
  fallback: _propTypes$d.default.node
};
{
  NoSsr.propTypes = (0, _utils$7.exactProp)(NoSsr.propTypes);
}
NoSsr.defaultProps = {
  defer: false,
  fallback: null
};
var _default$q = NoSsr;
NoSsr$1.default = _default$q;
(function (exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function get() {
      return _NoSsr.default;
    }
  });
  var _NoSsr = _interopRequireDefault(NoSsr$1);
})(NoSsr$2);
getDefaultExportFromCjs(NoSsr$2);
var focusVisible = {};
var _interopRequireDefault$p = interopRequireDefault.exports;
Object.defineProperty(focusVisible, "__esModule", {
  value: true
});
focusVisible.detectFocusVisible = detectFocusVisible;
focusVisible.listenForFocusKeys = listenForFocusKeys;
var _warning$1 = _interopRequireDefault$p(warning_1);
var _ownerDocument$4 = _interopRequireDefault$p(ownerDocument$1);
var internal = {
  focusKeyPressed: false,
  keyUpEventTimeout: -1
};
function findActiveElement(doc) {
  var activeElement = doc.activeElement;
  while (activeElement && activeElement.shadowRoot && activeElement.shadowRoot.activeElement) {
    activeElement = activeElement.shadowRoot.activeElement;
  }
  return activeElement;
}
function detectFocusVisible(instance, element, callback) {
  var attempt = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 1;
  (0, _warning$1.default)(instance.focusVisibleCheckTime, 'Material-UI: missing instance.focusVisibleCheckTime.');
  (0, _warning$1.default)(instance.focusVisibleMaxCheckTimes, 'Material-UI: missing instance.focusVisibleMaxCheckTimes.');
  instance.focusVisibleTimeout = setTimeout(function () {
    var doc = (0, _ownerDocument$4.default)(element);
    var activeElement = findActiveElement(doc);
    if (internal.focusKeyPressed && (activeElement === element || element.contains(activeElement))) {
      callback();
    } else if (attempt < instance.focusVisibleMaxCheckTimes) {
      detectFocusVisible(instance, element, callback, attempt + 1);
    }
  }, instance.focusVisibleCheckTime);
}
var FOCUS_KEYS = [9, 13, 27, 32, 37, 38, 39, 40];
function isFocusKey(event) {
  return FOCUS_KEYS.indexOf(event.keyCode) > -1;
}
var handleKeyUpEvent = function handleKeyUpEvent(event) {
  if (isFocusKey(event)) {
    internal.focusKeyPressed = true;
    clearTimeout(internal.keyUpEventTimeout);
    internal.keyUpEventTimeout = setTimeout(function () {
      internal.focusKeyPressed = false;
    }, 500);
  }
};
function listenForFocusKeys(win) {
  win.addEventListener('keyup', handleKeyUpEvent);
}
var TouchRipple$1 = {};
var toConsumableArray = {
  exports: {}
};
var arrayWithoutHoles = {
  exports: {}
};
var arrayLikeToArray = {
  exports: {}
};
(function (module) {
  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for (var i = 0, arr2 = new Array(len); i < len; i++) {
      arr2[i] = arr[i];
    }
    return arr2;
  }
  (module.exports = _arrayLikeToArray, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(arrayLikeToArray);
getDefaultExportFromCjs(arrayLikeToArray.exports);
(function (module) {
  var arrayLikeToArray$1 = arrayLikeToArray.exports;
  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return arrayLikeToArray$1(arr);
  }
  (module.exports = _arrayWithoutHoles, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(arrayWithoutHoles);
getDefaultExportFromCjs(arrayWithoutHoles.exports);
var iterableToArray = {
  exports: {}
};
(function (module) {
  function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
  }
  (module.exports = _iterableToArray, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(iterableToArray);
getDefaultExportFromCjs(iterableToArray.exports);
var unsupportedIterableToArray = {
  exports: {}
};
(function (module) {
  var arrayLikeToArray$1 = arrayLikeToArray.exports;
  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return arrayLikeToArray$1(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || (/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/).test(n)) return arrayLikeToArray$1(o, minLen);
  }
  (module.exports = _unsupportedIterableToArray, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(unsupportedIterableToArray);
getDefaultExportFromCjs(unsupportedIterableToArray.exports);
var nonIterableSpread = {
  exports: {}
};
(function (module) {
  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  (module.exports = _nonIterableSpread, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(nonIterableSpread);
getDefaultExportFromCjs(nonIterableSpread.exports);
(function (module) {
  var arrayWithoutHoles$1 = arrayWithoutHoles.exports;
  var iterableToArray$1 = iterableToArray.exports;
  var unsupportedIterableToArray$1 = unsupportedIterableToArray.exports;
  var nonIterableSpread$1 = nonIterableSpread.exports;
  function _toConsumableArray(arr) {
    return arrayWithoutHoles$1(arr) || iterableToArray$1(arr) || unsupportedIterableToArray$1(arr) || nonIterableSpread$1();
  }
  (module.exports = _toConsumableArray, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(toConsumableArray);
getDefaultExportFromCjs(toConsumableArray.exports);
var TransitionGroup = {
  exports: {}
};
var ChildMapping = {};
const require$$0$1 = _dll_react;
ChildMapping.__esModule = true;
ChildMapping.getChildMapping = getChildMapping;
ChildMapping.mergeChildMappings = mergeChildMappings;
ChildMapping.getInitialChildMapping = getInitialChildMapping;
ChildMapping.getNextChildMapping = getNextChildMapping;
var _react$i = require$$0$1;
function getChildMapping(children, mapFn) {
  var mapper = function mapper(child) {
    return mapFn && (0, _react$i.isValidElement)(child) ? mapFn(child) : child;
  };
  var result = Object.create(null);
  if (children) _react$i.Children.map(children, function (c) {
    return c;
  }).forEach(function (child) {
    result[child.key] = mapper(child);
  });
  return result;
}
function mergeChildMappings(prev, next) {
  prev = prev || ({});
  next = next || ({});
  function getValueForKey(key) {
    return (key in next) ? next[key] : prev[key];
  }
  var nextKeysPending = Object.create(null);
  var pendingKeys = [];
  for (var prevKey in prev) {
    if ((prevKey in next)) {
      if (pendingKeys.length) {
        nextKeysPending[prevKey] = pendingKeys;
        pendingKeys = [];
      }
    } else {
      pendingKeys.push(prevKey);
    }
  }
  var i;
  var childMapping = {};
  for (var nextKey in next) {
    if (nextKeysPending[nextKey]) {
      for (i = 0; i < nextKeysPending[nextKey].length; i++) {
        var pendingNextKey = nextKeysPending[nextKey][i];
        childMapping[nextKeysPending[nextKey][i]] = getValueForKey(pendingNextKey);
      }
    }
    childMapping[nextKey] = getValueForKey(nextKey);
  }
  for (i = 0; i < pendingKeys.length; i++) {
    childMapping[pendingKeys[i]] = getValueForKey(pendingKeys[i]);
  }
  return childMapping;
}
function getProp(child, prop, props) {
  return props[prop] != null ? props[prop] : child.props[prop];
}
function getInitialChildMapping(props, onExited) {
  return getChildMapping(props.children, function (child) {
    return (0, _react$i.cloneElement)(child, {
      onExited: onExited.bind(null, child),
      in: true,
      appear: getProp(child, 'appear', props),
      enter: getProp(child, 'enter', props),
      exit: getProp(child, 'exit', props)
    });
  });
}
function getNextChildMapping(nextProps, prevChildMapping, onExited) {
  var nextChildMapping = getChildMapping(nextProps.children);
  var children = mergeChildMappings(prevChildMapping, nextChildMapping);
  Object.keys(children).forEach(function (key) {
    var child = children[key];
    if (!(0, _react$i.isValidElement)(child)) return;
    var hasPrev = (key in prevChildMapping);
    var hasNext = (key in nextChildMapping);
    var prevChild = prevChildMapping[key];
    var isLeaving = (0, _react$i.isValidElement)(prevChild) && !prevChild.props.in;
    if (hasNext && (!hasPrev || isLeaving)) {
      children[key] = (0, _react$i.cloneElement)(child, {
        onExited: onExited.bind(null, child),
        in: true,
        exit: getProp(child, 'exit', nextProps),
        enter: getProp(child, 'enter', nextProps)
      });
    } else if (!hasNext && hasPrev && !isLeaving) {
      children[key] = (0, _react$i.cloneElement)(child, {
        in: false
      });
    } else if (hasNext && hasPrev && (0, _react$i.isValidElement)(prevChild)) {
      children[key] = (0, _react$i.cloneElement)(child, {
        onExited: onExited.bind(null, child),
        in: prevChild.props.in,
        exit: getProp(child, 'exit', nextProps),
        enter: getProp(child, 'enter', nextProps)
      });
    }
  });
  return children;
}
const require$$0 = _dll_prop_types;
const require$$1$4 = _dll_react;
(function (module, exports) {
  exports.__esModule = true;
  exports.default = void 0;
  var _propTypes = _interopRequireDefault(require$$0);
  var _react = _interopRequireDefault(require$$1$4);
  var _reactLifecyclesCompat = require$$2$4;
  var _ChildMapping = ChildMapping;
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }
  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }
    return target;
  }
  function _extends() {
    _extends = Object.assign || (function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];
        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }
      return target;
    });
    return _extends.apply(this, arguments);
  }
  function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    subClass.__proto__ = superClass;
  }
  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
  }
  var values = Object.values || (function (obj) {
    return Object.keys(obj).map(function (k) {
      return obj[k];
    });
  });
  var defaultProps = {
    component: 'div',
    childFactory: function childFactory(child) {
      return child;
    }
  };
  var TransitionGroup = (function (_React$Component) {
    _inheritsLoose(TransitionGroup, _React$Component);
    function TransitionGroup(props, context) {
      var _this;
      _this = _React$Component.call(this, props, context) || this;
      var handleExited = _this.handleExited.bind(_assertThisInitialized(_assertThisInitialized(_this)));
      _this.state = {
        handleExited: handleExited,
        firstRender: true
      };
      return _this;
    }
    var _proto = TransitionGroup.prototype;
    _proto.getChildContext = function getChildContext() {
      return {
        transitionGroup: {
          isMounting: !this.appeared
        }
      };
    };
    _proto.componentDidMount = function componentDidMount() {
      this.appeared = true;
      this.mounted = true;
    };
    _proto.componentWillUnmount = function componentWillUnmount() {
      this.mounted = false;
    };
    TransitionGroup.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, _ref) {
      var prevChildMapping = _ref.children, handleExited = _ref.handleExited, firstRender = _ref.firstRender;
      return {
        children: firstRender ? (0, _ChildMapping.getInitialChildMapping)(nextProps, handleExited) : (0, _ChildMapping.getNextChildMapping)(nextProps, prevChildMapping, handleExited),
        firstRender: false
      };
    };
    _proto.handleExited = function handleExited(child, node) {
      var currentChildMapping = (0, _ChildMapping.getChildMapping)(this.props.children);
      if ((child.key in currentChildMapping)) return;
      if (child.props.onExited) {
        child.props.onExited(node);
      }
      if (this.mounted) {
        this.setState(function (state) {
          var children = _extends({}, state.children);
          delete children[child.key];
          return {
            children: children
          };
        });
      }
    };
    _proto.render = function render() {
      var _this$props = this.props, Component = _this$props.component, childFactory = _this$props.childFactory, props = _objectWithoutPropertiesLoose(_this$props, ["component", "childFactory"]);
      var children = values(this.state.children).map(childFactory);
      delete props.appear;
      delete props.enter;
      delete props.exit;
      if (Component === null) {
        return children;
      }
      return _react.default.createElement(Component, props, children);
    };
    return TransitionGroup;
  })(_react.default.Component);
  TransitionGroup.childContextTypes = {
    transitionGroup: _propTypes.default.object.isRequired
  };
  TransitionGroup.propTypes = {
    component: _propTypes.default.any,
    children: _propTypes.default.node,
    appear: _propTypes.default.bool,
    enter: _propTypes.default.bool,
    exit: _propTypes.default.bool,
    childFactory: _propTypes.default.func
  };
  TransitionGroup.defaultProps = defaultProps;
  var _default = (0, _reactLifecyclesCompat.polyfill)(TransitionGroup);
  exports.default = _default;
  module.exports = exports["default"];
})(TransitionGroup, TransitionGroup.exports);
getDefaultExportFromCjs(TransitionGroup.exports);
var Ripple$1 = {};
const require$$9$1 = _dll_react;
const require$$10$4 = _dll_prop_types;
const require$$11$4 = _dll_classnames;
var _interopRequireDefault$o = interopRequireDefault.exports;
Object.defineProperty(Ripple$1, "__esModule", {
  value: true
});
Ripple$1.default = void 0;
var _extends2$a = _interopRequireDefault$o(_extends$1.exports);
var _defineProperty2$5 = _interopRequireDefault$o(defineProperty$1.exports);
var _objectWithoutProperties2$9 = _interopRequireDefault$o(objectWithoutProperties.exports);
var _classCallCheck2$7 = _interopRequireDefault$o(classCallCheck.exports);
var _createClass2$7 = _interopRequireDefault$o(createClass.exports);
var _possibleConstructorReturn2$6 = _interopRequireDefault$o(possibleConstructorReturn.exports);
var _getPrototypeOf3$4 = _interopRequireDefault$o(getPrototypeOf$1.exports);
var _inherits2$6 = _interopRequireDefault$o(inherits.exports);
var _react$h = _interopRequireDefault$o(require$$9$1);
var _propTypes$c = _interopRequireDefault$o(require$$10$4);
var _classnames$a = _interopRequireDefault$o(require$$11$4);
var _Transition = _interopRequireDefault$o(Transition$1);
var Ripple = (function (_React$Component) {
  (0, _inherits2$6.default)(Ripple, _React$Component);
  function Ripple() {
    var _getPrototypeOf2;
    var _this;
    (0, _classCallCheck2$7.default)(this, Ripple);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = (0, _possibleConstructorReturn2$6.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3$4.default)(Ripple)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      visible: false,
      leaving: false
    };
    _this.handleEnter = function () {
      _this.setState({
        visible: true
      });
    };
    _this.handleExit = function () {
      _this.setState({
        leaving: true
      });
    };
    return _this;
  }
  (0, _createClass2$7.default)(Ripple, [{
    key: "render",
    value: function render() {
      var _classNames, _classNames2;
      var _this$props = this.props, classes = _this$props.classes, classNameProp = _this$props.className, pulsate = _this$props.pulsate, rippleX = _this$props.rippleX, rippleY = _this$props.rippleY, rippleSize = _this$props.rippleSize, other = (0, _objectWithoutProperties2$9.default)(_this$props, ["classes", "className", "pulsate", "rippleX", "rippleY", "rippleSize"]);
      var _this$state = this.state, visible = _this$state.visible, leaving = _this$state.leaving;
      var rippleClassName = (0, _classnames$a.default)(classes.ripple, (_classNames = {}, (0, _defineProperty2$5.default)(_classNames, classes.rippleVisible, visible), (0, _defineProperty2$5.default)(_classNames, classes.ripplePulsate, pulsate), _classNames), classNameProp);
      var rippleStyles = {
        width: rippleSize,
        height: rippleSize,
        top: -(rippleSize / 2) + rippleY,
        left: -(rippleSize / 2) + rippleX
      };
      var childClassName = (0, _classnames$a.default)(classes.child, (_classNames2 = {}, (0, _defineProperty2$5.default)(_classNames2, classes.childLeaving, leaving), (0, _defineProperty2$5.default)(_classNames2, classes.childPulsate, pulsate), _classNames2));
      return _react$h.default.createElement(_Transition.default, (0, _extends2$a.default)({
        onEnter: this.handleEnter,
        onExit: this.handleExit
      }, other), _react$h.default.createElement("span", {
        className: rippleClassName,
        style: rippleStyles
      }, _react$h.default.createElement("span", {
        className: childClassName
      })));
    }
  }]);
  return Ripple;
})(_react$h.default.Component);
Ripple.propTypes = {
  classes: _propTypes$c.default.object.isRequired,
  className: _propTypes$c.default.string,
  pulsate: _propTypes$c.default.bool,
  rippleSize: _propTypes$c.default.number,
  rippleX: _propTypes$c.default.number,
  rippleY: _propTypes$c.default.number
};
Ripple.defaultProps = {
  pulsate: false
};
var _default$p = Ripple;
Ripple$1.default = _default$p;
const require$$10$3 = _dll_react;
const require$$11$3 = _dll_prop_types;
const require$$12$2 = _dll_react_dom;
const require$$14 = _dll_classnames;
var _interopRequireDefault$n = interopRequireDefault.exports;
Object.defineProperty(TouchRipple$1, "__esModule", {
  value: true
});
TouchRipple$1.default = TouchRipple$1.styles = TouchRipple$1.DELAY_RIPPLE = void 0;
var _extends2$9 = _interopRequireDefault$n(_extends$1.exports);
var _objectWithoutProperties2$8 = _interopRequireDefault$n(objectWithoutProperties.exports);
var _toConsumableArray2 = _interopRequireDefault$n(toConsumableArray.exports);
var _classCallCheck2$6 = _interopRequireDefault$n(classCallCheck.exports);
var _createClass2$6 = _interopRequireDefault$n(createClass.exports);
var _possibleConstructorReturn2$5 = _interopRequireDefault$n(possibleConstructorReturn.exports);
var _getPrototypeOf3$3 = _interopRequireDefault$n(getPrototypeOf$1.exports);
var _inherits2$5 = _interopRequireDefault$n(inherits.exports);
var _assertThisInitialized2$2 = _interopRequireDefault$n(assertThisInitialized.exports);
var _react$g = _interopRequireDefault$n(require$$10$3);
var _propTypes$b = _interopRequireDefault$n(require$$11$3);
var _reactDom$4 = _interopRequireDefault$n(require$$12$2);
var _TransitionGroup = _interopRequireDefault$n(TransitionGroup.exports);
var _classnames$9 = _interopRequireDefault$n(require$$14);
var _withStyles$9 = _interopRequireDefault$n(withStyles);
var _Ripple = _interopRequireDefault$n(Ripple$1);
var DURATION = 550;
var DELAY_RIPPLE = 80;
TouchRipple$1.DELAY_RIPPLE = DELAY_RIPPLE;
var styles$9 = function styles(theme) {
  return {
    root: {
      display: 'block',
      position: 'absolute',
      overflow: 'hidden',
      borderRadius: 'inherit',
      width: '100%',
      height: '100%',
      left: 0,
      top: 0,
      pointerEvents: 'none',
      zIndex: 0
    },
    ripple: {
      width: 50,
      height: 50,
      left: 0,
      top: 0,
      opacity: 0,
      position: 'absolute'
    },
    rippleVisible: {
      opacity: 0.3,
      transform: 'scale(1)',
      animation: ("mui-ripple-enter ").concat(DURATION, "ms ").concat(theme.transitions.easing.easeInOut),
      animationName: '$mui-ripple-enter'
    },
    ripplePulsate: {
      animationDuration: ("").concat(theme.transitions.duration.shorter, "ms")
    },
    child: {
      opacity: 1,
      display: 'block',
      width: '100%',
      height: '100%',
      borderRadius: '50%',
      backgroundColor: 'currentColor'
    },
    childLeaving: {
      opacity: 0,
      animation: ("mui-ripple-exit ").concat(DURATION, "ms ").concat(theme.transitions.easing.easeInOut),
      animationName: '$mui-ripple-exit'
    },
    childPulsate: {
      position: 'absolute',
      left: 0,
      top: 0,
      animation: ("mui-ripple-pulsate 2500ms ").concat(theme.transitions.easing.easeInOut, " 200ms infinite"),
      animationName: '$mui-ripple-pulsate'
    },
    '@keyframes mui-ripple-enter': {
      '0%': {
        transform: 'scale(0)',
        opacity: 0.1
      },
      '100%': {
        transform: 'scale(1)',
        opacity: 0.3
      }
    },
    '@keyframes mui-ripple-exit': {
      '0%': {
        opacity: 1
      },
      '100%': {
        opacity: 0
      }
    },
    '@keyframes mui-ripple-pulsate': {
      '0%': {
        transform: 'scale(1)'
      },
      '50%': {
        transform: 'scale(0.92)'
      },
      '100%': {
        transform: 'scale(1)'
      }
    }
  };
};
TouchRipple$1.styles = styles$9;
var TouchRipple = (function (_React$PureComponent) {
  (0, _inherits2$5.default)(TouchRipple, _React$PureComponent);
  function TouchRipple() {
    var _getPrototypeOf2;
    var _this;
    (0, _classCallCheck2$6.default)(this, TouchRipple);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = (0, _possibleConstructorReturn2$5.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3$3.default)(TouchRipple)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      nextKey: 0,
      ripples: []
    };
    _this.pulsate = function () {
      _this.start({}, {
        pulsate: true
      });
    };
    _this.start = function () {
      var event = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var cb = arguments.length > 2 ? arguments[2] : undefined;
      var _options$pulsate = options.pulsate, pulsate = _options$pulsate === void 0 ? false : _options$pulsate, _options$center = options.center, center = _options$center === void 0 ? _this.props.center || options.pulsate : _options$center, _options$fakeElement = options.fakeElement, fakeElement = _options$fakeElement === void 0 ? false : _options$fakeElement;
      if (event.type === 'mousedown' && _this.ignoringMouseDown) {
        _this.ignoringMouseDown = false;
        return;
      }
      if (event.type === 'touchstart') {
        _this.ignoringMouseDown = true;
      }
      var element = fakeElement ? null : _reactDom$4.default.findDOMNode((0, _assertThisInitialized2$2.default)((0, _assertThisInitialized2$2.default)(_this)));
      var rect = element ? element.getBoundingClientRect() : {
        width: 0,
        height: 0,
        left: 0,
        top: 0
      };
      var rippleX;
      var rippleY;
      var rippleSize;
      if (center || event.clientX === 0 && event.clientY === 0 || !event.clientX && !event.touches) {
        rippleX = Math.round(rect.width / 2);
        rippleY = Math.round(rect.height / 2);
      } else {
        var clientX = event.clientX ? event.clientX : event.touches[0].clientX;
        var clientY = event.clientY ? event.clientY : event.touches[0].clientY;
        rippleX = Math.round(clientX - rect.left);
        rippleY = Math.round(clientY - rect.top);
      }
      if (center) {
        rippleSize = Math.sqrt((2 * Math.pow(rect.width, 2) + Math.pow(rect.height, 2)) / 3);
        if (rippleSize % 2 === 0) {
          rippleSize += 1;
        }
      } else {
        var sizeX = Math.max(Math.abs((element ? element.clientWidth : 0) - rippleX), rippleX) * 2 + 2;
        var sizeY = Math.max(Math.abs((element ? element.clientHeight : 0) - rippleY), rippleY) * 2 + 2;
        rippleSize = Math.sqrt(Math.pow(sizeX, 2) + Math.pow(sizeY, 2));
      }
      if (event.touches) {
        _this.startTimerCommit = function () {
          _this.startCommit({
            pulsate: pulsate,
            rippleX: rippleX,
            rippleY: rippleY,
            rippleSize: rippleSize,
            cb: cb
          });
        };
        _this.startTimer = setTimeout(function () {
          if (_this.startTimerCommit) {
            _this.startTimerCommit();
            _this.startTimerCommit = null;
          }
        }, DELAY_RIPPLE);
      } else {
        _this.startCommit({
          pulsate: pulsate,
          rippleX: rippleX,
          rippleY: rippleY,
          rippleSize: rippleSize,
          cb: cb
        });
      }
    };
    _this.startCommit = function (params) {
      var pulsate = params.pulsate, rippleX = params.rippleX, rippleY = params.rippleY, rippleSize = params.rippleSize, cb = params.cb;
      _this.setState(function (state) {
        return {
          nextKey: state.nextKey + 1,
          ripples: [].concat((0, _toConsumableArray2.default)(state.ripples), [_react$g.default.createElement(_Ripple.default, {
            key: state.nextKey,
            classes: _this.props.classes,
            timeout: {
              exit: DURATION,
              enter: DURATION
            },
            pulsate: pulsate,
            rippleX: rippleX,
            rippleY: rippleY,
            rippleSize: rippleSize
          })])
        };
      }, cb);
    };
    _this.stop = function (event, cb) {
      clearTimeout(_this.startTimer);
      var ripples = _this.state.ripples;
      if (event.type === 'touchend' && _this.startTimerCommit) {
        event.persist();
        _this.startTimerCommit();
        _this.startTimerCommit = null;
        _this.startTimer = setTimeout(function () {
          _this.stop(event, cb);
        });
        return;
      }
      _this.startTimerCommit = null;
      if (ripples && ripples.length) {
        _this.setState({
          ripples: ripples.slice(1)
        }, cb);
      }
    };
    return _this;
  }
  (0, _createClass2$6.default)(TouchRipple, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.startTimer);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props;
      _this$props.center;
      var classes = _this$props.classes, className = _this$props.className, other = (0, _objectWithoutProperties2$8.default)(_this$props, ["center", "classes", "className"]);
      return _react$g.default.createElement(_TransitionGroup.default, (0, _extends2$9.default)({
        component: "span",
        enter: true,
        exit: true,
        className: (0, _classnames$9.default)(classes.root, className)
      }, other), this.state.ripples);
    }
  }]);
  return TouchRipple;
})(_react$g.default.PureComponent);
TouchRipple.propTypes = {
  center: _propTypes$b.default.bool,
  classes: _propTypes$b.default.object.isRequired,
  className: _propTypes$b.default.string
};
TouchRipple.defaultProps = {
  center: false
};
var _default$o = (0, _withStyles$9.default)(styles$9, {
  flip: false,
  name: 'MuiTouchRipple'
})(TouchRipple);
TouchRipple$1.default = _default$o;
var createRippleHandler$1 = {};
Object.defineProperty(createRippleHandler$1, "__esModule", {
  value: true
});
createRippleHandler$1.default = void 0;
var createRippleHandler = function createRippleHandler(instance, eventName, action, cb) {
  return function (event) {
    if (cb) {
      cb.call(instance, event);
    }
    var ignore = false;
    if (event.defaultPrevented) {
      ignore = true;
    }
    if (instance.props.disableTouchRipple && eventName !== 'Blur') {
      ignore = true;
    }
    if (!ignore && instance.ripple) {
      instance.ripple[action](event);
    }
    if (typeof instance.props[("on").concat(eventName)] === 'function') {
      instance.props[("on").concat(eventName)](event);
    }
    return true;
  };
};
if (typeof window === 'undefined') {
  createRippleHandler = function createRippleHandler() {
    return function () {};
  };
}
var _default$n = createRippleHandler;
createRippleHandler$1.default = _default$n;
const require$$10$2 = _dll_react;
const require$$11$2 = _dll_prop_types;
const require$$12$1 = _dll_react_dom;
const require$$13$1 = _dll_classnames;
var _interopRequireDefault$m = interopRequireDefault.exports;
Object.defineProperty(ButtonBase$1, "__esModule", {
  value: true
});
ButtonBase$1.default = ButtonBase$1.styles = void 0;
var _extends2$8 = _interopRequireDefault$m(_extends$1.exports);
var _defineProperty2$4 = _interopRequireDefault$m(defineProperty$1.exports);
var _objectWithoutProperties2$7 = _interopRequireDefault$m(objectWithoutProperties.exports);
var _classCallCheck2$5 = _interopRequireDefault$m(classCallCheck.exports);
var _createClass2$5 = _interopRequireDefault$m(createClass.exports);
var _possibleConstructorReturn2$4 = _interopRequireDefault$m(possibleConstructorReturn.exports);
var _getPrototypeOf3$2 = _interopRequireDefault$m(getPrototypeOf$1.exports);
var _inherits2$4 = _interopRequireDefault$m(inherits.exports);
var _assertThisInitialized2$1 = _interopRequireDefault$m(assertThisInitialized.exports);
var _react$f = _interopRequireDefault$m(require$$10$2);
var _propTypes$a = _interopRequireDefault$m(require$$11$2);
var _reactDom$3 = _interopRequireDefault$m(require$$12$1);
var _classnames$8 = _interopRequireDefault$m(require$$13$1);
var _utils$6 = require$$13$2;
var _ownerWindow$1 = _interopRequireDefault$m(ownerWindow$1);
var _withStyles$8 = _interopRequireDefault$m(withStyles);
var _NoSsr = _interopRequireDefault$m(NoSsr$2);
var _focusVisible = focusVisible;
var _TouchRipple = _interopRequireDefault$m(TouchRipple$1);
var _createRippleHandler = _interopRequireDefault$m(createRippleHandler$1);
var styles$8 = {
  root: {
    display: 'inline-flex',
    alignItems: 'center',
    justifyContent: 'center',
    position: 'relative',
    WebkitTapHighlightColor: 'transparent',
    backgroundColor: 'transparent',
    outline: 'none',
    border: 0,
    margin: 0,
    borderRadius: 0,
    padding: 0,
    cursor: 'pointer',
    userSelect: 'none',
    verticalAlign: 'middle',
    '-moz-appearance': 'none',
    '-webkit-appearance': 'none',
    textDecoration: 'none',
    color: 'inherit',
    '&::-moz-focus-inner': {
      borderStyle: 'none'
    },
    '&$disabled': {
      pointerEvents: 'none',
      cursor: 'default'
    }
  },
  disabled: {},
  focusVisible: {}
};
ButtonBase$1.styles = styles$8;
if (!_react$f.default.createContext) {
  throw new Error('Material-UI: react@16.3.0 or greater is required.');
}
var ButtonBase = (function (_React$Component) {
  (0, _inherits2$4.default)(ButtonBase, _React$Component);
  function ButtonBase() {
    var _getPrototypeOf2;
    var _this;
    (0, _classCallCheck2$5.default)(this, ButtonBase);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = (0, _possibleConstructorReturn2$4.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3$2.default)(ButtonBase)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {};
    _this.keyDown = false;
    _this.focusVisibleCheckTime = 50;
    _this.focusVisibleMaxCheckTimes = 5;
    _this.handleMouseDown = (0, _createRippleHandler.default)((0, _assertThisInitialized2$1.default)((0, _assertThisInitialized2$1.default)(_this)), 'MouseDown', 'start', function () {
      clearTimeout(_this.focusVisibleTimeout);
      if (_this.state.focusVisible) {
        _this.setState({
          focusVisible: false
        });
      }
    });
    _this.handleMouseUp = (0, _createRippleHandler.default)((0, _assertThisInitialized2$1.default)((0, _assertThisInitialized2$1.default)(_this)), 'MouseUp', 'stop');
    _this.handleMouseLeave = (0, _createRippleHandler.default)((0, _assertThisInitialized2$1.default)((0, _assertThisInitialized2$1.default)(_this)), 'MouseLeave', 'stop', function (event) {
      if (_this.state.focusVisible) {
        event.preventDefault();
      }
    });
    _this.handleTouchStart = (0, _createRippleHandler.default)((0, _assertThisInitialized2$1.default)((0, _assertThisInitialized2$1.default)(_this)), 'TouchStart', 'start');
    _this.handleTouchEnd = (0, _createRippleHandler.default)((0, _assertThisInitialized2$1.default)((0, _assertThisInitialized2$1.default)(_this)), 'TouchEnd', 'stop');
    _this.handleTouchMove = (0, _createRippleHandler.default)((0, _assertThisInitialized2$1.default)((0, _assertThisInitialized2$1.default)(_this)), 'TouchMove', 'stop');
    _this.handleContextMenu = (0, _createRippleHandler.default)((0, _assertThisInitialized2$1.default)((0, _assertThisInitialized2$1.default)(_this)), 'ContextMenu', 'stop');
    _this.handleBlur = (0, _createRippleHandler.default)((0, _assertThisInitialized2$1.default)((0, _assertThisInitialized2$1.default)(_this)), 'Blur', 'stop', function () {
      clearTimeout(_this.focusVisibleTimeout);
      if (_this.state.focusVisible) {
        _this.setState({
          focusVisible: false
        });
      }
    });
    _this.onRippleRef = function (node) {
      _this.ripple = node;
    };
    _this.onFocusVisibleHandler = function (event) {
      _this.keyDown = false;
      _this.setState({
        focusVisible: true
      });
      if (_this.props.onFocusVisible) {
        _this.props.onFocusVisible(event);
      }
    };
    _this.handleKeyDown = function (event) {
      var _this$props = _this.props, component = _this$props.component, focusRipple = _this$props.focusRipple, onKeyDown = _this$props.onKeyDown, onClick = _this$props.onClick;
      if (focusRipple && !_this.keyDown && _this.state.focusVisible && _this.ripple && event.key === ' ') {
        _this.keyDown = true;
        event.persist();
        _this.ripple.stop(event, function () {
          _this.ripple.start(event);
        });
      }
      if (onKeyDown) {
        onKeyDown(event);
      }
      if (event.target === event.currentTarget && component && component !== 'button' && (event.key === ' ' || event.key === 'Enter') && !(_this.button.tagName === 'A' && _this.button.href)) {
        event.preventDefault();
        if (onClick) {
          onClick(event);
        }
      }
    };
    _this.handleKeyUp = function (event) {
      if (_this.props.focusRipple && event.key === ' ' && _this.ripple && _this.state.focusVisible) {
        _this.keyDown = false;
        event.persist();
        _this.ripple.stop(event, function () {
          _this.ripple.pulsate(event);
        });
      }
      if (_this.props.onKeyUp) {
        _this.props.onKeyUp(event);
      }
    };
    _this.handleFocus = function (event) {
      if (_this.props.disabled) {
        return;
      }
      if (!_this.button) {
        _this.button = event.currentTarget;
      }
      event.persist();
      (0, _focusVisible.detectFocusVisible)((0, _assertThisInitialized2$1.default)((0, _assertThisInitialized2$1.default)(_this)), _this.button, function () {
        _this.onFocusVisibleHandler(event);
      });
      if (_this.props.onFocus) {
        _this.props.onFocus(event);
      }
    };
    return _this;
  }
  (0, _createClass2$5.default)(ButtonBase, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      this.button = _reactDom$3.default.findDOMNode(this);
      (0, _focusVisible.listenForFocusKeys)((0, _ownerWindow$1.default)(this.button));
      if (this.props.action) {
        this.props.action({
          focusVisible: function focusVisible() {
            _this2.setState({
              focusVisible: true
            });
            _this2.button.focus();
          }
        });
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      if (this.props.focusRipple && !this.props.disableRipple && !prevState.focusVisible && this.state.focusVisible) {
        this.ripple.pulsate();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.focusVisibleTimeout);
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props2 = this.props;
      _this$props2.action;
      var buttonRef = _this$props2.buttonRef, centerRipple = _this$props2.centerRipple, children = _this$props2.children, classes = _this$props2.classes, classNameProp = _this$props2.className, component = _this$props2.component, disabled = _this$props2.disabled, disableRipple = _this$props2.disableRipple;
      _this$props2.disableTouchRipple;
      _this$props2.focusRipple;
      var focusVisibleClassName = _this$props2.focusVisibleClassName;
      _this$props2.onBlur;
      _this$props2.onFocus;
      _this$props2.onFocusVisible;
      _this$props2.onKeyDown;
      _this$props2.onKeyUp;
      _this$props2.onMouseDown;
      _this$props2.onMouseLeave;
      _this$props2.onMouseUp;
      _this$props2.onTouchEnd;
      _this$props2.onTouchMove;
      _this$props2.onTouchStart;
      var tabIndex = _this$props2.tabIndex, TouchRippleProps = _this$props2.TouchRippleProps, type = _this$props2.type, other = (0, _objectWithoutProperties2$7.default)(_this$props2, ["action", "buttonRef", "centerRipple", "children", "classes", "className", "component", "disabled", "disableRipple", "disableTouchRipple", "focusRipple", "focusVisibleClassName", "onBlur", "onFocus", "onFocusVisible", "onKeyDown", "onKeyUp", "onMouseDown", "onMouseLeave", "onMouseUp", "onTouchEnd", "onTouchMove", "onTouchStart", "tabIndex", "TouchRippleProps", "type"]);
      var className = (0, _classnames$8.default)(classes.root, (_classNames = {}, (0, _defineProperty2$4.default)(_classNames, classes.disabled, disabled), (0, _defineProperty2$4.default)(_classNames, classes.focusVisible, this.state.focusVisible), (0, _defineProperty2$4.default)(_classNames, focusVisibleClassName, this.state.focusVisible), _classNames), classNameProp);
      var ComponentProp = component;
      if (ComponentProp === 'button' && other.href) {
        ComponentProp = 'a';
      }
      var buttonProps = {};
      if (ComponentProp === 'button') {
        buttonProps.type = type || 'button';
        buttonProps.disabled = disabled;
      } else {
        buttonProps.role = 'button';
      }
      return _react$f.default.createElement(ComponentProp, (0, _extends2$8.default)({
        className: className,
        onBlur: this.handleBlur,
        onFocus: this.handleFocus,
        onKeyDown: this.handleKeyDown,
        onKeyUp: this.handleKeyUp,
        onMouseDown: this.handleMouseDown,
        onMouseLeave: this.handleMouseLeave,
        onMouseUp: this.handleMouseUp,
        onTouchEnd: this.handleTouchEnd,
        onTouchMove: this.handleTouchMove,
        onTouchStart: this.handleTouchStart,
        onContextMenu: this.handleContextMenu,
        ref: buttonRef,
        tabIndex: disabled ? '-1' : tabIndex
      }, buttonProps, other), children, !disableRipple && !disabled ? _react$f.default.createElement(_NoSsr.default, null, _react$f.default.createElement(_TouchRipple.default, (0, _extends2$8.default)({
        innerRef: this.onRippleRef,
        center: centerRipple
      }, TouchRippleProps))) : null);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (typeof prevState.focusVisible === 'undefined') {
        return {
          focusVisible: false,
          lastDisabled: nextProps.disabled
        };
      }
      if (!prevState.prevState && nextProps.disabled && prevState.focusVisible) {
        return {
          focusVisible: false,
          lastDisabled: nextProps.disabled
        };
      }
      return {
        lastDisabled: nextProps.disabled
      };
    }
  }]);
  return ButtonBase;
})(_react$f.default.Component);
ButtonBase.propTypes = {
  action: _propTypes$a.default.func,
  buttonRef: _propTypes$a.default.oneOfType([_propTypes$a.default.func, _propTypes$a.default.object]),
  centerRipple: _propTypes$a.default.bool,
  children: _propTypes$a.default.node,
  classes: _propTypes$a.default.object.isRequired,
  className: _propTypes$a.default.string,
  component: _utils$6.componentPropType,
  disabled: _propTypes$a.default.bool,
  disableRipple: _propTypes$a.default.bool,
  disableTouchRipple: _propTypes$a.default.bool,
  focusRipple: _propTypes$a.default.bool,
  focusVisibleClassName: _propTypes$a.default.string,
  onBlur: _propTypes$a.default.func,
  onClick: _propTypes$a.default.func,
  onFocus: _propTypes$a.default.func,
  onFocusVisible: _propTypes$a.default.func,
  onKeyDown: _propTypes$a.default.func,
  onKeyUp: _propTypes$a.default.func,
  onMouseDown: _propTypes$a.default.func,
  onMouseLeave: _propTypes$a.default.func,
  onMouseUp: _propTypes$a.default.func,
  onTouchEnd: _propTypes$a.default.func,
  onTouchMove: _propTypes$a.default.func,
  onTouchStart: _propTypes$a.default.func,
  role: _propTypes$a.default.string,
  tabIndex: _propTypes$a.default.oneOfType([_propTypes$a.default.number, _propTypes$a.default.string]),
  TouchRippleProps: _propTypes$a.default.object,
  type: _propTypes$a.default.string
};
ButtonBase.defaultProps = {
  centerRipple: false,
  component: 'button',
  disableRipple: false,
  disableTouchRipple: false,
  focusRipple: false,
  tabIndex: '0',
  type: 'button'
};
var _default$m = (0, _withStyles$8.default)(styles$8, {
  name: 'MuiButtonBase'
})(ButtonBase);
ButtonBase$1.default = _default$m;
(function (exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function get() {
      return _ButtonBase.default;
    }
  });
  var _ButtonBase = _interopRequireDefault(ButtonBase$1);
})(ButtonBase$2);
getDefaultExportFromCjs(ButtonBase$2);
var Button$3 = {};
var Button$2 = {};
const require$$4$4 = _dll_react;
const require$$5$4 = _dll_prop_types;
const require$$6$3 = _dll_classnames;
var _interopRequireDefault$l = interopRequireDefault.exports;
Object.defineProperty(Button$2, "__esModule", {
  value: true
});
Button$2.default = Button$2.styles = void 0;
var _defineProperty2$3 = _interopRequireDefault$l(defineProperty$1.exports);
var _objectWithoutProperties2$6 = _interopRequireDefault$l(objectWithoutProperties.exports);
var _extends2$7 = _interopRequireDefault$l(_extends$1.exports);
var _react$e = _interopRequireDefault$l(require$$4$4);
var _propTypes$9 = _interopRequireDefault$l(require$$5$4);
var _classnames$7 = _interopRequireDefault$l(require$$6$3);
var _utils$5 = require$$13$2;
var _withStyles$7 = _interopRequireDefault$l(withStyles);
var _colorManipulator = colorManipulator;
var _ButtonBase = _interopRequireDefault$l(ButtonBase$2);
var _helpers$3 = helpers;
var styles$7 = function styles(theme) {
  return {
    root: (0, _extends2$7.default)({
      lineHeight: 1.75
    }, theme.typography.button, {
      boxSizing: 'border-box',
      minWidth: 64,
      padding: '6px 16px',
      borderRadius: theme.shape.borderRadius,
      color: theme.palette.text.primary,
      transition: theme.transitions.create(['background-color', 'box-shadow', 'border'], {
        duration: theme.transitions.duration.short
      }),
      '&:hover': {
        textDecoration: 'none',
        backgroundColor: (0, _colorManipulator.fade)(theme.palette.text.primary, theme.palette.action.hoverOpacity),
        '@media (hover: none)': {
          backgroundColor: 'transparent'
        },
        '&$disabled': {
          backgroundColor: 'transparent'
        }
      },
      '&$disabled': {
        color: theme.palette.action.disabled
      }
    }),
    label: {
      width: '100%',
      display: 'inherit',
      alignItems: 'inherit',
      justifyContent: 'inherit'
    },
    text: {
      padding: '6px 8px'
    },
    textPrimary: {
      color: theme.palette.primary.main,
      '&:hover': {
        backgroundColor: (0, _colorManipulator.fade)(theme.palette.primary.main, theme.palette.action.hoverOpacity),
        '@media (hover: none)': {
          backgroundColor: 'transparent'
        }
      }
    },
    textSecondary: {
      color: theme.palette.secondary.main,
      '&:hover': {
        backgroundColor: (0, _colorManipulator.fade)(theme.palette.secondary.main, theme.palette.action.hoverOpacity),
        '@media (hover: none)': {
          backgroundColor: 'transparent'
        }
      }
    },
    flat: {},
    flatPrimary: {},
    flatSecondary: {},
    outlined: {
      padding: '5px 16px',
      border: ("1px solid ").concat(theme.palette.type === 'light' ? 'rgba(0, 0, 0, 0.23)' : 'rgba(255, 255, 255, 0.23)'),
      '&$disabled': {
        border: ("1px solid ").concat(theme.palette.action.disabled)
      }
    },
    outlinedPrimary: {
      color: theme.palette.primary.main,
      border: ("1px solid ").concat((0, _colorManipulator.fade)(theme.palette.primary.main, 0.5)),
      '&:hover': {
        border: ("1px solid ").concat(theme.palette.primary.main),
        backgroundColor: (0, _colorManipulator.fade)(theme.palette.primary.main, theme.palette.action.hoverOpacity),
        '@media (hover: none)': {
          backgroundColor: 'transparent'
        }
      }
    },
    outlinedSecondary: {
      color: theme.palette.secondary.main,
      border: ("1px solid ").concat((0, _colorManipulator.fade)(theme.palette.secondary.main, 0.5)),
      '&:hover': {
        border: ("1px solid ").concat(theme.palette.secondary.main),
        backgroundColor: (0, _colorManipulator.fade)(theme.palette.secondary.main, theme.palette.action.hoverOpacity),
        '@media (hover: none)': {
          backgroundColor: 'transparent'
        }
      },
      '&$disabled': {
        border: ("1px solid ").concat(theme.palette.action.disabled)
      }
    },
    contained: {
      color: theme.palette.getContrastText(theme.palette.grey[300]),
      backgroundColor: theme.palette.grey[300],
      boxShadow: theme.shadows[2],
      '&$focusVisible': {
        boxShadow: theme.shadows[6]
      },
      '&:active': {
        boxShadow: theme.shadows[8]
      },
      '&$disabled': {
        color: theme.palette.action.disabled,
        boxShadow: theme.shadows[0],
        backgroundColor: theme.palette.action.disabledBackground
      },
      '&:hover': {
        backgroundColor: theme.palette.grey.A100,
        '@media (hover: none)': {
          backgroundColor: theme.palette.grey[300]
        },
        '&$disabled': {
          backgroundColor: theme.palette.action.disabledBackground
        }
      }
    },
    containedPrimary: {
      color: theme.palette.primary.contrastText,
      backgroundColor: theme.palette.primary.main,
      '&:hover': {
        backgroundColor: theme.palette.primary.dark,
        '@media (hover: none)': {
          backgroundColor: theme.palette.primary.main
        }
      }
    },
    containedSecondary: {
      color: theme.palette.secondary.contrastText,
      backgroundColor: theme.palette.secondary.main,
      '&:hover': {
        backgroundColor: theme.palette.secondary.dark,
        '@media (hover: none)': {
          backgroundColor: theme.palette.secondary.main
        }
      }
    },
    raised: {},
    raisedPrimary: {},
    raisedSecondary: {},
    fab: {
      borderRadius: '50%',
      padding: 0,
      minWidth: 0,
      width: 56,
      height: 56,
      boxShadow: theme.shadows[6],
      '&:active': {
        boxShadow: theme.shadows[12]
      }
    },
    extendedFab: {
      borderRadius: 48 / 2,
      padding: '0 16px',
      width: 'auto',
      minWidth: 48,
      height: 48
    },
    focusVisible: {},
    disabled: {},
    colorInherit: {
      color: 'inherit',
      borderColor: 'currentColor'
    },
    mini: {
      width: 40,
      height: 40
    },
    sizeSmall: {
      padding: '4px 8px',
      minWidth: 64,
      fontSize: theme.typography.pxToRem(13)
    },
    sizeLarge: {
      padding: '8px 24px',
      fontSize: theme.typography.pxToRem(15)
    },
    fullWidth: {
      width: '100%'
    }
  };
};
Button$2.styles = styles$7;
function Button$1(props) {
  var _classNames;
  var children = props.children, classes = props.classes, classNameProp = props.className, color = props.color, disabled = props.disabled, disableFocusRipple = props.disableFocusRipple, focusVisibleClassName = props.focusVisibleClassName, fullWidth = props.fullWidth, mini = props.mini, size = props.size, variant = props.variant, other = (0, _objectWithoutProperties2$6.default)(props, ["children", "classes", "className", "color", "disabled", "disableFocusRipple", "focusVisibleClassName", "fullWidth", "mini", "size", "variant"]);
  var fab = variant === 'fab' || variant === 'extendedFab';
  var contained = variant === 'contained' || variant === 'raised';
  var text = variant === 'text' || variant === 'flat';
  var className = (0, _classnames$7.default)(classes.root, (_classNames = {}, (0, _defineProperty2$3.default)(_classNames, classes.fab, fab), (0, _defineProperty2$3.default)(_classNames, classes.mini, fab && mini), (0, _defineProperty2$3.default)(_classNames, classes.extendedFab, variant === 'extendedFab'), (0, _defineProperty2$3.default)(_classNames, classes.text, text), (0, _defineProperty2$3.default)(_classNames, classes.textPrimary, text && color === 'primary'), (0, _defineProperty2$3.default)(_classNames, classes.textSecondary, text && color === 'secondary'), (0, _defineProperty2$3.default)(_classNames, classes.flat, text), (0, _defineProperty2$3.default)(_classNames, classes.flatPrimary, text && color === 'primary'), (0, _defineProperty2$3.default)(_classNames, classes.flatSecondary, text && color === 'secondary'), (0, _defineProperty2$3.default)(_classNames, classes.contained, contained || fab), (0, _defineProperty2$3.default)(_classNames, classes.containedPrimary, (contained || fab) && color === 'primary'), (0, _defineProperty2$3.default)(_classNames, classes.containedSecondary, (contained || fab) && color === 'secondary'), (0, _defineProperty2$3.default)(_classNames, classes.raised, contained || fab), (0, _defineProperty2$3.default)(_classNames, classes.raisedPrimary, (contained || fab) && color === 'primary'), (0, _defineProperty2$3.default)(_classNames, classes.raisedSecondary, (contained || fab) && color === 'secondary'), (0, _defineProperty2$3.default)(_classNames, classes.outlined, variant === 'outlined'), (0, _defineProperty2$3.default)(_classNames, classes.outlinedPrimary, variant === 'outlined' && color === 'primary'), (0, _defineProperty2$3.default)(_classNames, classes.outlinedSecondary, variant === 'outlined' && color === 'secondary'), (0, _defineProperty2$3.default)(_classNames, classes[("size").concat((0, _helpers$3.capitalize)(size))], size !== 'medium'), (0, _defineProperty2$3.default)(_classNames, classes.disabled, disabled), (0, _defineProperty2$3.default)(_classNames, classes.fullWidth, fullWidth), (0, _defineProperty2$3.default)(_classNames, classes.colorInherit, color === 'inherit'), _classNames), classNameProp);
  return _react$e.default.createElement(_ButtonBase.default, (0, _extends2$7.default)({
    className: className,
    disabled: disabled,
    focusRipple: !disableFocusRipple,
    focusVisibleClassName: (0, _classnames$7.default)(classes.focusVisible, focusVisibleClassName)
  }, other), _react$e.default.createElement("span", {
    className: classes.label
  }, children));
}
Button$1.propTypes = {
  children: _propTypes$9.default.node.isRequired,
  classes: _propTypes$9.default.object.isRequired,
  className: _propTypes$9.default.string,
  color: _propTypes$9.default.oneOf(['default', 'inherit', 'primary', 'secondary']),
  component: _utils$5.componentPropType,
  disabled: _propTypes$9.default.bool,
  disableFocusRipple: _propTypes$9.default.bool,
  disableRipple: _propTypes$9.default.bool,
  focusVisibleClassName: _propTypes$9.default.string,
  fullWidth: _propTypes$9.default.bool,
  href: _propTypes$9.default.string,
  mini: _propTypes$9.default.bool,
  size: _propTypes$9.default.oneOf(['small', 'medium', 'large']),
  type: _propTypes$9.default.string,
  variant: (0, _utils$5.chainPropTypes)(_propTypes$9.default.oneOf(['text', 'outlined', 'contained', 'fab', 'extendedFab', 'flat', 'raised']), function (props) {
    if (props.variant === 'flat') {
      return new Error('Material-UI: the `flat` variant will be removed in the next major release. ' + '`text` is equivalent and should be used instead.');
    }
    if (props.variant === 'raised') {
      return new Error('Material-UI: the `raised` variant will be removed in the next major release. ' + '`contained` is equivalent and should be used instead.');
    }
    if (props.variant === 'fab') {
      return new Error('Material-UI: the `fab` variant will be removed in the next major release. ' + 'The `<Fab>` component is equivalent and should be used instead.');
    }
    if (props.variant === 'extendedFab') {
      return new Error('Material-UI: the `fab` variant will be removed in the next major release. ' + 'The `<Fab>` component with `variant="extended"` is equivalent ' + 'and should be used instead.');
    }
    return null;
  })
};
Button$1.defaultProps = {
  color: 'default',
  component: 'button',
  disabled: false,
  disableFocusRipple: false,
  fullWidth: false,
  mini: false,
  size: 'medium',
  type: 'button',
  variant: 'text'
};
var _default$l = (0, _withStyles$7.default)(styles$7, {
  name: 'MuiButton'
})(Button$1);
Button$2.default = _default$l;
(function (exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function get() {
      return _Button.default;
    }
  });
  var _Button = _interopRequireDefault(Button$2);
})(Button$3);
var Button = getDefaultExportFromCjs(Button$3);
var reactHelpers = {};
const require$$1$3 = _dll_react;
const require$$2$2 = _dll_classnames;
var _interopRequireDefault$k = interopRequireDefault.exports;
Object.defineProperty(reactHelpers, "__esModule", {
  value: true
});
reactHelpers.cloneElementWithClassName = cloneElementWithClassName;
reactHelpers.cloneChildrenWithClassName = cloneChildrenWithClassName;
reactHelpers.isMuiElement = isMuiElement;
reactHelpers.setRef = setRef;
var _react$d = _interopRequireDefault$k(require$$1$3);
var _classnames$6 = _interopRequireDefault$k(require$$2$2);
function cloneElementWithClassName(child, className) {
  return _react$d.default.cloneElement(child, {
    className: (0, _classnames$6.default)(child.props.className, className)
  });
}
function cloneChildrenWithClassName(children, className) {
  return _react$d.default.Children.map(children, function (child) {
    return _react$d.default.isValidElement(child) && cloneElementWithClassName(child, className);
  });
}
function isMuiElement(element, muiNames) {
  return _react$d.default.isValidElement(element) && muiNames.indexOf(element.type.muiName) !== -1;
}
function setRef(ref, value) {
  if (typeof ref === 'function') {
    ref(value);
  } else if (ref) {
    ref.current = value;
  }
}
var pure$1 = {};
var shouldUpdate$1 = {};
var inheritsLoose = {
  exports: {}
};
(function (module) {
  var setPrototypeOf$1 = setPrototypeOf.exports;
  function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    setPrototypeOf$1(subClass, superClass);
  }
  (module.exports = _inheritsLoose, module.exports.__esModule = true, module.exports["default"] = module.exports);
})(inheritsLoose);
getDefaultExportFromCjs(inheritsLoose.exports);
var setDisplayName$1 = {};
var setStatic$1 = {};
setStatic$1.__esModule = true;
setStatic$1.default = void 0;
var setStatic = function setStatic(key, value) {
  return function (BaseComponent) {
    BaseComponent[key] = value;
    return BaseComponent;
  };
};
var _default$k = setStatic;
setStatic$1.default = _default$k;
var _interopRequireDefault$j = interopRequireDefault.exports;
setDisplayName$1.__esModule = true;
setDisplayName$1.default = void 0;
var _setStatic = _interopRequireDefault$j(setStatic$1);
var setDisplayName = function setDisplayName(displayName) {
  return (0, _setStatic.default)('displayName', displayName);
};
var _default$j = setDisplayName;
setDisplayName$1.default = _default$j;
var wrapDisplayName$1 = {};
var getDisplayName$1 = {};
getDisplayName$1.__esModule = true;
getDisplayName$1.default = void 0;
var getDisplayName = function getDisplayName(Component) {
  if (typeof Component === 'string') {
    return Component;
  }
  if (!Component) {
    return undefined;
  }
  return Component.displayName || Component.name || 'Component';
};
var _default$i = getDisplayName;
getDisplayName$1.default = _default$i;
var _interopRequireDefault$i = interopRequireDefault.exports;
wrapDisplayName$1.__esModule = true;
wrapDisplayName$1.default = void 0;
var _getDisplayName = _interopRequireDefault$i(getDisplayName$1);
var wrapDisplayName = function wrapDisplayName(BaseComponent, hocName) {
  return hocName + "(" + (0, _getDisplayName.default)(BaseComponent) + ")";
};
var _default$h = wrapDisplayName;
wrapDisplayName$1.default = _default$h;
const require$$2$1 = _dll_react;
var _interopRequireDefault$h = interopRequireDefault.exports;
shouldUpdate$1.__esModule = true;
shouldUpdate$1.default = void 0;
var _inheritsLoose2 = _interopRequireDefault$h(inheritsLoose.exports);
var _react$c = require$$2$1;
var _setDisplayName$1 = _interopRequireDefault$h(setDisplayName$1);
var _wrapDisplayName$1 = _interopRequireDefault$h(wrapDisplayName$1);
var shouldUpdate = function shouldUpdate(test) {
  return function (BaseComponent) {
    var factory = (0, _react$c.createFactory)(BaseComponent);
    var ShouldUpdate = (function (_Component) {
      (0, _inheritsLoose2.default)(ShouldUpdate, _Component);
      function ShouldUpdate() {
        return _Component.apply(this, arguments) || this;
      }
      var _proto = ShouldUpdate.prototype;
      _proto.shouldComponentUpdate = function shouldComponentUpdate(nextProps) {
        return test(this.props, nextProps);
      };
      _proto.render = function render() {
        return factory(this.props);
      };
      return ShouldUpdate;
    })(_react$c.Component);
    {
      return (0, _setDisplayName$1.default)((0, _wrapDisplayName$1.default)(BaseComponent, 'shouldUpdate'))(ShouldUpdate);
    }
  };
};
var _default$g = shouldUpdate;
shouldUpdate$1.default = _default$g;
var shallowEqual$1 = {};
var hasOwnProperty = Object.prototype.hasOwnProperty;
function is(x, y) {
  if (x === y) {
    return x !== 0 || y !== 0 || 1 / x === 1 / y;
  } else {
    return x !== x && y !== y;
  }
}
function shallowEqual(objA, objB) {
  if (is(objA, objB)) {
    return true;
  }
  if (typeof objA !== 'object' || objA === null || typeof objB !== 'object' || objB === null) {
    return false;
  }
  var keysA = Object.keys(objA);
  var keysB = Object.keys(objB);
  if (keysA.length !== keysB.length) {
    return false;
  }
  for (var i = 0; i < keysA.length; i++) {
    if (!hasOwnProperty.call(objB, keysA[i]) || !is(objA[keysA[i]], objB[keysA[i]])) {
      return false;
    }
  }
  return true;
}
var shallowEqual_1 = shallowEqual;
var _interopRequireDefault$g = interopRequireDefault.exports;
shallowEqual$1.__esModule = true;
shallowEqual$1.default = void 0;
var _shallowEqual$1 = _interopRequireDefault$g(shallowEqual_1);
var _default$f = _shallowEqual$1.default;
shallowEqual$1.default = _default$f;
var _interopRequireDefault$f = interopRequireDefault.exports;
pure$1.__esModule = true;
pure$1.default = void 0;
var _shouldUpdate = _interopRequireDefault$f(shouldUpdate$1);
var _shallowEqual = _interopRequireDefault$f(shallowEqual$1);
var _setDisplayName = _interopRequireDefault$f(setDisplayName$1);
var _wrapDisplayName = _interopRequireDefault$f(wrapDisplayName$1);
var pure = function pure(BaseComponent) {
  var hoc = (0, _shouldUpdate.default)(function (props, nextProps) {
    return !(0, _shallowEqual.default)(props, nextProps);
  });
  {
    return (0, _setDisplayName.default)((0, _wrapDisplayName.default)(BaseComponent, 'pure'))(hoc(BaseComponent));
  }
};
var _default$e = pure;
pure$1.default = _default$e;
var SvgIcon$2 = {};
var SvgIcon$1 = {};
const require$$4$3 = _dll_react;
const require$$5$3 = _dll_prop_types;
const require$$6$2 = _dll_classnames;
var _interopRequireDefault$e = interopRequireDefault.exports;
Object.defineProperty(SvgIcon$1, "__esModule", {
  value: true
});
SvgIcon$1.default = SvgIcon$1.styles = void 0;
var _extends2$6 = _interopRequireDefault$e(_extends$1.exports);
var _defineProperty2$2 = _interopRequireDefault$e(defineProperty$1.exports);
var _objectWithoutProperties2$5 = _interopRequireDefault$e(objectWithoutProperties.exports);
var _react$b = _interopRequireDefault$e(require$$4$3);
var _propTypes$8 = _interopRequireDefault$e(require$$5$3);
var _classnames$5 = _interopRequireDefault$e(require$$6$2);
var _utils$4 = require$$13$2;
var _withStyles$6 = _interopRequireDefault$e(withStyles);
var _helpers$2 = helpers;
var styles$6 = function styles(theme) {
  return {
    root: {
      userSelect: 'none',
      width: '1em',
      height: '1em',
      display: 'inline-block',
      fill: 'currentColor',
      flexShrink: 0,
      fontSize: 24,
      transition: theme.transitions.create('fill', {
        duration: theme.transitions.duration.shorter
      })
    },
    colorPrimary: {
      color: theme.palette.primary.main
    },
    colorSecondary: {
      color: theme.palette.secondary.main
    },
    colorAction: {
      color: theme.palette.action.active
    },
    colorError: {
      color: theme.palette.error.main
    },
    colorDisabled: {
      color: theme.palette.action.disabled
    },
    fontSizeInherit: {
      fontSize: 'inherit'
    },
    fontSizeSmall: {
      fontSize: 20
    },
    fontSizeLarge: {
      fontSize: 35
    }
  };
};
SvgIcon$1.styles = styles$6;
function SvgIcon(props) {
  var _classNames;
  var children = props.children, classes = props.classes, className = props.className, color = props.color, Component = props.component, fontSize = props.fontSize, nativeColor = props.nativeColor, titleAccess = props.titleAccess, viewBox = props.viewBox, other = (0, _objectWithoutProperties2$5.default)(props, ["children", "classes", "className", "color", "component", "fontSize", "nativeColor", "titleAccess", "viewBox"]);
  return _react$b.default.createElement(Component, (0, _extends2$6.default)({
    className: (0, _classnames$5.default)(classes.root, (_classNames = {}, (0, _defineProperty2$2.default)(_classNames, classes[("color").concat((0, _helpers$2.capitalize)(color))], color !== 'inherit'), (0, _defineProperty2$2.default)(_classNames, classes[("fontSize").concat((0, _helpers$2.capitalize)(fontSize))], fontSize !== 'default'), _classNames), className),
    focusable: "false",
    viewBox: viewBox,
    color: nativeColor,
    "aria-hidden": titleAccess ? 'false' : 'true',
    role: titleAccess ? 'img' : 'presentation'
  }, other), children, titleAccess ? _react$b.default.createElement("title", null, titleAccess) : null);
}
SvgIcon.propTypes = {
  children: _propTypes$8.default.node.isRequired,
  classes: _propTypes$8.default.object.isRequired,
  className: _propTypes$8.default.string,
  color: _propTypes$8.default.oneOf(['inherit', 'primary', 'secondary', 'action', 'error', 'disabled']),
  component: _utils$4.componentPropType,
  fontSize: _propTypes$8.default.oneOf(['inherit', 'default', 'small', 'large']),
  nativeColor: _propTypes$8.default.string,
  shapeRendering: _propTypes$8.default.string,
  titleAccess: _propTypes$8.default.string,
  viewBox: _propTypes$8.default.string
};
SvgIcon.defaultProps = {
  color: 'inherit',
  component: 'svg',
  fontSize: 'default',
  viewBox: '0 0 24 24'
};
SvgIcon.muiName = 'SvgIcon';
var _default$d = (0, _withStyles$6.default)(styles$6, {
  name: 'MuiSvgIcon'
})(SvgIcon);
SvgIcon$1.default = _default$d;
(function (exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function get() {
      return _SvgIcon.default;
    }
  });
  var _SvgIcon = _interopRequireDefault(SvgIcon$1);
})(SvgIcon$2);
getDefaultExportFromCjs(SvgIcon$2);
var Dialog$3 = {};
var Dialog$2 = {};
var Modal$2 = {};
var Modal$1 = {};
var RootRef$2 = {};
var RootRef$1 = {};
const require$$6$1 = _dll_react;
const require$$7$1 = _dll_react_dom;
const require$$8$1 = _dll_prop_types;
var _interopRequireDefault$d = interopRequireDefault.exports;
Object.defineProperty(RootRef$1, "__esModule", {
  value: true
});
RootRef$1.default = void 0;
var _classCallCheck2$4 = _interopRequireDefault$d(classCallCheck.exports);
var _createClass2$4 = _interopRequireDefault$d(createClass.exports);
var _possibleConstructorReturn2$3 = _interopRequireDefault$d(possibleConstructorReturn.exports);
var _getPrototypeOf2$1 = _interopRequireDefault$d(getPrototypeOf$1.exports);
var _inherits2$3 = _interopRequireDefault$d(inherits.exports);
var _react$a = _interopRequireDefault$d(require$$6$1);
var _reactDom$2 = _interopRequireDefault$d(require$$7$1);
var _propTypes$7 = _interopRequireDefault$d(require$$8$1);
var _utils$3 = require$$13$2;
var _reactHelpers$1 = reactHelpers;
var RootRef = (function (_React$Component) {
  (0, _inherits2$3.default)(RootRef, _React$Component);
  function RootRef() {
    (0, _classCallCheck2$4.default)(this, RootRef);
    return (0, _possibleConstructorReturn2$3.default)(this, (0, _getPrototypeOf2$1.default)(RootRef).apply(this, arguments));
  }
  (0, _createClass2$4.default)(RootRef, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.ref = _reactDom$2.default.findDOMNode(this);
      (0, _reactHelpers$1.setRef)(this.props.rootRef, this.ref);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var ref = _reactDom$2.default.findDOMNode(this);
      if (prevProps.rootRef !== this.props.rootRef || this.ref !== ref) {
        if (prevProps.rootRef !== this.props.rootRef) {
          (0, _reactHelpers$1.setRef)(prevProps.rootRef, null);
        }
        this.ref = ref;
        (0, _reactHelpers$1.setRef)(this.props.rootRef, this.ref);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.ref = null;
      (0, _reactHelpers$1.setRef)(this.props.rootRef, null);
    }
  }, {
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }]);
  return RootRef;
})(_react$a.default.Component);
RootRef.propTypes = {
  children: _propTypes$7.default.element.isRequired,
  rootRef: _propTypes$7.default.oneOfType([_propTypes$7.default.func, _propTypes$7.default.object]).isRequired
};
{
  RootRef.propTypes = (0, _utils$3.exactProp)(RootRef.propTypes);
}
var _default$c = RootRef;
RootRef$1.default = _default$c;
(function (exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function get() {
      return _RootRef.default;
    }
  });
  var _RootRef = _interopRequireDefault(RootRef$1);
})(RootRef$2);
getDefaultExportFromCjs(RootRef$2);
var Portal$2 = {};
var Portal$1 = {};
const require$$6 = _dll_react;
const require$$7 = _dll_react_dom;
const require$$8 = _dll_prop_types;
var _interopRequireDefault$c = interopRequireDefault.exports;
Object.defineProperty(Portal$1, "__esModule", {
  value: true
});
Portal$1.default = void 0;
var _classCallCheck2$3 = _interopRequireDefault$c(classCallCheck.exports);
var _createClass2$3 = _interopRequireDefault$c(createClass.exports);
var _possibleConstructorReturn2$2 = _interopRequireDefault$c(possibleConstructorReturn.exports);
var _getPrototypeOf3$1 = _interopRequireDefault$c(getPrototypeOf$1.exports);
var _inherits2$2 = _interopRequireDefault$c(inherits.exports);
var _react$9 = _interopRequireDefault$c(require$$6);
var _reactDom$1 = _interopRequireDefault$c(require$$7);
var _propTypes$6 = _interopRequireDefault$c(require$$8);
var _ownerDocument$3 = _interopRequireDefault$c(ownerDocument$1);
var _utils$2 = require$$13$2;
function getContainer$1(container, defaultContainer) {
  container = typeof container === 'function' ? container() : container;
  return _reactDom$1.default.findDOMNode(container) || defaultContainer;
}
function getOwnerDocument(element) {
  return (0, _ownerDocument$3.default)(_reactDom$1.default.findDOMNode(element));
}
var Portal = (function (_React$Component) {
  (0, _inherits2$2.default)(Portal, _React$Component);
  function Portal() {
    var _getPrototypeOf2;
    var _this;
    (0, _classCallCheck2$3.default)(this, Portal);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = (0, _possibleConstructorReturn2$2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3$1.default)(Portal)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.getMountNode = function () {
      return _this.mountNode;
    };
    return _this;
  }
  (0, _createClass2$3.default)(Portal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.setMountNode(this.props.container);
      if (!this.props.disablePortal) {
        this.forceUpdate(this.props.onRendered);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this2 = this;
      if (prevProps.container !== this.props.container || prevProps.disablePortal !== this.props.disablePortal) {
        this.setMountNode(this.props.container);
        if (!this.props.disablePortal) {
          this.forceUpdate(function () {
            if (_this2.props.onRendered) {
              clearTimeout(_this2.renderedTimer);
              _this2.renderedTimer = setTimeout(_this2.props.onRendered);
            }
          });
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.mountNode = null;
      clearTimeout(this.renderedTimer);
    }
  }, {
    key: "setMountNode",
    value: function setMountNode(container) {
      if (this.props.disablePortal) {
        this.mountNode = _reactDom$1.default.findDOMNode(this).parentElement;
        return;
      }
      this.mountNode = getContainer$1(container, getOwnerDocument(this).body);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props, children = _this$props.children, disablePortal = _this$props.disablePortal;
      if (disablePortal) {
        return children;
      }
      return this.mountNode ? _reactDom$1.default.createPortal(children, this.mountNode) : null;
    }
  }]);
  return Portal;
})(_react$9.default.Component);
Portal.propTypes = {
  children: _propTypes$6.default.node.isRequired,
  container: _propTypes$6.default.oneOfType([_propTypes$6.default.object, _propTypes$6.default.func]),
  disablePortal: _propTypes$6.default.bool,
  onRendered: _propTypes$6.default.func
};
Portal.defaultProps = {
  disablePortal: false
};
{
  Portal.propTypes = (0, _utils$2.exactProp)(Portal.propTypes);
}
var _default$b = Portal;
Portal$1.default = _default$b;
(function (exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function get() {
      return _Portal.default;
    }
  });
  var _Portal = _interopRequireDefault(Portal$1);
})(Portal$2);
getDefaultExportFromCjs(Portal$2);
var ModalManager$1 = {};
var style = {
  exports: {}
};
var camelizeStyle = {
  exports: {}
};
var camelize = {
  exports: {}
};
(function (module, exports) {
  exports.__esModule = true;
  exports.default = camelize;
  var rHyphen = /-(.)/g;
  function camelize(string) {
    return string.replace(rHyphen, function (_, chr) {
      return chr.toUpperCase();
    });
  }
  module.exports = exports["default"];
})(camelize, camelize.exports);
getDefaultExportFromCjs(camelize.exports);
(function (module, exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  exports.__esModule = true;
  exports.default = camelizeStyleName;
  var _camelize = _interopRequireDefault(camelize.exports);
  var msPattern = /^-ms-/;
  function camelizeStyleName(string) {
    return (0, _camelize.default)(string.replace(msPattern, 'ms-'));
  }
  module.exports = exports["default"];
})(camelizeStyle, camelizeStyle.exports);
getDefaultExportFromCjs(camelizeStyle.exports);
var hyphenateStyle = {
  exports: {}
};
var hyphenate = {
  exports: {}
};
(function (module, exports) {
  exports.__esModule = true;
  exports.default = hyphenate;
  var rUpper = /([A-Z])/g;
  function hyphenate(string) {
    return string.replace(rUpper, '-$1').toLowerCase();
  }
  module.exports = exports["default"];
})(hyphenate, hyphenate.exports);
getDefaultExportFromCjs(hyphenate.exports);
(function (module, exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  exports.__esModule = true;
  exports.default = hyphenateStyleName;
  var _hyphenate = _interopRequireDefault(hyphenate.exports);
  var msPattern = /^ms-/;
  function hyphenateStyleName(string) {
    return (0, _hyphenate.default)(string).replace(msPattern, '-ms-');
  }
  module.exports = exports["default"];
})(hyphenateStyle, hyphenateStyle.exports);
getDefaultExportFromCjs(hyphenateStyle.exports);
var getComputedStyle = {
  exports: {}
};
(function (module, exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  exports.__esModule = true;
  exports.default = _getComputedStyle;
  var _camelizeStyle = _interopRequireDefault(camelizeStyle.exports);
  var rposition = /^(top|right|bottom|left)$/;
  var rnumnonpx = /^([+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|))(?!px)[a-z%]+$/i;
  function _getComputedStyle(node) {
    if (!node) throw new TypeError('No Element passed to `getComputedStyle()`');
    var doc = node.ownerDocument;
    return ('defaultView' in doc) ? doc.defaultView.opener ? node.ownerDocument.defaultView.getComputedStyle(node, null) : window.getComputedStyle(node, null) : {
      getPropertyValue: function getPropertyValue(prop) {
        var style = node.style;
        prop = (0, _camelizeStyle.default)(prop);
        if (prop == 'float') prop = 'styleFloat';
        var current = node.currentStyle[prop] || null;
        if (current == null && style && style[prop]) current = style[prop];
        if (rnumnonpx.test(current) && !rposition.test(prop)) {
          var left = style.left;
          var runStyle = node.runtimeStyle;
          var rsLeft = runStyle && runStyle.left;
          if (rsLeft) runStyle.left = node.currentStyle.left;
          style.left = prop === 'fontSize' ? '1em' : current;
          current = style.pixelLeft + 'px';
          style.left = left;
          if (rsLeft) runStyle.left = rsLeft;
        }
        return current;
      }
    };
  }
  module.exports = exports["default"];
})(getComputedStyle, getComputedStyle.exports);
getDefaultExportFromCjs(getComputedStyle.exports);
var removeStyle = {
  exports: {}
};
(function (module, exports) {
  exports.__esModule = true;
  exports.default = removeStyle;
  function removeStyle(node, key) {
    return ('removeProperty' in node.style) ? node.style.removeProperty(key) : node.style.removeAttribute(key);
  }
  module.exports = exports["default"];
})(removeStyle, removeStyle.exports);
getDefaultExportFromCjs(removeStyle.exports);
var properties = {};
var inDOM = {
  exports: {}
};
(function (module, exports) {
  exports.__esModule = true;
  exports.default = void 0;
  var _default = !!(typeof window !== 'undefined' && window.document && window.document.createElement);
  exports.default = _default;
  module.exports = exports["default"];
})(inDOM, inDOM.exports);
getDefaultExportFromCjs(inDOM.exports);
var _interopRequireDefault$b = interopRequireDefault.exports;
properties.__esModule = true;
properties.default = properties.animationEnd = properties.animationDelay = properties.animationTiming = properties.animationDuration = properties.animationName = properties.transitionEnd = properties.transitionDuration = properties.transitionDelay = properties.transitionTiming = properties.transitionProperty = properties.transform = void 0;
var _inDOM = _interopRequireDefault$b(inDOM.exports);
var transform = 'transform';
properties.transform = transform;
var prefix, transitionEnd, animationEnd;
properties.animationEnd = animationEnd;
properties.transitionEnd = transitionEnd;
var transitionProperty, transitionDuration, transitionTiming, transitionDelay;
properties.transitionDelay = transitionDelay;
properties.transitionTiming = transitionTiming;
properties.transitionDuration = transitionDuration;
properties.transitionProperty = transitionProperty;
var animationName, animationDuration, animationTiming, animationDelay;
properties.animationDelay = animationDelay;
properties.animationTiming = animationTiming;
properties.animationDuration = animationDuration;
properties.animationName = animationName;
if (_inDOM.default) {
  var _getTransitionPropert = getTransitionProperties();
  prefix = _getTransitionPropert.prefix;
  properties.transitionEnd = transitionEnd = _getTransitionPropert.transitionEnd;
  properties.animationEnd = animationEnd = _getTransitionPropert.animationEnd;
  properties.transform = transform = prefix + "-" + transform;
  properties.transitionProperty = transitionProperty = prefix + "-transition-property";
  properties.transitionDuration = transitionDuration = prefix + "-transition-duration";
  properties.transitionDelay = transitionDelay = prefix + "-transition-delay";
  properties.transitionTiming = transitionTiming = prefix + "-transition-timing-function";
  properties.animationName = animationName = prefix + "-animation-name";
  properties.animationDuration = animationDuration = prefix + "-animation-duration";
  properties.animationTiming = animationTiming = prefix + "-animation-delay";
  properties.animationDelay = animationDelay = prefix + "-animation-timing-function";
}
var _default$a = {
  transform: transform,
  end: transitionEnd,
  property: transitionProperty,
  timing: transitionTiming,
  delay: transitionDelay,
  duration: transitionDuration
};
properties.default = _default$a;
function getTransitionProperties() {
  var style = document.createElement('div').style;
  var vendorMap = {
    O: function O(e) {
      return "o" + e.toLowerCase();
    },
    Moz: function Moz(e) {
      return e.toLowerCase();
    },
    Webkit: function Webkit(e) {
      return "webkit" + e;
    },
    ms: function ms(e) {
      return "MS" + e;
    }
  };
  var vendors = Object.keys(vendorMap);
  var transitionEnd, animationEnd;
  var prefix = '';
  for (var i = 0; i < vendors.length; i++) {
    var vendor = vendors[i];
    if ((vendor + "TransitionProperty" in style)) {
      prefix = "-" + vendor.toLowerCase();
      transitionEnd = vendorMap[vendor]('TransitionEnd');
      animationEnd = vendorMap[vendor]('AnimationEnd');
      break;
    }
  }
  if (!transitionEnd && ('transitionProperty' in style)) transitionEnd = 'transitionend';
  if (!animationEnd && ('animationName' in style)) animationEnd = 'animationend';
  style = null;
  return {
    animationEnd: animationEnd,
    transitionEnd: transitionEnd,
    prefix: prefix
  };
}
var isTransform = {
  exports: {}
};
(function (module, exports) {
  exports.__esModule = true;
  exports.default = isTransform;
  var supportedTransforms = /^((translate|rotate|scale)(X|Y|Z|3d)?|matrix(3d)?|perspective|skew(X|Y)?)$/i;
  function isTransform(property) {
    return !!(property && supportedTransforms.test(property));
  }
  module.exports = exports["default"];
})(isTransform, isTransform.exports);
getDefaultExportFromCjs(isTransform.exports);
(function (module, exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  exports.__esModule = true;
  exports.default = style;
  var _camelizeStyle = _interopRequireDefault(camelizeStyle.exports);
  var _hyphenateStyle = _interopRequireDefault(hyphenateStyle.exports);
  var _getComputedStyle2 = _interopRequireDefault(getComputedStyle.exports);
  var _removeStyle = _interopRequireDefault(removeStyle.exports);
  var _properties = properties;
  var _isTransform = _interopRequireDefault(isTransform.exports);
  function style(node, property, value) {
    var css = '';
    var transforms = '';
    var props = property;
    if (typeof property === 'string') {
      if (value === undefined) {
        return node.style[(0, _camelizeStyle.default)(property)] || (0, _getComputedStyle2.default)(node).getPropertyValue((0, _hyphenateStyle.default)(property));
      } else {
        (props = {})[property] = value;
      }
    }
    Object.keys(props).forEach(function (key) {
      var value = props[key];
      if (!value && value !== 0) {
        (0, _removeStyle.default)(node, (0, _hyphenateStyle.default)(key));
      } else if ((0, _isTransform.default)(key)) {
        transforms += key + "(" + value + ") ";
      } else {
        css += (0, _hyphenateStyle.default)(key) + ": " + value + ";";
      }
    });
    if (transforms) {
      css += _properties.transform + ": " + transforms + ";";
    }
    node.style.cssText += ';' + css;
  }
  module.exports = exports["default"];
})(style, style.exports);
getDefaultExportFromCjs(style.exports);
var scrollbarSize = {
  exports: {}
};
(function (module, exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  exports.__esModule = true;
  exports.default = scrollbarSize;
  var _inDOM = _interopRequireDefault(inDOM.exports);
  var size;
  function scrollbarSize(recalc) {
    if (!size && size !== 0 || recalc) {
      if (_inDOM.default) {
        var scrollDiv = document.createElement('div');
        scrollDiv.style.position = 'absolute';
        scrollDiv.style.top = '-9999px';
        scrollDiv.style.width = '50px';
        scrollDiv.style.height = '50px';
        scrollDiv.style.overflow = 'scroll';
        document.body.appendChild(scrollDiv);
        size = scrollDiv.offsetWidth - scrollDiv.clientWidth;
        document.body.removeChild(scrollDiv);
      }
    }
    return size;
  }
  module.exports = exports["default"];
})(scrollbarSize, scrollbarSize.exports);
getDefaultExportFromCjs(scrollbarSize.exports);
var isOverflowing$1 = {};
var isWindow = {
  exports: {}
};
(function (module, exports) {
  exports.__esModule = true;
  exports.default = getWindow;
  function getWindow(node) {
    return node === node.window ? node : node.nodeType === 9 ? node.defaultView || node.parentWindow : false;
  }
  module.exports = exports["default"];
})(isWindow, isWindow.exports);
getDefaultExportFromCjs(isWindow.exports);
var _interopRequireDefault$a = interopRequireDefault.exports;
Object.defineProperty(isOverflowing$1, "__esModule", {
  value: true
});
isOverflowing$1.isBody = isBody;
isOverflowing$1.default = isOverflowing;
var _isWindow = _interopRequireDefault$a(isWindow.exports);
var _ownerDocument$2 = _interopRequireDefault$a(ownerDocument$1);
var _ownerWindow = _interopRequireDefault$a(ownerWindow$1);
function isBody(node) {
  return node && node.tagName.toLowerCase() === 'body';
}
function isOverflowing(container) {
  var doc = (0, _ownerDocument$2.default)(container);
  var win = (0, _ownerWindow.default)(doc);
  if (!(0, _isWindow.default)(doc) && !isBody(container)) {
    return container.scrollHeight > container.clientHeight;
  }
  var style = win.getComputedStyle(doc.body);
  var marginLeft = parseInt(style.getPropertyValue('margin-left'), 10);
  var marginRight = parseInt(style.getPropertyValue('margin-right'), 10);
  return marginLeft + doc.body.clientWidth + marginRight < win.innerWidth;
}
var manageAriaHidden = {};
Object.defineProperty(manageAriaHidden, "__esModule", {
  value: true
});
manageAriaHidden.ariaHidden = ariaHidden;
manageAriaHidden.ariaHiddenSiblings = ariaHiddenSiblings;
var BLACKLIST = ['template', 'script', 'style'];
function isHideable(node) {
  return node.nodeType === 1 && BLACKLIST.indexOf(node.tagName.toLowerCase()) === -1;
}
function siblings(container, mount, currentNode, callback) {
  var blacklist = [mount, currentNode];
  [].forEach.call(container.children, function (node) {
    if (blacklist.indexOf(node) === -1 && isHideable(node)) {
      callback(node);
    }
  });
}
function ariaHidden(node, show) {
  if (show) {
    node.setAttribute('aria-hidden', 'true');
  } else {
    node.removeAttribute('aria-hidden');
  }
}
function ariaHiddenSiblings(container, mountNode, currentNode, show) {
  siblings(container, mountNode, currentNode, function (node) {
    return ariaHidden(node, show);
  });
}
var _interopRequireDefault$9 = interopRequireDefault.exports;
Object.defineProperty(ModalManager$1, "__esModule", {
  value: true
});
ModalManager$1.default = void 0;
var _classCallCheck2$2 = _interopRequireDefault$9(classCallCheck.exports);
var _createClass2$2 = _interopRequireDefault$9(createClass.exports);
var _style = _interopRequireDefault$9(style.exports);
var _scrollbarSize = _interopRequireDefault$9(scrollbarSize.exports);
var _ownerDocument$1 = _interopRequireDefault$9(ownerDocument$1);
var _isOverflowing = _interopRequireDefault$9(isOverflowing$1);
var _manageAriaHidden$1 = manageAriaHidden;
function findIndexOf(data, callback) {
  var idx = -1;
  data.some(function (item, index) {
    if (callback(item)) {
      idx = index;
      return true;
    }
    return false;
  });
  return idx;
}
function getPaddingRight(node) {
  return parseInt((0, _style.default)(node, 'paddingRight') || 0, 10);
}
function setContainerStyle(data) {
  data.style = {
    overflow: data.container.style.overflow,
    paddingRight: data.container.style.paddingRight
  };
  var style = {
    overflow: 'hidden'
  };
  if (data.overflowing) {
    var scrollbarSize = (0, _scrollbarSize.default)();
    style.paddingRight = ("").concat(getPaddingRight(data.container) + scrollbarSize, "px");
    var fixedNodes = (0, _ownerDocument$1.default)(data.container).querySelectorAll('.mui-fixed');
    for (var i = 0; i < fixedNodes.length; i += 1) {
      var paddingRight = getPaddingRight(fixedNodes[i]);
      data.prevPaddings.push(paddingRight);
      fixedNodes[i].style.paddingRight = ("").concat(paddingRight + scrollbarSize, "px");
    }
  }
  Object.keys(style).forEach(function (key) {
    data.container.style[key] = style[key];
  });
}
function removeContainerStyle(data) {
  if (data.style) {
    Object.keys(data.style).forEach(function (key) {
      data.container.style[key] = data.style[key];
    });
  }
  var fixedNodes = (0, _ownerDocument$1.default)(data.container).querySelectorAll('.mui-fixed');
  for (var i = 0; i < fixedNodes.length; i += 1) {
    fixedNodes[i].style.paddingRight = ("").concat(data.prevPaddings[i], "px");
  }
}
var ModalManager = (function () {
  function ModalManager() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck2$2.default)(this, ModalManager);
    var _options$hideSiblingN = options.hideSiblingNodes, hideSiblingNodes = _options$hideSiblingN === void 0 ? true : _options$hideSiblingN, _options$handleContai = options.handleContainerOverflow, handleContainerOverflow = _options$handleContai === void 0 ? true : _options$handleContai;
    this.hideSiblingNodes = hideSiblingNodes;
    this.handleContainerOverflow = handleContainerOverflow;
    this.modals = [];
    this.data = [];
  }
  (0, _createClass2$2.default)(ModalManager, [{
    key: "add",
    value: function add(modal, container) {
      var modalIdx = this.modals.indexOf(modal);
      if (modalIdx !== -1) {
        return modalIdx;
      }
      modalIdx = this.modals.length;
      this.modals.push(modal);
      if (modal.modalRef) {
        (0, _manageAriaHidden$1.ariaHidden)(modal.modalRef, false);
      }
      if (this.hideSiblingNodes) {
        (0, _manageAriaHidden$1.ariaHiddenSiblings)(container, modal.mountNode, modal.modalRef, true);
      }
      var containerIdx = findIndexOf(this.data, function (item) {
        return item.container === container;
      });
      if (containerIdx !== -1) {
        this.data[containerIdx].modals.push(modal);
        return modalIdx;
      }
      var data = {
        modals: [modal],
        container: container,
        overflowing: (0, _isOverflowing.default)(container),
        prevPaddings: []
      };
      this.data.push(data);
      return modalIdx;
    }
  }, {
    key: "mount",
    value: function mount(modal) {
      var containerIdx = findIndexOf(this.data, function (item) {
        return item.modals.indexOf(modal) !== -1;
      });
      var data = this.data[containerIdx];
      if (!data.style && this.handleContainerOverflow) {
        setContainerStyle(data);
      }
    }
  }, {
    key: "remove",
    value: function remove(modal) {
      var modalIdx = this.modals.indexOf(modal);
      if (modalIdx === -1) {
        return modalIdx;
      }
      var containerIdx = findIndexOf(this.data, function (item) {
        return item.modals.indexOf(modal) !== -1;
      });
      var data = this.data[containerIdx];
      data.modals.splice(data.modals.indexOf(modal), 1);
      this.modals.splice(modalIdx, 1);
      if (data.modals.length === 0) {
        if (this.handleContainerOverflow) {
          removeContainerStyle(data);
        }
        if (modal.modalRef) {
          (0, _manageAriaHidden$1.ariaHidden)(modal.modalRef, true);
        }
        if (this.hideSiblingNodes) {
          (0, _manageAriaHidden$1.ariaHiddenSiblings)(data.container, modal.mountNode, modal.modalRef, false);
        }
        this.data.splice(containerIdx, 1);
      } else if (this.hideSiblingNodes) {
        var nextTop = data.modals[data.modals.length - 1];
        if (nextTop.modalRef) {
          (0, _manageAriaHidden$1.ariaHidden)(nextTop.modalRef, false);
        }
      }
      return modalIdx;
    }
  }, {
    key: "isTopModal",
    value: function isTopModal(modal) {
      return !!this.modals.length && this.modals[this.modals.length - 1] === modal;
    }
  }]);
  return ModalManager;
})();
var _default$9 = ModalManager;
ModalManager$1.default = _default$9;
const require$$10$1 = _dll_react;
const require$$11$1 = _dll_react_dom;
const require$$12 = _dll_prop_types;
const require$$13 = _dll_classnames;
var _interopRequireDefault$8 = interopRequireDefault.exports;
Object.defineProperty(Modal$1, "__esModule", {
  value: true
});
Modal$1.default = Modal$1.styles = void 0;
var _extends2$5 = _interopRequireDefault$8(_extends$1.exports);
var _defineProperty2$1 = _interopRequireDefault$8(defineProperty$1.exports);
var _objectWithoutProperties2$4 = _interopRequireDefault$8(objectWithoutProperties.exports);
var _classCallCheck2$1 = _interopRequireDefault$8(classCallCheck.exports);
var _createClass2$1 = _interopRequireDefault$8(createClass.exports);
var _possibleConstructorReturn2$1 = _interopRequireDefault$8(possibleConstructorReturn.exports);
var _getPrototypeOf2 = _interopRequireDefault$8(getPrototypeOf$1.exports);
var _inherits2$1 = _interopRequireDefault$8(inherits.exports);
var _assertThisInitialized2 = _interopRequireDefault$8(assertThisInitialized.exports);
var _react$8 = _interopRequireDefault$8(require$$10$1);
var _reactDom = _interopRequireDefault$8(require$$11$1);
var _propTypes$5 = _interopRequireDefault$8(require$$12);
var _classnames$4 = _interopRequireDefault$8(require$$13);
var _warning = _interopRequireDefault$8(warning_1);
var _utils$1 = require$$13$2;
var _ownerDocument = _interopRequireDefault$8(ownerDocument$1);
var _RootRef = _interopRequireDefault$8(RootRef$2);
var _Portal = _interopRequireDefault$8(Portal$2);
var _helpers$1 = helpers;
var _withStyles$5 = _interopRequireDefault$8(withStyles);
var _ModalManager = _interopRequireDefault$8(ModalManager$1);
var _Backdrop = _interopRequireDefault$8(Backdrop$2);
var _manageAriaHidden = manageAriaHidden;
function getContainer(container, defaultContainer) {
  container = typeof container === 'function' ? container() : container;
  return _reactDom.default.findDOMNode(container) || defaultContainer;
}
function getHasTransition(props) {
  return props.children ? props.children.props.hasOwnProperty('in') : false;
}
var styles$5 = function styles(theme) {
  return {
    root: {
      position: 'fixed',
      zIndex: theme.zIndex.modal,
      right: 0,
      bottom: 0,
      top: 0,
      left: 0
    },
    hidden: {
      visibility: 'hidden'
    }
  };
};
Modal$1.styles = styles$5;
if (!_react$8.default.createContext) {
  throw new Error('Material-UI: react@16.3.0 or greater is required.');
}
var Modal = (function (_React$Component) {
  (0, _inherits2$1.default)(Modal, _React$Component);
  function Modal(props) {
    var _this;
    (0, _classCallCheck2$1.default)(this, Modal);
    _this = (0, _possibleConstructorReturn2$1.default)(this, (0, _getPrototypeOf2.default)(Modal).call(this));
    _this.mounted = false;
    _this.handleOpen = function () {
      var doc = (0, _ownerDocument.default)(_this.mountNode);
      var container = getContainer(_this.props.container, doc.body);
      _this.props.manager.add((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), container);
      doc.addEventListener('focus', _this.enforceFocus, true);
      if (_this.dialogRef) {
        _this.handleOpened();
      }
    };
    _this.handleRendered = function () {
      if (_this.props.onRendered) {
        _this.props.onRendered();
      }
      if (_this.props.open) {
        _this.handleOpened();
      } else {
        (0, _manageAriaHidden.ariaHidden)(_this.modalRef, true);
      }
    };
    _this.handleOpened = function () {
      _this.autoFocus();
      _this.props.manager.mount((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
      _this.modalRef.scrollTop = 0;
    };
    _this.handleClose = function (reason) {
      var hasTransition = getHasTransition(_this.props);
      if (!(hasTransition && _this.props.closeAfterTransition) || reason === 'unmount') {
        _this.props.manager.remove((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
      }
      var doc = (0, _ownerDocument.default)(_this.mountNode);
      doc.removeEventListener('focus', _this.enforceFocus, true);
      _this.restoreLastFocus();
    };
    _this.handleExited = function () {
      if (_this.props.closeAfterTransition) {
        _this.props.manager.remove((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
      }
      _this.setState({
        exited: true
      });
    };
    _this.handleBackdropClick = function (event) {
      if (event.target !== event.currentTarget) {
        return;
      }
      if (_this.props.onBackdropClick) {
        _this.props.onBackdropClick(event);
      }
      if (!_this.props.disableBackdropClick && _this.props.onClose) {
        _this.props.onClose(event, 'backdropClick');
      }
    };
    _this.handleKeyDown = function (event) {
      if (event.key !== 'Escape' || !_this.isTopModal() || event.defaultPrevented) {
        return;
      }
      event.stopPropagation();
      if (_this.props.onEscapeKeyDown) {
        _this.props.onEscapeKeyDown(event);
      }
      if (!_this.props.disableEscapeKeyDown && _this.props.onClose) {
        _this.props.onClose(event, 'escapeKeyDown');
      }
    };
    _this.enforceFocus = function () {
      if (!_this.isTopModal() || _this.props.disableEnforceFocus || !_this.mounted || !_this.dialogRef) {
        return;
      }
      var currentActiveElement = (0, _ownerDocument.default)(_this.mountNode).activeElement;
      if (!_this.dialogRef.contains(currentActiveElement)) {
        _this.dialogRef.focus();
      }
    };
    _this.handlePortalRef = function (ref) {
      _this.mountNode = ref ? ref.getMountNode() : ref;
    };
    _this.handleModalRef = function (ref) {
      _this.modalRef = ref;
    };
    _this.onRootRef = function (ref) {
      _this.dialogRef = ref;
    };
    _this.state = {
      exited: !props.open
    };
    return _this;
  }
  (0, _createClass2$1.default)(Modal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.mounted = true;
      if (this.props.open) {
        this.handleOpen();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.open && !this.props.open) {
        this.handleClose();
      } else if (!prevProps.open && this.props.open) {
        this.lastFocus = (0, _ownerDocument.default)(this.mountNode).activeElement;
        this.handleOpen();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.mounted = false;
      if (this.props.open || getHasTransition(this.props) && !this.state.exited) {
        this.handleClose('unmount');
      }
    }
  }, {
    key: "autoFocus",
    value: function autoFocus() {
      if (this.props.disableAutoFocus || !this.dialogRef) {
        return;
      }
      var currentActiveElement = (0, _ownerDocument.default)(this.mountNode).activeElement;
      if (!this.dialogRef.contains(currentActiveElement)) {
        if (!this.dialogRef.hasAttribute('tabIndex')) {
          (0, _warning.default)(false, ['Material-UI: the modal content node does not accept focus.', 'For the benefit of assistive technologies, ' + 'the tabIndex of the node is being set to "-1".'].join('\n'));
          this.dialogRef.setAttribute('tabIndex', -1);
        }
        this.lastFocus = currentActiveElement;
        this.dialogRef.focus();
      }
    }
  }, {
    key: "restoreLastFocus",
    value: function restoreLastFocus() {
      if (this.props.disableRestoreFocus || !this.lastFocus) {
        return;
      }
      if (this.lastFocus.focus) {
        this.lastFocus.focus();
      }
      this.lastFocus = null;
    }
  }, {
    key: "isTopModal",
    value: function isTopModal() {
      return this.props.manager.isTopModal(this);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props, BackdropComponent = _this$props.BackdropComponent, BackdropProps = _this$props.BackdropProps, children = _this$props.children, classes = _this$props.classes, className = _this$props.className;
      _this$props.closeAfterTransition;
      var container = _this$props.container;
      _this$props.disableAutoFocus;
      _this$props.disableBackdropClick;
      _this$props.disableEnforceFocus;
      _this$props.disableEscapeKeyDown;
      var disablePortal = _this$props.disablePortal;
      _this$props.disableRestoreFocus;
      var hideBackdrop = _this$props.hideBackdrop, keepMounted = _this$props.keepMounted;
      _this$props.manager;
      _this$props.onBackdropClick;
      _this$props.onClose;
      _this$props.onEscapeKeyDown;
      _this$props.onRendered;
      var open = _this$props.open, other = (0, _objectWithoutProperties2$4.default)(_this$props, ["BackdropComponent", "BackdropProps", "children", "classes", "className", "closeAfterTransition", "container", "disableAutoFocus", "disableBackdropClick", "disableEnforceFocus", "disableEscapeKeyDown", "disablePortal", "disableRestoreFocus", "hideBackdrop", "keepMounted", "manager", "onBackdropClick", "onClose", "onEscapeKeyDown", "onRendered", "open"]);
      var exited = this.state.exited;
      var hasTransition = getHasTransition(this.props);
      if (!keepMounted && !open && (!hasTransition || exited)) {
        return null;
      }
      var childProps = {};
      if (hasTransition) {
        childProps.onExited = (0, _helpers$1.createChainedFunction)(this.handleExited, children.props.onExited);
      }
      if (children.props.role === undefined) {
        childProps.role = children.props.role || 'document';
      }
      if (children.props.tabIndex === undefined) {
        childProps.tabIndex = children.props.tabIndex || '-1';
      }
      return _react$8.default.createElement(_Portal.default, {
        ref: this.handlePortalRef,
        container: container,
        disablePortal: disablePortal,
        onRendered: this.handleRendered
      }, _react$8.default.createElement("div", (0, _extends2$5.default)({
        ref: this.handleModalRef,
        onKeyDown: this.handleKeyDown,
        role: "presentation",
        className: (0, _classnames$4.default)(classes.root, className, (0, _defineProperty2$1.default)({}, classes.hidden, exited))
      }, other), hideBackdrop ? null : _react$8.default.createElement(BackdropComponent, (0, _extends2$5.default)({
        open: open,
        onClick: this.handleBackdropClick
      }, BackdropProps)), _react$8.default.createElement(_RootRef.default, {
        rootRef: this.onRootRef
      }, _react$8.default.cloneElement(children, childProps))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      if (nextProps.open) {
        return {
          exited: false
        };
      }
      if (!getHasTransition(nextProps)) {
        return {
          exited: true
        };
      }
      return null;
    }
  }]);
  return Modal;
})(_react$8.default.Component);
Modal.propTypes = {
  BackdropComponent: _utils$1.componentPropType,
  BackdropProps: _propTypes$5.default.object,
  children: _propTypes$5.default.element,
  classes: _propTypes$5.default.object.isRequired,
  className: _propTypes$5.default.string,
  closeAfterTransition: _propTypes$5.default.bool,
  container: _propTypes$5.default.oneOfType([_propTypes$5.default.object, _propTypes$5.default.func]),
  disableAutoFocus: _propTypes$5.default.bool,
  disableBackdropClick: _propTypes$5.default.bool,
  disableEnforceFocus: _propTypes$5.default.bool,
  disableEscapeKeyDown: _propTypes$5.default.bool,
  disablePortal: _propTypes$5.default.bool,
  disableRestoreFocus: _propTypes$5.default.bool,
  hideBackdrop: _propTypes$5.default.bool,
  keepMounted: _propTypes$5.default.bool,
  manager: _propTypes$5.default.object,
  onBackdropClick: _propTypes$5.default.func,
  onClose: _propTypes$5.default.func,
  onEscapeKeyDown: _propTypes$5.default.func,
  onRendered: _propTypes$5.default.func,
  open: _propTypes$5.default.bool.isRequired
};
Modal.defaultProps = {
  BackdropComponent: _Backdrop.default,
  closeAfterTransition: false,
  disableAutoFocus: false,
  disableBackdropClick: false,
  disableEnforceFocus: false,
  disableEscapeKeyDown: false,
  disablePortal: false,
  disableRestoreFocus: false,
  hideBackdrop: false,
  keepMounted: false,
  manager: new _ModalManager.default()
};
var _default$8 = (0, _withStyles$5.default)(styles$5, {
  flip: false,
  name: 'MuiModal'
})(Modal);
Modal$1.default = _default$8;
(function (exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function get() {
      return _Modal.default;
    }
  });
  Object.defineProperty(exports, "ModalManager", {
    enumerable: true,
    get: function get() {
      return _ModalManager.default;
    }
  });
  var _Modal = _interopRequireDefault(Modal$1);
  var _ModalManager = _interopRequireDefault(ModalManager$1);
})(Modal$2);
getDefaultExportFromCjs(Modal$2);
const require$$9 = _dll_react;
const require$$10 = _dll_prop_types;
const require$$11 = _dll_classnames;
var _interopRequireDefault$7 = interopRequireDefault.exports;
Object.defineProperty(Dialog$2, "__esModule", {
  value: true
});
Dialog$2.default = Dialog$2.styles = void 0;
var _extends2$4 = _interopRequireDefault$7(_extends$1.exports);
var _objectWithoutProperties2$3 = _interopRequireDefault$7(objectWithoutProperties.exports);
var _classCallCheck2 = _interopRequireDefault$7(classCallCheck.exports);
var _createClass2 = _interopRequireDefault$7(createClass.exports);
var _possibleConstructorReturn2 = _interopRequireDefault$7(possibleConstructorReturn.exports);
var _getPrototypeOf3 = _interopRequireDefault$7(getPrototypeOf$1.exports);
var _inherits2 = _interopRequireDefault$7(inherits.exports);
var _defineProperty2 = _interopRequireDefault$7(defineProperty$1.exports);
var _react$7 = _interopRequireDefault$7(require$$9);
var _propTypes$4 = _interopRequireDefault$7(require$$10);
var _classnames$3 = _interopRequireDefault$7(require$$11);
var _utils = require$$13$2;
var _withStyles$4 = _interopRequireDefault$7(withStyles);
var _helpers = helpers;
var _Modal = _interopRequireDefault$7(Modal$2);
var _Fade = _interopRequireDefault$7(Fade$2);
var _transitions = transitions;
var _Paper = _interopRequireDefault$7(Paper$2);
var styles$4 = function styles(theme) {
  return {
    root: {},
    scrollPaper: {
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center'
    },
    scrollBody: {
      overflowY: 'auto',
      overflowX: 'hidden'
    },
    container: {
      height: '100%',
      outline: 'none'
    },
    paper: {
      display: 'flex',
      flexDirection: 'column',
      margin: 48,
      position: 'relative',
      overflowY: 'auto'
    },
    paperScrollPaper: {
      flex: '0 1 auto',
      maxHeight: 'calc(100% - 96px)'
    },
    paperScrollBody: {
      margin: '48px auto'
    },
    paperWidthXs: {
      maxWidth: Math.max(theme.breakpoints.values.xs, 360),
      '&$paperScrollBody': (0, _defineProperty2.default)({}, theme.breakpoints.down(Math.max(theme.breakpoints.values.xs, 360) + 48 * 2), {
        margin: 48
      })
    },
    paperWidthSm: {
      maxWidth: theme.breakpoints.values.sm,
      '&$paperScrollBody': (0, _defineProperty2.default)({}, theme.breakpoints.down(theme.breakpoints.values.sm + 48 * 2), {
        margin: 48
      })
    },
    paperWidthMd: {
      maxWidth: theme.breakpoints.values.md,
      '&$paperScrollBody': (0, _defineProperty2.default)({}, theme.breakpoints.down(theme.breakpoints.values.md + 48 * 2), {
        margin: 48
      })
    },
    paperWidthLg: {
      maxWidth: theme.breakpoints.values.lg,
      '&$paperScrollBody': (0, _defineProperty2.default)({}, theme.breakpoints.down(theme.breakpoints.values.lg + 48 * 2), {
        margin: 48
      })
    },
    paperWidthXl: {
      maxWidth: theme.breakpoints.values.xl,
      '&$paperScrollBody': (0, _defineProperty2.default)({}, theme.breakpoints.down(theme.breakpoints.values.xl + 48 * 2), {
        margin: 48
      })
    },
    paperFullWidth: {
      width: '100%'
    },
    paperFullScreen: {
      margin: 0,
      width: '100%',
      maxWidth: '100%',
      height: '100%',
      maxHeight: 'none',
      borderRadius: 0,
      '&$paperScrollBody': {
        margin: 0
      }
    }
  };
};
Dialog$2.styles = styles$4;
var Dialog$1 = (function (_React$Component) {
  (0, _inherits2.default)(Dialog, _React$Component);
  function Dialog() {
    var _getPrototypeOf2;
    var _this;
    (0, _classCallCheck2.default)(this, Dialog);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(Dialog)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.handleMouseDown = function (event) {
      _this.mouseDownTarget = event.target;
    };
    _this.handleBackdropClick = function (event) {
      if (event.target !== event.currentTarget) {
        return;
      }
      if (event.target !== _this.mouseDownTarget) {
        return;
      }
      _this.mouseDownTarget = null;
      if (_this.props.onBackdropClick) {
        _this.props.onBackdropClick(event);
      }
      if (!_this.props.disableBackdropClick && _this.props.onClose) {
        _this.props.onClose(event, 'backdropClick');
      }
    };
    return _this;
  }
  (0, _createClass2.default)(Dialog, [{
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props = this.props, BackdropProps = _this$props.BackdropProps, children = _this$props.children, classes = _this$props.classes, className = _this$props.className, disableBackdropClick = _this$props.disableBackdropClick, disableEscapeKeyDown = _this$props.disableEscapeKeyDown, fullScreen = _this$props.fullScreen, fullWidth = _this$props.fullWidth, maxWidth = _this$props.maxWidth, onBackdropClick = _this$props.onBackdropClick, onClose = _this$props.onClose, onEnter = _this$props.onEnter, onEntered = _this$props.onEntered, onEntering = _this$props.onEntering, onEscapeKeyDown = _this$props.onEscapeKeyDown, onExit = _this$props.onExit, onExited = _this$props.onExited, onExiting = _this$props.onExiting, open = _this$props.open, PaperComponent = _this$props.PaperComponent, _this$props$PaperProp = _this$props.PaperProps, PaperProps = _this$props$PaperProp === void 0 ? {} : _this$props$PaperProp, scroll = _this$props.scroll, TransitionComponent = _this$props.TransitionComponent, transitionDuration = _this$props.transitionDuration, TransitionProps = _this$props.TransitionProps, other = (0, _objectWithoutProperties2$3.default)(_this$props, ["BackdropProps", "children", "classes", "className", "disableBackdropClick", "disableEscapeKeyDown", "fullScreen", "fullWidth", "maxWidth", "onBackdropClick", "onClose", "onEnter", "onEntered", "onEntering", "onEscapeKeyDown", "onExit", "onExited", "onExiting", "open", "PaperComponent", "PaperProps", "scroll", "TransitionComponent", "transitionDuration", "TransitionProps"]);
      return _react$7.default.createElement(_Modal.default, (0, _extends2$4.default)({
        className: (0, _classnames$3.default)(classes.root, className),
        BackdropProps: (0, _extends2$4.default)({
          transitionDuration: transitionDuration
        }, BackdropProps),
        closeAfterTransition: true,
        disableBackdropClick: disableBackdropClick,
        disableEscapeKeyDown: disableEscapeKeyDown,
        onBackdropClick: onBackdropClick,
        onEscapeKeyDown: onEscapeKeyDown,
        onClose: onClose,
        open: open,
        role: "dialog"
      }, other), _react$7.default.createElement(TransitionComponent, (0, _extends2$4.default)({
        appear: true,
        in: open,
        timeout: transitionDuration,
        onEnter: onEnter,
        onEntering: onEntering,
        onEntered: onEntered,
        onExit: onExit,
        onExiting: onExiting,
        onExited: onExited
      }, TransitionProps), _react$7.default.createElement("div", {
        className: (0, _classnames$3.default)(classes.container, classes[("scroll").concat((0, _helpers.capitalize)(scroll))]),
        onClick: this.handleBackdropClick,
        onMouseDown: this.handleMouseDown,
        role: "document"
      }, _react$7.default.createElement(PaperComponent, (0, _extends2$4.default)({
        elevation: 24
      }, PaperProps, {
        className: (0, _classnames$3.default)(classes.paper, classes[("paperScroll").concat((0, _helpers.capitalize)(scroll))], (_classNames = {}, (0, _defineProperty2.default)(_classNames, classes[("paperWidth").concat(maxWidth ? (0, _helpers.capitalize)(maxWidth) : '')], maxWidth), (0, _defineProperty2.default)(_classNames, classes.paperFullScreen, fullScreen), (0, _defineProperty2.default)(_classNames, classes.paperFullWidth, fullWidth), _classNames), PaperProps.className)
      }), children))));
    }
  }]);
  return Dialog;
})(_react$7.default.Component);
Dialog$1.propTypes = {
  BackdropProps: _propTypes$4.default.object,
  children: _propTypes$4.default.node.isRequired,
  classes: _propTypes$4.default.object.isRequired,
  className: _propTypes$4.default.string,
  disableBackdropClick: _propTypes$4.default.bool,
  disableEscapeKeyDown: _propTypes$4.default.bool,
  fullScreen: _propTypes$4.default.bool,
  fullWidth: _propTypes$4.default.bool,
  maxWidth: _propTypes$4.default.oneOf(['xs', 'sm', 'md', 'lg', 'xl', false]),
  onBackdropClick: _propTypes$4.default.func,
  onClose: _propTypes$4.default.func,
  onEnter: _propTypes$4.default.func,
  onEntered: _propTypes$4.default.func,
  onEntering: _propTypes$4.default.func,
  onEscapeKeyDown: _propTypes$4.default.func,
  onExit: _propTypes$4.default.func,
  onExited: _propTypes$4.default.func,
  onExiting: _propTypes$4.default.func,
  open: _propTypes$4.default.bool.isRequired,
  PaperComponent: _utils.componentPropType,
  PaperProps: _propTypes$4.default.object,
  scroll: _propTypes$4.default.oneOf(['body', 'paper']),
  TransitionComponent: _utils.componentPropType,
  transitionDuration: _propTypes$4.default.oneOfType([_propTypes$4.default.number, _propTypes$4.default.shape({
    enter: _propTypes$4.default.number,
    exit: _propTypes$4.default.number
  })]),
  TransitionProps: _propTypes$4.default.object
};
Dialog$1.defaultProps = {
  disableBackdropClick: false,
  disableEscapeKeyDown: false,
  fullScreen: false,
  fullWidth: false,
  maxWidth: 'sm',
  PaperComponent: _Paper.default,
  scroll: 'paper',
  TransitionComponent: _Fade.default,
  transitionDuration: {
    enter: _transitions.duration.enteringScreen,
    exit: _transitions.duration.leavingScreen
  }
};
var _default$7 = (0, _withStyles$4.default)(styles$4, {
  name: 'MuiDialog'
})(Dialog$1);
Dialog$2.default = _default$7;
(function (exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function get() {
      return _Dialog.default;
    }
  });
  var _Dialog = _interopRequireDefault(Dialog$2);
})(Dialog$3);
var Dialog = getDefaultExportFromCjs(Dialog$3);
var DialogActions$3 = {};
var DialogActions$2 = {};
const require$$3$3 = _dll_react;
const require$$4$2 = _dll_prop_types;
const require$$5$2 = _dll_classnames;
var _interopRequireDefault$6 = interopRequireDefault.exports;
Object.defineProperty(DialogActions$2, "__esModule", {
  value: true
});
DialogActions$2.default = DialogActions$2.styles = void 0;
var _extends2$3 = _interopRequireDefault$6(_extends$1.exports);
var _objectWithoutProperties2$2 = _interopRequireDefault$6(objectWithoutProperties.exports);
var _react$6 = _interopRequireDefault$6(require$$3$3);
var _propTypes$3 = _interopRequireDefault$6(require$$4$2);
var _classnames$2 = _interopRequireDefault$6(require$$5$2);
var _withStyles$3 = _interopRequireDefault$6(withStyles);
var _reactHelpers = reactHelpers;
var styles$3 = {
  root: {
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'flex-end',
    flex: '0 0 auto',
    margin: '8px 4px'
  },
  action: {
    margin: '0 4px'
  }
};
DialogActions$2.styles = styles$3;
function DialogActions$1(props) {
  var disableActionSpacing = props.disableActionSpacing, children = props.children, classes = props.classes, className = props.className, other = (0, _objectWithoutProperties2$2.default)(props, ["disableActionSpacing", "children", "classes", "className"]);
  return _react$6.default.createElement("div", (0, _extends2$3.default)({
    className: (0, _classnames$2.default)(classes.root, className)
  }, other), disableActionSpacing ? children : (0, _reactHelpers.cloneChildrenWithClassName)(children, classes.action));
}
DialogActions$1.propTypes = {
  children: _propTypes$3.default.node,
  classes: _propTypes$3.default.object.isRequired,
  className: _propTypes$3.default.string,
  disableActionSpacing: _propTypes$3.default.bool
};
DialogActions$1.defaultProps = {
  disableActionSpacing: false
};
var _default$6 = (0, _withStyles$3.default)(styles$3, {
  name: 'MuiDialogActions'
})(DialogActions$1);
DialogActions$2.default = _default$6;
(function (exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function get() {
      return _DialogActions.default;
    }
  });
  var _DialogActions = _interopRequireDefault(DialogActions$2);
})(DialogActions$3);
var DialogActions = getDefaultExportFromCjs(DialogActions$3);
var DialogContent$3 = {};
var DialogContent$2 = {};
const require$$3$2 = _dll_react;
const require$$4$1 = _dll_prop_types;
const require$$5$1 = _dll_classnames;
var _interopRequireDefault$5 = interopRequireDefault.exports;
Object.defineProperty(DialogContent$2, "__esModule", {
  value: true
});
DialogContent$2.default = DialogContent$2.styles = void 0;
var _extends2$2 = _interopRequireDefault$5(_extends$1.exports);
var _objectWithoutProperties2$1 = _interopRequireDefault$5(objectWithoutProperties.exports);
var _react$5 = _interopRequireDefault$5(require$$3$2);
var _propTypes$2 = _interopRequireDefault$5(require$$4$1);
var _classnames$1 = _interopRequireDefault$5(require$$5$1);
var _withStyles$2 = _interopRequireDefault$5(withStyles);
var styles$2 = {
  root: {
    flex: '1 1 auto',
    overflowY: 'auto',
    WebkitOverflowScrolling: 'touch',
    padding: '0 24px 24px',
    '&:first-child': {
      paddingTop: 24
    }
  }
};
DialogContent$2.styles = styles$2;
function DialogContent$1(props) {
  var classes = props.classes, children = props.children, className = props.className, other = (0, _objectWithoutProperties2$1.default)(props, ["classes", "children", "className"]);
  return _react$5.default.createElement("div", (0, _extends2$2.default)({
    className: (0, _classnames$1.default)(classes.root, className)
  }, other), children);
}
DialogContent$1.propTypes = {
  children: _propTypes$2.default.node,
  classes: _propTypes$2.default.object.isRequired,
  className: _propTypes$2.default.string
};
var _default$5 = (0, _withStyles$2.default)(styles$2, {
  name: 'MuiDialogContent'
})(DialogContent$1);
DialogContent$2.default = _default$5;
(function (exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function get() {
      return _DialogContent.default;
    }
  });
  var _DialogContent = _interopRequireDefault(DialogContent$2);
})(DialogContent$3);
var DialogContent = getDefaultExportFromCjs(DialogContent$3);
var DialogContentText$3 = {};
var DialogContentText$2 = {};
const require$$2 = _dll_react;
const require$$3$1 = _dll_prop_types;
var _interopRequireDefault$4 = interopRequireDefault.exports;
Object.defineProperty(DialogContentText$2, "__esModule", {
  value: true
});
DialogContentText$2.default = DialogContentText$2.styles = void 0;
var _extends2$1 = _interopRequireDefault$4(_extends$1.exports);
var _react$4 = _interopRequireDefault$4(require$$2);
var _propTypes$1 = _interopRequireDefault$4(require$$3$1);
var _withStyles$1 = _interopRequireDefault$4(withStyles);
var _Typography$1 = _interopRequireDefault$4(Typography$3);
var styles$1 = {
  root: {
    lineHeight: 1.5
  }
};
DialogContentText$2.styles = styles$1;
function DialogContentText$1(props) {
  return _react$4.default.createElement(_Typography$1.default, (0, _extends2$1.default)({
    component: "p",
    internalDeprecatedVariant: true,
    variant: "subheading",
    color: "textSecondary"
  }, props));
}
DialogContentText$1.propTypes = {
  children: _propTypes$1.default.node,
  classes: _propTypes$1.default.object.isRequired
};
var _default$4 = (0, _withStyles$1.default)(styles$1, {
  name: 'MuiDialogContentText'
})(DialogContentText$1);
DialogContentText$2.default = _default$4;
(function (exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function get() {
      return _DialogContentText.default;
    }
  });
  var _DialogContentText = _interopRequireDefault(DialogContentText$2);
})(DialogContentText$3);
var DialogContentText = getDefaultExportFromCjs(DialogContentText$3);
var DialogTitle$3 = {};
var DialogTitle$2 = {};
const require$$3 = _dll_react;
const require$$4 = _dll_prop_types;
const require$$5 = _dll_classnames;
var _interopRequireDefault$3 = interopRequireDefault.exports;
Object.defineProperty(DialogTitle$2, "__esModule", {
  value: true
});
DialogTitle$2.default = DialogTitle$2.styles = void 0;
var _extends2 = _interopRequireDefault$3(_extends$1.exports);
var _objectWithoutProperties2 = _interopRequireDefault$3(objectWithoutProperties.exports);
var _react$3 = _interopRequireDefault$3(require$$3);
var _propTypes = _interopRequireDefault$3(require$$4);
var _classnames = _interopRequireDefault$3(require$$5);
var _withStyles = _interopRequireDefault$3(withStyles);
var _Typography = _interopRequireDefault$3(Typography$3);
var styles = {
  root: {
    margin: 0,
    padding: '24px 24px 20px',
    flex: '0 0 auto'
  }
};
DialogTitle$2.styles = styles;
function DialogTitle$1(props) {
  var children = props.children, classes = props.classes, className = props.className, disableTypography = props.disableTypography, other = (0, _objectWithoutProperties2.default)(props, ["children", "classes", "className", "disableTypography"]);
  return _react$3.default.createElement("div", (0, _extends2.default)({
    className: (0, _classnames.default)(classes.root, className)
  }, other), disableTypography ? children : _react$3.default.createElement(_Typography.default, {
    variant: "title",
    internalDeprecatedVariant: true
  }, children));
}
DialogTitle$1.propTypes = {
  children: _propTypes.default.node.isRequired,
  classes: _propTypes.default.object.isRequired,
  className: _propTypes.default.string,
  disableTypography: _propTypes.default.bool
};
DialogTitle$1.defaultProps = {
  disableTypography: false
};
var _default$3 = (0, _withStyles.default)(styles, {
  name: 'MuiDialogTitle'
})(DialogTitle$1);
DialogTitle$2.default = _default$3;
(function (exports) {
  var _interopRequireDefault = interopRequireDefault.exports;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function get() {
      return _DialogTitle.default;
    }
  });
  var _DialogTitle = _interopRequireDefault(DialogTitle$2);
})(DialogTitle$3);
var DialogTitle = getDefaultExportFromCjs(DialogTitle$3);
var RemoveCircle = {};
var createSvgIcon$1 = {};
const require$$1$2 = _dll_react;
var _interopRequireDefault$2 = interopRequireDefault.exports;
Object.defineProperty(createSvgIcon$1, "__esModule", {
  value: true
});
createSvgIcon$1.default = void 0;
var _react$2 = _interopRequireDefault$2(require$$1$2);
var _pure = _interopRequireDefault$2(pure$1);
var _SvgIcon = _interopRequireDefault$2(SvgIcon$2);
function createSvgIcon(path, displayName) {
  var Icon = function Icon(props) {
    return _react$2.default.createElement(_SvgIcon.default, props, path);
  };
  Icon.displayName = ("").concat(displayName, "Icon");
  Icon = (0, _pure.default)(Icon);
  Icon.muiName = 'SvgIcon';
  return Icon;
}
var _default$2 = createSvgIcon;
createSvgIcon$1.default = _default$2;
const require$$1$1 = _dll_react;
var _interopRequireDefault$1 = interopRequireDefault.exports;
Object.defineProperty(RemoveCircle, "__esModule", {
  value: true
});
var default_1$1 = RemoveCircle.default = void 0;
var _react$1 = _interopRequireDefault$1(require$$1$1);
var _createSvgIcon$1 = _interopRequireDefault$1(createSvgIcon$1);
var _default$1 = (0, _createSvgIcon$1.default)(_react$1.default.createElement(_react$1.default.Fragment, null, _react$1.default.createElement("path", {
  fill: "none",
  d: "M0 0h24v24H0z"
}), _react$1.default.createElement("path", {
  d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm5 11H7v-2h10v2z"
})), 'RemoveCircle');
default_1$1 = RemoveCircle.default = _default$1;
var AddCircle = {};
const require$$1 = _dll_react;
var _interopRequireDefault = interopRequireDefault.exports;
Object.defineProperty(AddCircle, "__esModule", {
  value: true
});
var default_1 = AddCircle.default = void 0;
var _react = _interopRequireDefault(require$$1);
var _createSvgIcon = _interopRequireDefault(createSvgIcon$1);
var _default = (0, _createSvgIcon.default)(_react.default.createElement(_react.default.Fragment, null, _react.default.createElement("path", {
  fill: "none",
  d: "M0 0h24v24H0z"
}), _react.default.createElement("path", {
  d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm5 11h-4v4h-2v-4H7v-2h4V7h2v4h4v2z"
})), 'AddCircle');
default_1 = AddCircle.default = _default;
const React$3 = _dll_react;
const PropTypes$2 = _dll_prop_types;
const _jsxFileName$2 = "/home/circleci/repo/packages/passage/configure/src/common.jsx";
const RemoveAddButton = ({classes, label, type = 'add', onClick}) => {
  const Tag = type === 'add' ? default_1 : default_1$1;
  return React$3.createElement(Button, {
    color: "primary",
    size: "small",
    className: classes.root,
    onClick: onClick,
    __self: undefined,
    __source: {
      fileName: _jsxFileName$2,
      lineNumber: 16
    }
  }, React$3.createElement(Tag, {
    fontSize: 'small',
    color: 'primary',
    className: classes.icon,
    __self: undefined,
    __source: {
      fileName: _jsxFileName$2,
      lineNumber: 17
    }
  }), label);
};
const PassageButton = styles$e.withStyles(theme => ({
  root: {
    textDecoration: 'underline',
    '&:hover': {
      textDecoration: 'underline',
      backgroundColor: 'transparent'
    }
  },
  label: {
    display: 'flex',
    alignItems: 'center'
  },
  icon: {
    marginRight: theme.spacing.unit / 2
  }
}))(RemoveAddButton);
const ConfimationDialog = ({content, cancel, title, ok, open, onOk, onCancel}) => React$3.createElement(Dialog, {
  open: open,
  __self: undefined,
  __source: {
    fileName: _jsxFileName$2,
    lineNumber: 41
  }
}, React$3.createElement(DialogTitle, {
  __self: undefined,
  __source: {
    fileName: _jsxFileName$2,
    lineNumber: 42
  }
}, title), React$3.createElement(DialogContent, {
  __self: undefined,
  __source: {
    fileName: _jsxFileName$2,
    lineNumber: 44
  }
}, React$3.createElement(DialogContentText, {
  __self: undefined,
  __source: {
    fileName: _jsxFileName$2,
    lineNumber: 45
  }
}, content)), React$3.createElement(DialogActions, {
  __self: undefined,
  __source: {
    fileName: _jsxFileName$2,
    lineNumber: 48
  }
}, onOk && React$3.createElement(Button, {
  onClick: onOk,
  color: "primary",
  __self: undefined,
  __source: {
    fileName: _jsxFileName$2,
    lineNumber: 50
  }
}, ok), onCancel && React$3.createElement(Button, {
  onClick: onCancel,
  color: "primary",
  __self: undefined,
  __source: {
    fileName: _jsxFileName$2,
    lineNumber: 55
  }
}, cancel)));
ConfimationDialog.propTypes = {
  content: PropTypes$2.string.isRequired,
  title: PropTypes$2.string.isRequired,
  cancel: PropTypes$2.string.isRequired,
  ok: PropTypes$2.string.isRequired,
  open: PropTypes$2.bool.isRequired,
  onCancel: PropTypes$2.func.isRequired,
  onOk: PropTypes$2.func.isRequired
};
const React$2 = _dll_react;
const PropTypes$1 = _dll_prop_types;
const {InputContainer: InputContainer} = _dll_pie_lib__pie_toolbox_config_ui;
const {EditableHtml: EditableHtml} = _dll_pie_lib__pie_toolbox_editable_html;
const {ALL_PLUGINS: ALL_PLUGINS} = _dll_pie_lib__pie_toolbox_editable_html;
const _jsxFileName$1 = "/home/circleci/repo/packages/passage/configure/src/passage.jsx";
function _optionalChain(ops) {
  let lastAccessLHS = undefined;
  let value = ops[0];
  let i = 1;
  while (i < ops.length) {
    const op = ops[i];
    const fn = ops[i + 1];
    i += 2;
    if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) {
      return undefined;
    }
    if (op === 'access' || op === 'optionalAccess') {
      lastAccessLHS = value;
      value = fn(value);
    } else if (op === 'call' || op === 'optionalCall') {
      value = fn((...args) => value.call(lastAccessLHS, ...args));
      lastAccessLHS = undefined;
    }
  }
  return value;
}
class PassageComponent extends React$2.Component {
  static __initStatic() {
    this.propTypes = {
      classes: PropTypes$1.object,
      onModelChanged: PropTypes$1.func.isRequired,
      model: PropTypes$1.object.isRequired,
      configuration: PropTypes$1.object.isRequired,
      imageSupport: PropTypes$1.object.isRequired,
      passageIndex: PropTypes$1.number.isRequired,
      uploadSoundSupport: PropTypes$1.object.isRequired
    };
  }
  static __initStatic2() {
    this.defaultProps = {
      passageIndex: 0
    };
  }
  constructor(props) {
    super(props);
    PassageComponent.prototype.__init.call(this);
  }
  __init() {
    this.handleChange = (fieldName, value) => {
      const {model, onModelChanged, passageIndex} = this.props;
      if (!model.passages || passageIndex < 0 || passageIndex >= model.passages.length) {
        return;
      }
      const updatedPassages = [...model.passages];
      updatedPassages[passageIndex] = {
        ...updatedPassages[passageIndex],
        [fieldName]: value
      };
      onModelChanged({
        ...model,
        passages: updatedPassages
      });
    };
  }
  render() {
    const {model, classes, configuration, imageSupport, passageIndex, uploadSoundSupport} = this.props;
    const {maxImageWidth = {}, maxImageHeight = {}, mathMlOptions = {}, baseInputConfiguration = {}, teacherInstructions = {}, title = {}, subtitle = {}, text = {}, author = {}} = configuration || ({});
    const {errors = {}, passages = [], teacherInstructionsEnabled, titleEnabled, subtitleEnabled, authorEnabled, textEnabled} = model || ({});
    const {passages: passagesErrors} = errors || ({});
    const {teacherInstructions: teacherInstructionsError, title: titleError, subtitle: subtitleError, author: authorError, text: textError} = passagesErrors && passagesErrors[passageIndex] || ({});
    const defaultImageMaxWidth = maxImageWidth && maxImageWidth.prompt;
    const defaultImageMaxHeight = maxImageHeight && maxImageHeight.prompt;
    const getPluginProps = customConfiguration => ({
      ...baseInputConfiguration,
      ...customConfiguration
    });
    return React$2.createElement(React$2.Fragment, {
      __self: this,
      __source: {
        fileName: _jsxFileName$1,
        lineNumber: 77
      }
    }, teacherInstructionsEnabled && React$2.createElement(InputContainer, {
      label: teacherInstructions.label,
      className: classes.inputContainer,
      __self: this,
      __source: {
        fileName: _jsxFileName$1,
        lineNumber: 79
      }
    }, React$2.createElement(EditableHtml, {
      activePlugins: ALL_PLUGINS,
      markup: passages[passageIndex].teacherInstructions || '',
      onChange: value => this.handleChange('teacherInstructions', value),
      nonEmpty: false,
      error: teacherInstructionsError,
      maxImageWidth: maxImageWidth && maxImageWidth.teacherInstructions || defaultImageMaxWidth,
      maxImageHeight: maxImageHeight && maxImageHeight.teacherInstructions || defaultImageMaxHeight,
      mathMlOptions: mathMlOptions,
      languageCharactersProps: [{
        language: 'spanish'
      }, {
        language: 'special'
      }],
      pluginProps: getPluginProps(_optionalChain([teacherInstructions, 'optionalAccess', _ => _.inputConfiguration])),
      __self: this,
      __source: {
        fileName: _jsxFileName$1,
        lineNumber: 80
      }
    }), teacherInstructionsError && React$2.createElement('div', {
      className: classes.errorText,
      __self: this,
      __source: {
        fileName: _jsxFileName$1,
        lineNumber: 92
      }
    }, teacherInstructionsError)), titleEnabled && React$2.createElement(InputContainer, {
      label: title.label,
      className: classes.inputContainer,
      __self: this,
      __source: {
        fileName: _jsxFileName$1,
        lineNumber: 97
      }
    }, React$2.createElement(EditableHtml, {
      activePlugins: ALL_PLUGINS,
      markup: passages[passageIndex].title || '',
      onChange: value => this.handleChange('title', value),
      nonEmpty: false,
      error: titleError,
      mathMlOptions: mathMlOptions,
      languageCharactersProps: [{
        language: 'spanish'
      }, {
        language: 'special'
      }],
      pluginProps: getPluginProps(_optionalChain([title, 'optionalAccess', _2 => _2.inputConfiguration])),
      __self: this,
      __source: {
        fileName: _jsxFileName$1,
        lineNumber: 98
      }
    }), titleError && React$2.createElement('div', {
      className: classes.errorText,
      __self: this,
      __source: {
        fileName: _jsxFileName$1,
        lineNumber: 108
      }
    }, titleError)), subtitleEnabled && React$2.createElement(InputContainer, {
      label: subtitle.label,
      className: classes.inputContainer,
      __self: this,
      __source: {
        fileName: _jsxFileName$1,
        lineNumber: 113
      }
    }, React$2.createElement(EditableHtml, {
      activePlugins: ALL_PLUGINS,
      markup: passages[passageIndex].subtitle || '',
      onChange: value => this.handleChange('subtitle', value),
      nonEmpty: false,
      error: subtitleError,
      mathMlOptions: mathMlOptions,
      languageCharactersProps: [{
        language: 'spanish'
      }, {
        language: 'special'
      }],
      pluginProps: getPluginProps(_optionalChain([subtitle, 'optionalAccess', _3 => _3.inputConfiguration])),
      __self: this,
      __source: {
        fileName: _jsxFileName$1,
        lineNumber: 114
      }
    }), subtitleError && React$2.createElement('div', {
      className: classes.errorText,
      __self: this,
      __source: {
        fileName: _jsxFileName$1,
        lineNumber: 124
      }
    }, subtitleError)), authorEnabled && React$2.createElement(InputContainer, {
      label: author.label,
      className: classes.inputContainer,
      __self: this,
      __source: {
        fileName: _jsxFileName$1,
        lineNumber: 129
      }
    }, React$2.createElement(EditableHtml, {
      activePlugins: ALL_PLUGINS,
      markup: passages[passageIndex].author || '',
      onChange: value => this.handleChange('author', value),
      nonEmpty: false,
      error: authorError,
      mathMlOptions: mathMlOptions,
      languageCharactersProps: [{
        language: 'spanish'
      }, {
        language: 'special'
      }],
      pluginProps: getPluginProps(_optionalChain([author, 'optionalAccess', _4 => _4.inputConfiguration])),
      __self: this,
      __source: {
        fileName: _jsxFileName$1,
        lineNumber: 130
      }
    }), authorError && React$2.createElement('div', {
      className: classes.errorText,
      __self: this,
      __source: {
        fileName: _jsxFileName$1,
        lineNumber: 140
      }
    }, authorError)), textEnabled && React$2.createElement(InputContainer, {
      label: text.label,
      className: classes.inputContainer,
      __self: this,
      __source: {
        fileName: _jsxFileName$1,
        lineNumber: 145
      }
    }, React$2.createElement(EditableHtml, {
      activePlugins: ALL_PLUGINS,
      markup: passages[passageIndex].text || '',
      onChange: value => this.handleChange('text', value),
      imageSupport: imageSupport,
      uploadSoundSupport: uploadSoundSupport,
      nonEmpty: false,
      error: textError,
      maxImageWidth: maxImageWidth && maxImageWidth.text || defaultImageMaxWidth,
      maxImageHeight: maxImageHeight && maxImageHeight.text || defaultImageMaxHeight,
      mathMlOptions: mathMlOptions,
      languageCharactersProps: [{
        language: 'spanish'
      }, {
        language: 'special'
      }],
      pluginProps: getPluginProps(_optionalChain([text, 'optionalAccess', _5 => _5.inputConfiguration])),
      __self: this,
      __source: {
        fileName: _jsxFileName$1,
        lineNumber: 146
      }
    }), textError && React$2.createElement('div', {
      className: classes.errorText,
      __self: this,
      __source: {
        fileName: _jsxFileName$1,
        lineNumber: 160
      }
    }, textError)));
  }
}
PassageComponent.__initStatic();
PassageComponent.__initStatic2();
var Passage = styles$e.withStyles(theme => ({
  inputContainer: {
    paddingTop: theme.spacing.unit * 2,
    marginBottom: theme.spacing.unit * 2,
    width: '100%'
  },
  errorText: {
    fontSize: theme.typography.fontSize - 2,
    color: theme.palette.error.main,
    paddingTop: theme.spacing.unit
  }
}))(PassageComponent);
const React$1 = _dll_react;
const PropTypes = _dll_prop_types;
const {settings: settings} = _dll_pie_lib__pie_toolbox_config_ui;
const {layout: layout} = _dll_pie_lib__pie_toolbox_config_ui;
const _jsxFileName = "/home/circleci/repo/packages/passage/configure/src/design.jsx";
const {Panel, toggle, dropdown} = settings;
class Main extends React$1.Component {
  static __initStatic() {
    this.propTypes = {
      onModelChanged: PropTypes.func.isRequired,
      onConfigurationChanged: PropTypes.func,
      model: PropTypes.object.isRequired,
      configuration: PropTypes.object.isRequired,
      imageSupport: PropTypes.object.isRequired,
      uploadSoundSupport: PropTypes.object.isRequired,
      classes: PropTypes.object.isRequired
    };
  }
  constructor(props) {
    super(props);
    Main.prototype.__init.call(this);
    Main.prototype.__init2.call(this);
    Main.prototype.__init3.call(this);
    Main.prototype.__init4.call(this);
    this.state = {
      showConfirmationDialog: false,
      indexToRemove: -1
    };
  }
  __init() {
    this.getInnerText = html => (html || '').replaceAll(/<[^>]*>/g, '');
  }
  __init2() {
    this.onDelete = (model, indexToRemove, onModelChanged) => {
      let updatedPassages = model.passages;
      updatedPassages.splice(indexToRemove, 1);
      onModelChanged({
        ...model,
        passages: updatedPassages
      });
      this.setState({
        showConfirmationDialog: false,
        indexToRemove: -1
      });
    };
  }
  __init3() {
    this.removeAdditionalPassage = indexToRemove => {
      const {model = {}, onModelChanged} = this.props;
      const {passages = []} = model;
      const {teacherInstructions = '', title = '', subtitle = '', author = '', text = ''} = passages[indexToRemove];
      if (this.getInnerText(teacherInstructions).trim() || this.getInnerText(title).trim() || this.getInnerText(subtitle).trim() || this.getInnerText(author).trim() || this.getInnerText(text).trim()) {
        this.setState({
          showConfirmationDialog: true,
          indexToRemove
        });
      } else {
        this.onDelete(model, indexToRemove, onModelChanged);
      }
    };
  }
  __init4() {
    this.addAdditionalPassage = () => {
      const {model, onModelChanged} = this.props;
      const updatedPassages = [...model.passages, {
        teacherInstructions: '',
        title: '',
        subtitle: '',
        author: '',
        text: ''
      }];
      onModelChanged({
        ...model,
        passages: updatedPassages
      });
    };
  }
  render() {
    const {classes, model, configuration, imageSupport, onConfigurationChanged, onModelChanged, uploadSoundSupport} = this.props;
    const {settingsPanelDisabled, language = {}, languageChoices = {}, teacherInstructions = {}, title = {}, subtitle = {}, text = {}, author = {}, additionalPassage = {}} = configuration || ({});
    const {extraCSSRules, passages} = model || ({});
    const panelSettings = {
      titleEnabled: title && title.settings && toggle(title.label),
      subtitleEnabled: subtitle && subtitle.settings && toggle(subtitle.label),
      authorEnabled: author && author.settings && toggle(author.label),
      textEnabled: text && text.settings && toggle(text.label),
      'additionalPassage.enabled': additionalPassage && additionalPassage.settings && toggle(additionalPassage.label, true)
    };
    const panelProperties = {
      teacherInstructionsEnabled: teacherInstructions && teacherInstructions.settings && toggle(teacherInstructions.label),
      'language.enabled': language && language.settings && toggle(language.label, true),
      language: language && language.settings && language.enabled && dropdown(languageChoices.label, languageChoices.options)
    };
    const confirmationDialogContent = `${additionalPassage.label} will be deleted`;
    const {indexToRemove, showConfirmationDialog} = this.state;
    return React$1.createElement(layout.ConfigLayout, {
      extraCSSRules: extraCSSRules,
      hideSettings: settingsPanelDisabled,
      settings: React$1.createElement(Panel, {
        model: model,
        configuration: configuration,
        onChangeModel: model => onModelChanged(model),
        onChangeConfiguration: config => onConfigurationChanged(config),
        groups: {
          Settings: panelSettings,
          Properties: panelProperties
        },
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 123
        }
      }),
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 119
      }
    }, passages.map((passage, passageIndex) => React$1.createElement(React$1.Fragment, {
      key: passageIndex,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 136
      }
    }, passageIndex > 0 && React$1.createElement(Typography, {
      variant: "h5",
      className: classes.additionalPassageHeading,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 138
      }
    }, additionalPassage.label), React$1.createElement(Passage, {
      imageSupport: imageSupport,
      uploadSoundSupport: uploadSoundSupport,
      model: model,
      configuration: configuration,
      passageIndex: passageIndex,
      onModelChanged: onModelChanged,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 142
      }
    }), passageIndex > 0 && additionalPassage.enabled && React$1.createElement(PassageButton, {
      type: 'remove',
      label: `Remove ${additionalPassage.label}`,
      onClick: () => this.removeAdditionalPassage(passageIndex),
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 151
      }
    }), passageIndex === 0 && additionalPassage.enabled && passages.length < 2 && React$1.createElement(PassageButton, {
      label: `Add ${additionalPassage.label}`,
      onClick: this.addAdditionalPassage,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 158
      }
    }))), React$1.createElement(ConfimationDialog, {
      open: showConfirmationDialog,
      title: 'Warning',
      content: confirmationDialogContent,
      cancel: 'Cancel',
      ok: 'Ok',
      onCancel: () => this.setState({
        showConfirmationDialog: false
      }),
      onOk: () => this.onDelete(model, indexToRemove, onModelChanged),
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 162
      }
    }));
  }
}
Main.__initStatic();
var Main$1 = styles$e.withStyles(theme => ({
  additionalPassageHeading: {
    paddingTop: theme.spacing.unit * 2,
    marginBottom: theme.spacing.unit * 2
  }
}))(Main);
var defaultValues = {
  model: {
    authorEnabled: true,
    passages: [{
      teacherInstructions: '',
      title: '',
      subtitle: '',
      author: '',
      text: ''
    }],
    subtitleEnabled: true,
    teacherInstructionsEnabled: true,
    textEnabled: true,
    titleEnabled: true
  },
  configuration: {
    baseInputConfiguration: {
      audio: {
        disabled: false
      },
      video: {
        disabled: false
      },
      image: {
        disabled: false
      },
      h3: {
        disabled: true
      },
      blockquote: {
        disabled: true
      },
      textAlign: {
        disabled: true
      },
      showParagraphs: {
        disabled: false
      },
      separateParagraphs: {
        disabled: true
      }
    },
    settingsPanelDisabled: false,
    title: {
      settings: true,
      label: 'Title',
      inputConfiguration: {
        audio: {
          disabled: true
        },
        video: {
          disabled: true
        },
        image: {
          disabled: true
        },
        textAlign: {
          disabled: false
        }
      },
      required: true
    },
    subtitle: {
      settings: true,
      label: 'Subtitle',
      inputConfiguration: {
        audio: {
          disabled: true
        },
        video: {
          disabled: true
        },
        image: {
          disabled: true
        },
        textAlign: {
          disabled: false
        }
      },
      required: false
    },
    author: {
      settings: true,
      label: 'Author',
      inputConfiguration: {
        audio: {
          disabled: true
        },
        video: {
          disabled: true
        },
        image: {
          disabled: true
        }
      },
      required: false
    },
    text: {
      settings: true,
      label: 'Text',
      inputConfiguration: {
        audio: {
          disabled: false
        },
        video: {
          disabled: false
        },
        image: {
          disabled: false
        },
        h3: {
          disabled: false
        },
        blockquote: {
          disabled: false
        },
        textAlign: {
          disabled: false
        }
      },
      required: true
    },
    teacherInstructions: {
      settings: true,
      label: 'Teacher Instructions',
      inputConfiguration: {
        audio: {
          disabled: false
        },
        video: {
          disabled: false
        },
        image: {
          disabled: false
        }
      },
      required: false
    },
    maxImageWidth: {
      teacherInstructions: 300,
      text: 300
    },
    maxImageHeight: {
      teacherInstructions: 300,
      text: 300
    },
    mathMlOptions: {
      mmlOutput: false,
      mmlEditing: false
    },
    language: {
      settings: false,
      label: 'Specify Language',
      enabled: false
    },
    languageChoices: {
      label: 'Language Choices',
      options: []
    },
    additionalPassage: {
      settings: true,
      label: 'Additional Passage',
      enabled: false
    }
  }
};
const React = _dll_react;
const ReactDOM = _dll_react_dom;
class PassageConfigure extends HTMLElement {
  static __initStatic() {
    this.createDefaultModel = (model = {}) => ({
      ...defaultValues.model,
      ...model
    });
  }
  constructor() {
    super();
    this._model = PassageConfigure.createDefaultModel();
    this._configuration = defaultValues.configuration;
  }
  set model(m) {
    this._model = PassageConfigure.createDefaultModel(m);
    this.render();
  }
  set configuration(c) {
    this._configuration = c;
    this.render();
  }
  connectedCallback() {
    this.render();
  }
  modelChanged(m) {
    this._model = m;
    this.dispatchEvent(new ModelUpdatedEvent_1(this._model), true);
    this.render();
  }
  onConfigurationChanged(c) {
    this._configuration = c;
    this.render();
  }
  insertImage(handler) {
    this.dispatchEvent(new InsertImageEvent_1(handler));
  }
  onDeleteImage(src, done) {
    this.dispatchEvent(new DeleteImageEvent_1(src, done));
  }
  insertSound(handler) {
    this.dispatchEvent(new InsertSoundEvent_1(handler));
  }
  onDeleteSound(src, done) {
    this.dispatchEvent(new DeleteSoundEvent_1(src, done));
  }
  render() {
    if (this._model) {
      const el = React.createElement(Main$1, {
        model: this._model,
        configuration: this._configuration,
        onModelChanged: this.modelChanged.bind(this),
        onConfigurationChanged: this.onConfigurationChanged.bind(this),
        imageSupport: {
          add: this.insertImage.bind(this),
          delete: this.onDeleteImage.bind(this)
        },
        uploadSoundSupport: {
          add: this.insertSound.bind(this),
          delete: this.onDeleteSound.bind(this)
        }
      });
      ReactDOM.render(el, this);
    }
  }
}
PassageConfigure.__initStatic();
export {PassageConfigure as default};
